C T.L.Gulyaeva...........................................July 2009
C Input files foF2 .br................................. 
C 
C Input: annual file stYR00.br for Correlation studies
C Include subprox & SOCO for Proxy fnF2 calculations
C include subdist for distance calculation
C
      PROGRAM CALCORF2
C---------------------------------------------------------------
C data for 24 UT=0,1,2,...23hUT daily
C Includes: YRMNDY,24foF2(UT)
C
C
C*********TEST
	CHARACTER*80 INFILE1,INFILE2,OUTFILE
	CHARACTER*4 AYEAR
	character*2 ayr,amn,byr,bmn,bdy,ST1,ST2,STS(8)
	character*1 n1,n10,NST(0:9),f1(0:23),f2(0:23)
C	+,NS
	+,CA1(31,0:23),CA2(31,0:23),CB1(31,0:23),CB2(31,0:23)
	dimension im(12),fin1(0:23),fin2(0:23),dat1f(999),dat2f(999)
	+,dat1x(999),dat2x(999),glats(8),glons(8)
	dimension fdat1(31,0:23),fdat2(31,0:23)
	     COMMON  /CONST/UMR
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA NST/'0','1','2','3','4','5','6','7','8','9'/
	data STS/'kk','wk','jj','dw','jr','mo','ld','rv'/
	data glats/35.7,45.4,33.5,-12.2,54.6,55.5,60.0,47.2/
	data glons/139.5,141.7,126.5,130.9,13.4,37.3,30.7,39.7/

C
	UMR=ATAN(1.0)*4./180.
	IRUN=0
Temp	yy0='98'
Temp	mn0='12'
c
	outfile='calcor2.txt'
	OPEN(110,FILE=outfile,access='APPEND')

c
      WRITE(*,'(\A\)') ' ENTER ST1, ST2 OF INPUT FILES='
      READ(*,'(A)') ST1,ST2
C
Temp      WRITE(*,'(\A\)') ' ENTER YEAR OF INPUT FILE='
Temp      READ(*,'(A)') AYEAR
	AYEAR='2000'  ! Temp
	write(*,*) ' YEAR=',AYEAR
	ayr=ayear(3:4)
	read(ayr,*) yr

CC CALCULATION OF DAY OF YEAR	(LDA)
	iyr=int(yr)
	if(int(yr/4.)*4.eq.iyr) THEN 
	im(2)=29
	ndnr=366
	                          ELSE
	IM(2)=28
	ndnr=365
	ENDIF

c
      WRITE(*,'(\A\)') ' ENTER MN OF INPUT FILE='
      READ(*,'(A)') AMN
	read(amn,*) xmn
	mn=int(xmn)
C
Temp      WRITE(*,'(\A\)') ' ENTER GLA1,GLO1 =' ! corr. calculation
Temp	      READ(*,*) gla1,glo1
Temp      WRITE(*,'(\A\)') ' ENTER GLA2,GLO2 =' ! corr. calculation
Temp	      READ(*,*) gla2,glo2
	do j=1,8
	if (sts(j).eq.st1) then
	gla1=glats(j)
	glo1=glons(j)
	endif
		if (sts(j).eq.st2) then
 	gla2=glats(j)
	glo2=glons(j)
	endif
	enddo
	call subdist2(gla1,glo1,gla2,glo2,dkm)     ! distance between 2 sites
C :
C
 2503 CONTINUE
C
rem	infile1='STYR00.BR'
	infile1='STYRf.BR'
	infile1(1:2)=ST1
	infile1(3:4)=AYR
	infile2=infile1
	infile2(1:2)=ST2
	write(*,109) st1,st2,ayear,amn,dkm
	write(110,109) st1,st2,ayear,amn,dkm
  109	FORMAT(1X,2(1X,A2),1X,A4,1X,A2,1X,F6.1)
C
C =====================================================
  178	continue
C
C Start INFILE:
C
		      OPEN(111,FILE=INFILE1)
	 OPEN(112,FILE=INFILE2)
c ***************************************************************
C	  Read 1st array:
	nn=0
   	do 80 ii=1,ndnr+31					             !!
	READ (111,107,END=81,ERR=2) byr,bmn,bdy,(fin1(k)
	+,f1(k),f2(k),k=0,23)      ! read line of fgrid data
  107	FORMAT(3A2,2X,24(F3.1,2A1))
	if (bmn.eq.amn) then  !<<<<<<<
	nn=nn+1
	do i=0,23
	fdat1(nn,i)=fin1(i)
	ca1(nn,i)=f1(i)
	ca2(nn,i)=f2(i)
	enddo
	endif
   80	continue
   81	close(unit=111)
C
C	  Read 2nd array:
	nn=0
   	do 82 ii=1,ndnr+31					             !!
	READ (112,107,END=83,ERR=2) byr,bmn,bdy,(fin2(k)
	+,f1(k),f2(k),k=0,23)      ! read line of fgrid data
	if (bmn.eq.amn) then  !<<<<<<<
	nn=nn+1
	do i=0,23
	fdat2(nn,i)=fin2(i)
	cb1(nn,i)=f1(i)
	cb2(nn,i)=f2(i)
	enddo
	endif
   82	continue
   83	close(unit=112)

D start pre-processing for corrcoef::
	icnt=0
   	do 88 idy=1,im(mn)					             !!
C
	do 87 iut=0,23
	if ((fdat1(idy,iut).eq.0.).or.(fdat2(idy,iut).eq.0.).or.
	+(ca1(idy,iut).eq.'*').or.(cb1(idy,iut).eq.'*')) goto 87
C
	icnt=icnt+1
	dat1f(icnt)=fdat1(idy,iut)
	dat2f(icnt)=fdat2(idy,iut)
C
C XHI-reduced result 
C Proxy foF2/XHIrae:
	ut=float(iut)
	hour=ut+glo1/15.
	if (hour.ge.24.) hour=hour-24.
	lday=ndoy(iyr,mn,idy) ! function to define day-of-year
	call SOCO(LDAY,HOUR,GLA1,GLO1,SUNDEC,XHI,SAX,SUX)
		call SOCO(LDAY,12.,GLA1,GLO1,SUNDEC,XHINON,SAX,SUX) !Temp=====
C	
	call subprox(xhi,xhinon,cxx) 
C
	dat1x(icnt)=dat1f(icnt)*cxx ! fnF2 -1
C
	call SOCO(LDAY,HOUR,GLA2,GLO2,SUNDEC,XHI,SAX,SUX)
		call SOCO(LDAY,12.,GLA2,GLO2,SUNDEC,XHINON,SAX,SUX) !Temp=====
C	
	call subprox(xhi,xhinon,cxx) 
C
	dat2x(icnt)=dat2f(icnt)*cxx ! fnF2 -2

  87	continue								 !!
C
  88	continue								 !!

	call corcoef(icnt,dat1f,dat2f,corff,sff)
	call corcoef(icnt,dat1x,dat2x,corxx,sxx)
C Output results :
	write(*,67) corff,corxx,sff,sxx,icnt
	write(110,67) corff,corxx,sff,sxx,icnt
   67	format(4(2X,F6.3),1X,I4)

	GOTO 33
C
c  183			write(*,*) ' month=',xmn
c	xmn=xmn+1.
c      imn=imn+1
c	xdy=1.
C --------------- 
	i10=mn/10
 	i1=mn-i10*10
	do i=0,9
	if (i1.eq.i) n1=nst(i)
	if (i10.eq.i) n10=nst(i)
	enddo
	amn(1:1)=n10
	amn(2:2)=n1
	if (mn.lt.13) goto 777 ! next month
C	 
c		close(unit=113)
 777  continue  				! >>> End output 

   9	continue
C
C 
	goto 33
    2 CONTINUE
      if (irun.eq.0) then
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34
      endif

   33	continue
	close(unit=110)
      write(*,*) infile1,infile2,outfile
      pause ' ' 
   34   STOP
       END

C***********************************************************
