C ===========================================================
	PROGRAM EXTDGEC1
C..............................................................Aug. 2016
C GECq = Median for -27 days; Forecast Furie GEC* based on 4 prec. days; 
C dGEC=(GEC-GECq)/GECq*100%; dGEC*=(GEC*-GECq)/GECq*100%
C                                                             ! Nov. 2011   
C   infile0, 1 ='d:\web\dat1\YY\moYRMN.txt'  
C   infile2='d:\web\graf\MA\ma155_2011XXXUT0000.SAO'
C   EXTRACT foF2 FROM DAILY-HOURLY FILE DPS SAO FILE, => infile2
c   EXTRACT 96 HOURLY "FOF2" from d:\web\dat1\YR\moyrmn.txt for 96 prec. hours => infile1
C               Send output results to d:\web\graf\dias\fof2-pred.txt files..= outfile1
C               Keep intermediate results in 'd:\web\graf\dias\fof2-96.txt' = outfile2
C   txt   fof2-pred.txt  fof2-96.txt     
c
      DIMENSION XF(0:96),IXF(4,0:96),XRES(0:23),IM(12)
C-     *,XX(15)
C-     +,dat(60)
     +,IXMD(28,3),rx(0:23),COEFA(74),COEFB(74),
     *FU1(24),FU2(24),FUA(5,24),FUB(5,24),
     *DA(5,0:23),IYMD(5,3) !4 prec_days+curr_day(5)
	+,XX(28,0:23)   ! 27 prec days for median,28-day for dGEC
C-      INTEGER*2 jyr,jmn,jdy,jyr_pre,jmn_pre,jdy_pre
      INTEGER med(0:23),IDG(0:23),ires(0:23)
      CHARACTER*120 infile0,infile1,outfile1,outfile2
	+,outfile3,outfile4
C-	+,infile2,timefile,txt        !Ljuba  timefile (  graf/UT_time)
C- 	CHARACTER*10 CCM
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*4 YEAR,TTT
C-	+,YEARbeg                       !Ljuba  YEARbeg -    
C-    CHARACTER*6 YYMMDD
C-	CHARACTER*13 dd1,CC1
C-	CHARACTER*3 DOY
C-	+,DOYpre,DOYbeg                      !Ljuba  DOYpre -  , DOYbeg -     
 	CHARACTER*2 AMN,DD1,DD2,AYR,ADY
C-	+,AUT
C-	+,DD3								!Ljuba   DD3 -      
     *,PYR_pre,PMN_pre                              
      COMMON /BL1/XX,MED,IDG
	COMMON /BLFUR/FUA,FUB        ! Coeff. Furie
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA COEFA/
     &.2588190, .5, .7071068, .8660254, .9659258,1.0,.9659258,.8660254
     &, .7071067, .5, .2588190, .0,-.2588191,-.5,-.7071068,-.8660254,
     &-.9659259,-1.0,-.9659258,-.8660253,-.7071066,-.5,-.2588189, .0
     &,.5,.8660254,1.0,.8660254,.5,.0,-.5,-.8660254,-1.0,-.8660253,-.5
     &,.0, .7071068, 1.0, .7071067, .0,-.7071068,-1.0,-.7071066, .0      
     &, .8660254, .8660254, .0,-.8660254,-.8660253, .0
     &,.9659258,.5,-.7071068,-.8660253,.2588192,1.0,.2588188,-.8660256
     &,-.7071065, .5, .9659257,.0,-.9659259,-.5, .7071072,.8660251
     &,-.2588196,-1.0,-.2588184, .8660257, .7071062,-.5,-.9659256, .0/
	DATA COEFB/
     &.9659258, .8660254, .7071068, .5, .2588190, .0,-.2588191,-.5
     &,-.7071068,-.8660254,-.9659259,-1.0,-.9659258,-.8660253,-.7071067
     &,-.5,-.2588189,.0, .2588192,.5,.7071069, .8660255, .9659259, 1.0     
     &,.8660254,.5,.0,-.5,-.8660254,-1.0,-.8660253,-.5,.0,.5,.8660255
     &,1.0, .7071068, .0,-.7071068,-1.0,-.7071067, .0, .7071069, 1.0
     &, .5,-.5,-1.0,-.5, .5, 1.0
     &, .2588190,-.8660254,-.7071067, .5, .9659258, .0,-.9659259,-.5
     &,.7071070,.8660252,-.2588194,-1.0,-.2588186,.8660257,.7071064,-.5
     &,-.9659257, .0, .9659260, .5,-.7071073,-.8660250, .2588198, 1.0/
C
C  Re-arrange coefficients for Ai, Bi:
	DO JCASE=1,5
	select case (jcase)
	case (1)
    	do i=1,24
    	fu1(i)=coefa(i)
	fu2(i)=coefb(i)
	enddo
	goto 6
	case (2)
    	do i=1,12 
      fu1(i)=coefa(i+24)
      fu1(i+12)=fu1(i)
	fu2(i)=coefb(i+24)
	fu2(i+12)=fu2(i)
	enddo
	goto 6
	case (3)
    	do i=1,8 
    	fu1(i)=coefa(i+36)
	fu1(i+8)=fu1(i)
	fu1(i+16)=fu1(i)
	fu2(i)=coefb(i+36)
	fu2(i+8)=fu2(i)
	fu2(i+16)=fu2(i)
	enddo
	goto 6
	case (4)
    	do i=1,6 
    	fu1(i)=coefa(i+44)
	fu1(i+6)=fu1(i)
	fu1(i+12)=fu1(i)
	fu1(i+18)=fu1(i)
	fu2(i)=coefb(i+44)
	fu2(i+6)=fu2(i)
	fu2(i+12)=fu2(i)
	fu2(i+18)=fu2(i)
	enddo
	goto 6
	case (5)
    	do i=1,24
    	fu1(i)=coefa(i+50)
	fu2(i)=coefb(i+50)
	enddo
	goto 6
	end select
C
    6		do nn=1,24
      FUA(jcase,nn)=fu1(nn)
	FUB(jcase,nn)=fu2(nn)
	enddo
	ENDDO
C Start:
C    
C
C read preceding 96 values: iyr,imn,idy,iut,GEC
C
C
c	 Next lines = specify path and name of Output file:
C
C
		CALL DATE_AND_TIME(DD,TT,ZZ)
C-       TTT(1:4)=TT(1:4)								 !Ljuba
	YEAR=DD(1:4)									 !Ljuba
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT !Tamara

C-       timefile='/var/www/izmiran/ionosphere/weather/graf/UT_time'
   50	FORMAT(A4,1x,A2,1x,A2,1x,A3,1x,A2,1x,A4,1x,A2,1x,A2,1x,A3,A10)
C+       OPEN(13,FILE=timefile,STATUS='OLD')
C+       read (13,50)YEAR,AMN,DD2,DOYpre,AUT,YEARbeg,PMN_pre,DD3,DOYbeg       !Ljuba YEAR ,,,,UT - , 
C+       close(unit=13)                                                       !Ljuba AYR ,,, -   
C	WRITE(*,*) 'Reading file UT_time: YEAR=',YEAR, ' AMN=', AMN,' DD2=', DD2,' DOYpre=', DOYpre, ' AUT=', AUT  
C	WRITE(*,*) ' YEARbeg=',YEARbeg, ' PMN_pre=', PMN_pre, ' DD3=', DD3, ' DOYbeg=',DOYbeg  

	write(*,*) ' Enter YEAR' 							!  Ljuba	 !Tamara
	read(*,*) YEAR								!  Ljuba	 !Tamara
            TTT(1:4)=YEAR                                                   !Ljuba   =YEAR     UT_time .
	AYR=YEAR(3:4)                                                         !  Ljuba
C-       AYR=YEARbeg(3:4)                                         ! Ljuba      =pyr_pre ?     UT_time .
       write(*,*) ' AYR=YEARbeg(3:4) = ', AYR
	pyr_pre=AYR ! prec_year
	read(ayr,*) ryr
	jyr=int(ryr)
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
	jmn=0		 ! ++
	if (jyr.eq.98) jmn=9
	if (jyr.eq.16) jmn=7
C
111	CONTINUE
      jmn=jmn+1
	if (jmn.gt.12) GOTO	112
Cpre	if ((jyr.eq.16).and.(jmn.gt.8)) GOTO	112 ! 2016
C! ++	call blet2(jmn,AMN)
C! ++	kdy1=1
C! ++	kdy2=im(jmn)
C! ++	call blet2(kdy1,DD1)
C! ++	call blet2(kdy2,DD2)
CREM      write(*,*) ' Enter MN, DY1,DY2:' 			       !  Ljuba	 !Tamara
CREM	read(*,*) AMN,DD1,DD2						!  Ljuba		 !Tamara
	call blet2(jmn,AMN)
	if (AMN.eq.'00') goto 112
crem	AMN=DD(5:6)							!Ljuba   =AMN     UT_time . 
crem      DD2=DD(7:8)		                         	!Ljuba   =DD2     UT_time . 
C	read(amn,*) rmn
C	jmn=int(rmn)
C
C	read(dd1,*) rdy1
C	kdy1=int(rdy1)      ! start day 
	kdy1=1				! start day 
C	read(dd2,*) rdy2
C	kdy2=int(rdy2)      ! current day 
	kdy2=im(jmn)      ! last day of month day 
	call blet2(kdy1,DD1)
	call blet2(kdy2,DD2)
C
C
C	write(*,*) ' Enter UT' 						!  Ljuba	  !Tamara
C	read(*,*) AUT	                                                 !  Ljuba !Tamara
C	AUT=TTT(1:2)			!  Ljuba   UT  =AUT     UT_time .								  
C      	read(aut,*) ut
C+ 	jut=int(ut)
       jut=0			!Furie prediction for current day UT=00,...,23
	ut=float(jut)

C
C preceding month:
	if (jmn.gt.1) then
	jmn_pre=jmn-1			 ! prec_mn
      jyr_pre=jyr
	PYR_pre=AYR
	else
	jmn_pre=12				 ! prec_mn
	jyr_pre=jyr-1			 ! prec_yr
	if (jyr_pre.lt.0) jyr_pre=100+jyr_pre ! 1998 or 1999
	call blet2(jyr_pre,PYR_pre)  ! prec_yr
	endif
	call blet2(jmn_pre,PMN_pre)   ! prec_mn
C
C?	CCM=YEAR
C?	CCM(5:5)=' '
C?	CCM(6:7)=AMN
C?	CCM(8:8)=' '
C
  134  CONTINUE
c
C
C	infile0='d:\web\dat1\YY\moYRMN.txt'   ! preceding mn      !Tamara
	infile0='d:\web\dat0\YY\eoYRMNj.txt'   ! preceding mn      !Tamara
	infile0(13:14)=pyr_pre										 !Tamara
 	infile0(18:19)=pyr_pre										 !Tamara
	infile0(20:21)=pmn_pre										 !Tamara
	 infile1=infile0  ! current mn
	infile1(13:14)=ayr										 !Tamara
 	infile1(18:19)=ayr										 !Tamara
	infile1(20:21)=amn										 !Tamara
	OUTFILE3='d:\web\dat0\YY\eoYRdgecj.txt' ! dGEC%*10, dGEC=(GEC-GECfurie)/GECfurie*100%
	OUTFILE3(13:14)=ayr
	OUTFILE3(18:19)=ayr
	OPEN(11,file=outfile3,access='APPEND')
		OUTFILE4='d:\web\dat0\YY\eoYRmed4j.txt' !
	OUTFILE4(13:14)=ayr
	OUTFILE4(18:19)=ayr
	OPEN(13,file=outfile4,access='APPEND')
C =======================================================
C-	infile0='/var/www/izmiran/ionosphere/weather/dat1/YY/moYRMN.txt'  
C	infile0(42:43)=pyr_pre	
C-       infile0(42:43)=YEARbeg(3:4)		! LIUBA 03-01-2013							 !YY
C 	infile0(47:48)=pyr_pre							 !YR
C-       infile0(47:48)=YEARbeg(3:4)	        ! LIUBA 03-01-2013
C-	infile0(49:50)=pmn_pre										 !MN
C-	 infile1=infile0  ! current mn
C-	infile1(42:43)=AYR										 !YY
C- 	infile1(47:48)=AYR										 !YR
C-	infile1(49:50)=amn	                                     !MN
	write(*,*) ' infile0=', infile0
C =======================================================
	DO 77 kdy=kdy1,kdy2
	call blet2(kdy,ADY)
CREM Avoid input of prec. month if current day >4
C Avoid input of prec. month if current day >27 For -27 days median
CREM	if (kdy2.gt.4) GOTO 130						 !!!
	if (kdy.gt.27) GOTO 130						 !!!
C =======================================================
C
  117	FORMAT(3I2,2X,24(F3.0,2X))		   
C
C  day-to-day input for prec mon
C
	nndy=im(jmn_pre)	  ! prec. mn
		OPEN(10,FILE=INFILE0)
	do ir=1,4
	read(10,89,err=3,end=116) txt ! 4 extra lines
	enddo
	DO jdy_pre=1,nndy  ! 
C	     DA(5,0:23) ! 4 prec_days+curr_day=5
	READ (10,117,ERR=3,END=116) iiy,iim,iid,(rx(k),k=0,23)
	 ixmd(28,1)=iiy
	ixmd(28,2)=iim
	ixmd(28,3)=iid
	do k=0,23
	XX(28,k)=rx(k)
	enddo
C move data up by 1 line
	do jj=1,27
	do j=1,3
	ixmd(jj,j)=ixmd(jj+1,j)
	enddo
	do k=0,23
	XX(jj,k)=XX(jj+1,k)
	enddo
	enddo
      ENDDO
  116	close(unit=10)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C input for current mn
  130	continue
C
		OPEN(10,FILE=INFILE1)
	do ir=1,4
	read(10,89,err=3,end=116) txt ! 4 extra lines
	enddo
	kk=0
	DO jdy=1,kdy  ! 
C	     DA(5,0:23) ! 4 prec_days+curr_day=5
	READ (10,117,ERR=3,END=118)  iiy,iim,iid,(rx(k),k=0,23)
	 ixmd(28,1)=iiy
	ixmd(28,2)=iim
	ixmd(28,3)=iid
	do k=0,23
	XX(28,k)=rx(k)
	enddo

	kk=kk+1
	if (kk.lt.kdy) then

C move data up by 1 line
	
	do jj=1,27
	do j=1,3
	ixmd(jj,j)=ixmd(jj+1,j)
	enddo
	do k=0,23
	XX(jj,k)=XX(jj+1,k)
	enddo
	enddo
	endif
  	ENDDO
  118	close(unit=10)
C+
C>>       call rmedian27(27) ! median for -27 prec. days	 =>MED(0:23)
C
C?	write(*,86) ayr,amn,ady,(med(k),k=0,23)
C?	write(13,86) ayr,amn,ady,(med(k),k=0,23)
C+	  Data for 4 prec. days + current day=5
C
      do nn=1,5
	iymd(nn,1)=ixmd(nn+23,1)
	iymd(nn,2)=ixmd(nn+23,2)
	iymd(nn,3)=ixmd(nn+23,3)
	do kk=0,23
	DA(nn,kk)=XX(nn+23,kk)
	enddo
	enddo
C re-arrange data for 96 prec. hours:
	kk=0
C
	 kut=jut
	jj1=1
	jjend=4
  123	IXF(1,kk)=iymd(jj1,1)
	IXF(2,kk)=iymd(jj1,2)
	IXF(3,kk)=iymd(jj1,3)
	IXF(4,kk)=kut
      XF(kk)=da(jj1,kut)
	kk=kk+1
	if (kk.gt.95) goto 124
	kut=kut+1
	if (kut.gt.23) then
	kut=0
	jj1=jj1+1
	if (jj1.gt.5) goto 124
	endif
	goto 123
C
 124	call subfur(xf,xres) ! Furie results for UT=00,...,23 on current day (28) =>xres
	DO kk=0,23
	IDG(KK)=NINT((XX(28,KK)-XRES(KK))/XRES(KK)*1000.)
	med(kk)=NINT(XRES(kk))
	ENDDO
	write(*,86) ayr,amn,ady,(med(k),k=0,23)
	write(13,86) ayr,amn,ady,(med(k),k=0,23)
	write(*,86) AYR,AMN,ADY,(idg(k),k=0,23)
	write(11,86) AYR,AMN,ADY,(idg(k),k=0,23)
   86	format(3A2,24(1X,I4))
C
  135	CONTINUE
C-      kdy=kdy2	 ! current day from GEC file
C
c ==========================================================
c
C   17	FORMAT(1X,A3)  ! Ljuba -  FORMAT(1X,'DOY='A3)

   19	format(A6)
   20	format(A13,A2,A1)
   21	format(A4)
   22	format(A2)
   23	format(15(F8.3))
   89	format(A120)
C
C
C
   1	continue
C ===================================
C
	xfof2=xres(jut)             ! xres(0)?
C new array ===============
C=	ixf(1,96)=jyr
C=	ixf(2,96)=jmn
C=	ixf(3,96)=jdy
C=	ixf(4,96)=jut
C=	xf(96)=xfof2
C Shift 96 values by 1 h up:
C=	do n=1,96
C=	do k=1,4
C=	ixf(k,n-1)=ixf(k,n)
C=	enddo
C=	xf(n-1)=xf(n)
C=	enddo
C-	call subfur(xf,xres)
C ========================================
   11	continue
C-  440 CLOSE (unit=11)
C Output of foF2-pred.txt
	OUTFILE1='d:\web\dat0\eoYR-pred.txt' !
	OUTFILE1(15:16)=AYR
C-       OUTFILE1='/var/www/izmiran/ionosphere/weather/graf/f/fof2-pred'  ! Liuba
	OPEN(12,FILE=OUTFILE1,access='APPEND')
	kut=jut
C-	kdy=jdy
	do kk=0,23
C-	kut=kut+1
C-	if (kut.gt.23) then
C-	kut=0
C-	kdy=kdy+1
C-	endif
	ires(kk)=nint(xres(kk))
	fpred=xres(kk)	  ! Check
	enddo
	write(*,86) ayr,amn,ady,(ires(k),k=0,23)
	write(12,86) ayr,amn,ady,(ires(k),k=0,23)
	close(unit=12)
   87	format(4(I2,1X),1X,F5.1)					!NEW
C Keep updated outfile2:
	outfile2='d:\web\dat0\eo-96.txt'
C       outfile2='/var/www/izmiran/ionosphere/weather/graf/f/fof2-96'
C+		OPEN(12,file=outfile2)
C+	do nn=1,96
C+	ifof2=nint(xf(nn-1))
C+	write(*,88) (IXF(k,nn-1),k=1,4),ifof2
C+	write(12,88) (IXF(k,nn-1),k=1,4),ifof2
C+	enddo
C+	    CLOSE (unit=12)
   77 continue                 ! go to the next day
   88	format(4(I2,1X),1X,I3)					!NEW
C End of  ===============
C Add output to graf/2011/mo11f.br including sout(*), mo11h.br ++++++++++++
C
	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
   2  	 CLOSE (unit=11)
	CLOSE (unit=13)
	IF (jmn.lt.12) GOTO 111
  112	pause ' '       ! Liuba 
	STOP            ! Liuba 
	END
C
C
C================================================================
      subroutine subfur(fdat,fres)
C.......................................................Nov. 2011
C Furie expansion of diurnal foF2 using 96 prec. values 
      dimension fdat(0:96),fres(0:23),
     *AI(5),BI(5),FUA(5,24),FUB(5,24)
	COMMON /BLFUR/FUA,FUB        ! Coeff. Furie for Ai, Bi
	PARAMETER (n=96,p=24.,pip=.2617994)
C
C Parameters:
c	PI=ATAN(1.0)*4.
c	P=24.
c	N=96
c	 pip=2*pi/p 
C
crem
C mean of 96 values:
	xav=0.
	do i=0,N-1
	xav=xav+fdat(i)
	enddo
	xav=xav/N
C
	do ii=1,5
	  ai(ii)=0.
	  bi(ii)=0.
	  DO nn=1,4  ! 4 times repeat coefs. for Ai and Bi
	     do j=1,24  ! set of coefficiens
	       nj=j-1+(nn-1)*24
	       xval=fdat(nj)
c
	       ai(ii)=ai(ii)+xval*fua(ii,j)
	       bi(ii)=bi(ii)+xval*fub(ii,j)
	     enddo
	  ENDDO
	  ai(ii)=ai(ii)*2./N
	  bi(ii)=bi(ii)*2./N
	enddo
C synthesis
		sum=xav
	do iut=0,23
	fres(iut)=xav
	do ii=1,5
	fres(iut)=fres(iut)+ai(ii)*fua(ii,iut+1)+
     *bi(ii)*fub(ii,iut+1)
	 enddo
	enddo
  101	CONTINUE
crem	close (unit=15)
	RETURN
	end

C ===============================================================
