C ===========================================================
	PROGRAM EXTGEC24
C                                                             ! Dec. 2011   
C
C   EXTRACT GEC FROM DAILY-HOURLY FILE  => infile2
c   EXTRACT 24 HOURLY "GEC" from d:\web\dat0\YR\ghyrmn.txt for 24 prec. hours => infile1
C   Send output results to d:\dat0\yr\gyrmn24.txt-q-model.= > outfile1
C   Send dlogGEC= log10(gec/GECm)*1000 => outfile2
c
      DIMENSION XF(0:24),IXF(4,0:24),XRES(0:24),IM(12)
	+,IYMD(5,3),rx(0:24),COEFA(74),COEFB(74),IRES(0:24)
	+,FU1(24),FU2(24),FUA(5,24),FUB(5,24)
	+,DA(5,0:24) ! 4 prec_days+curr_day=5
      INTEGER*2 jyr,jmn,jdy,jyr_pre,jmn_pre,jdy_pre,kdy2,idy1,idy2
      CHARACTER*128 infile0,infile1,outfile1,outfile2,txt
 	CHARACTER*10 CCM
		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*4 YEAR,TTT
c-	CHARACTER*3 DOY
 	CHARACTER*2 ST,AMN,DD1,DD2,AYR,ADY,AUT
	+,PYR_pre,PMN_pre
	COMMON /BLFUR/FUA,FUB        ! Coeff. Furie
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA COEFA/
     &.2588190, .5, .7071068, .8660254, .9659258,1.0,.9659258,.8660254
     &, .7071067, .5, .2588190, .0,-.2588191,-.5,-.7071068,-.8660254,
     &-.9659259,-1.0,-.9659258,-.8660253,-.7071066,-.5,-.2588189, .0
     &,.5,.8660254,1.0,.8660254,.5,.0,-.5,-.8660254,-1.0,-.8660253,-.5
     &,.0, .7071068, 1.0, .7071067, .0,-.7071068,-1.0,-.7071066, .0      
     &, .8660254, .8660254, .0,-.8660254,-.8660253, .0
     &,.9659258,.5,-.7071068,-.8660253,.2588192,1.0,.2588188,-.8660256
     &,-.7071065, .5, .9659257,.0,-.9659259,-.5, .7071072,.8660251
     &,-.2588196,-1.0,-.2588184, .8660257, .7071062,-.5,-.9659256, .0/
	DATA COEFB/
     &.9659258, .8660254, .7071068, .5, .2588190, .0,-.2588191,-.5
     &,-.7071068,-.8660254,-.9659259,-1.0,-.9659258,-.8660253,-.7071067
     &,-.5,-.2588189,.0, .2588192,.5,.7071069, .8660255, .9659259, 1.0     
     &,.8660254,.5,.0,-.5,-.8660254,-1.0,-.8660253,-.5,.0,.5,.8660255
     &,1.0, .7071068, .0,-.7071068,-1.0,-.7071067, .0, .7071069, 1.0
     &, .5,-.5,-1.0,-.5, .5, 1.0
     &, .2588190,-.8660254,-.7071067, .5, .9659258, .0,-.9659259,-.5
     &,.7071070,.8660252,-.2588194,-1.0,-.2588186,.8660257,.7071064,-.5
     &,-.9659257, .0, .9659260, .5,-.7071073,-.8660250, .2588198, 1.0/
C
C  Re-arrange coefficients for Ai, Bi:
	DO JCASE=1,5
	select case (jcase)
	case (1)
    	do i=1,24
    	fu1(i)=coefa(i)
	fu2(i)=coefb(i)
	enddo
	goto 6
	case (2)
    	do i=1,12 
      fu1(i)=coefa(i+24)
      fu1(i+12)=fu1(i)
	fu2(i)=coefb(i+24)
	fu2(i+12)=fu2(i)
	enddo
	goto 6
	case (3)
    	do i=1,8 
    	fu1(i)=coefa(i+36)
	fu1(i+8)=fu1(i)
	fu1(i+16)=fu1(i)
	fu2(i)=coefb(i+36)
	fu2(i+8)=fu2(i)
	fu2(i+16)=fu2(i)
	enddo
	goto 6
	case (4)
    	do i=1,6 
    	fu1(i)=coefa(i+44)
	fu1(i+6)=fu1(i)
	fu1(i+12)=fu1(i)
	fu1(i+18)=fu1(i)
	fu2(i)=coefb(i+44)
	fu2(i+6)=fu2(i)
	fu2(i+12)=fu2(i)
	fu2(i+18)=fu2(i)
	enddo
	goto 6
	case (5)
    	do i=1,24
    	fu1(i)=coefa(i+50)
	fu2(i)=coefb(i+50)
	enddo
	goto 6
	end select
C
    6		do nn=1,24
      FUA(jcase,nn)=fu1(nn)
	FUB(jcase,nn)=fu2(nn)
	enddo
	ENDDO
C Start:
C    
	st='gh'		! temp
Ctemp	st='gp'		! temp

C
C read preceding 24 values: iyr,imn,idy,iut,fof2
C
C
c	 Next lines = specify path and name of Output file:
C
C
		CALL DATE_AND_TIME(DD,TT,ZZ)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT 
	write(*,*) ' Enter YEAR' 								 
	read(*,*) YEAR											 
            TTT(1:4)=YEAR  
	AYR=YEAR(3:4)
	pyr_pre=AYR ! prec_year
	read(ayr,*) ryr
	jyr=int(ryr)
C
	write(*,*) ' Enter MN, DY1,DY2:' 				
	read(*,*) AMN,DD1,DD2							
	read(amn,*) rmn
	jmn=int(rmn)
C
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
C
C preceding month:
	if (jmn.gt.1) then
	jmn_pre=jmn-1			 ! prec_mn
      jyr_pre=jyr
	PYR_pre=AYR
	else
	jmn_pre=12				 ! prec_mn
	jyr_pre=jyr-1			 ! prec_yr
	if (jyr_pre.lt.0) jyr_pre=100+jyr_pre ! 1998 or 1999
	call blet2(jyr_pre,PYR_pre)  ! prec_yr
	endif
	call blet2(jmn_pre,PMN_pre)   ! prec_mn
C
	CCM=YEAR
	CCM(5:5)=' '
	CCM(6:7)=AMN
	CCM(8:8)=' '
C
	read(dd1,*) rdy1
	 idy1=int(rdy1)      
	read(dd2,*) rdy2
	 idy2=int(rdy2)      
C
  134  CONTINUE
c
C
	infile0='d:\web\dat0\YY\ghYRMN.txt'   ! preceding mn     
	infile0(13:14)=pyr_pre									
 	infile0(18:19)=pyr_pre									
	infile0(20:21)=pmn_pre									
C Check file gh or gp:
	write(*,*) pmn_pre,infile0
	write(*,*) ' enter 0/1 for gh/gp:'
	read(*,*) ihp
	if (ihp.eq.1) infile0(17:17)='p'
C end check
	 infile1=infile0  ! current mn
	infile1(13:14)=ayr										
 	infile1(18:19)=ayr										
	infile1(20:21)=amn		
C Check file gh or gp:
	write(*,*) amn,infile1
	write(*,*) ' enter 0/1 for gh/gp:'
	read(*,*) ihp
	if (ihp.eq.1) infile1(17:17)='p'
C end check
	outfile1=infile1
	outfile1(22:)='m.txt'
	outfile2=outfile1
	outfile2(22:)='d.txt'							
		OPEN(12,FILE=OUTFILE1,access='APPEND')
	OPEN(13,FILE=OUTFILE2,access='APPEND')
C =======================================================
C   Day-to=day cycle
  55	DO 77 kdy2=idy1,idy2
	call blet2(kdy2,ADY)
c---	kdy2      ! current day 
C
	aut='00'
      	read(aut,*) ut
 	jut=int(ut)
C
C Avoid input of prec. month if current day >4
	if (kdy2.gt.4) GOTO 130						 !!!
C =======================================================
C
  117	FORMAT(3I2,1X,25(F4.0,1X))		   
C
C  day-to-day input for prec mon
C
	nndy=im(jmn_pre)	  ! prec. mn
C
C
		OPEN(10,FILE=INFILE0)
	do ir=1,4
	read(10,89,err=3,end=116) txt ! 4 extra lines
	enddo
	DO jdy_pre=1,nndy  ! 
C	     DA(5,0:23) ! 4 prec_days+curr_day=5
	READ (10,117,ERR=3,END=116) iiy,iim,iid,(rx(k),k=0,24)
	 iymd(5,1)=iiy
	iymd(5,2)=iim
	iymd(5,3)=iid
	do k=0,24
	da(5,k)=rx(k)
	enddo
C move data up by 1 line
	do jj=1,4
	do j=1,3
	iymd(jj,j)=iymd(jj+1,j)
	enddo
	do k=0,24
	da(jj,k)=da(jj+1,k)
	enddo
	enddo
      ENDDO
  116	close(unit=10)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C input for current mn
  130	continue
C
C
C
		OPEN(10,FILE=INFILE1)
	do ir=1,4
	read(10,89,err=3,end=116) txt ! 4 extra lines
      if (kdy2.eq.1) then
	write(12,89) txt
	write(13,89) txt
	endif
	enddo
	kk=0
	DO jdy=1,kdy2  ! 
C	     DA(5,0:23) ! 4 prec_days+curr_day=5
	READ (10,117,ERR=3,END=118)  iiy,iim,iid,(rx(k),k=0,24)
	 iymd(5,1)=iiy
	iymd(5,2)=iim
	iymd(5,3)=iid
	do k=0,24
	da(5,k)=rx(k)
	enddo

	kk=kk+1
	if (kk.lt.kdy2) then

C move data up by 1 line
	
	do jj=1,4
	do j=1,3
	iymd(jj,j)=iymd(jj+1,j)
	enddo
	do k=0,24
	da(jj,k)=da(jj+1,k)
	enddo
	enddo
	endif
  	ENDDO
  118	close(unit=10)
C
C re-arrange data for 24 prec. hours:
	kk=0
C
	 kut=jut
c-	jj1=1
	jj1=4
	jjend=4

  123	IXF(1,kk)=iymd(jj1,1)
	IXF(2,kk)=iymd(jj1,2)
	IXF(3,kk)=iymd(jj1,3)
	IXF(4,kk)=kut
      XF(kk)=da(jj1,kut)
	kk=kk+1
c-	if (kk.gt.95) goto 124
	if (kk.gt.23) goto 124
	kut=kut+1
	if (kut.gt.23) then
	kut=0
	jj1=jj1+1
c-	if (jj1.gt.5) goto 124
	if (jj1.gt.4) goto 124
	endif
	goto 123
C
 124	call subfur24(xf,xres)
	xres(24)=xres(0)
C
  135	kdy=kdy2	 ! current day 
C
c-	ADY=DD2
C
c-	read(ady,*) rdy
c-	jdy=int(rdy)

C Calculate day-of-year:
c-	lday=ndoy(jyr,jmn,jdy) ! function to define day-of-year
c-	call blet3(lday,DOY)

c-	write(*,17) doy
C
C
C ==========================================================
c
   17	FORMAT(1X,'DOY='A3)
   19	format(A6)
   20	format(A13,A2,A1)
   21	format(A4)
   22	format(A2)
   23	format(15(F8.3))
   89	format(A128)
C
C
   1	continue
C ===================================
C Output of 'quiet' subfur results for current day++++++++++++++++++++++
   87	format(3A2,25(1X,I4))					!NEW
	do k=0,24
	ires(k)=nint(xres(k))
	enddo
	write(12,87) ayr,amn,ady,(ires(k),k=0,24)
	write(*,87) ayr,amn,ady,(ires(k),k=0,24)
C
C  Output  deltaGEC,%
	do k=0,24
crem	xres(k)=alog10(da(5,k)/xres(k)*1000.) !dlogGEC
      xres(k)=(da(5,k)-xres(k))/xres(k)*100. !deltaGEC,%
	ires(k)=nint(xres(k))
	enddo
	write(13,87) ayr,amn,ady,(ires(k),k=0,24)
	write(*,87) ayr,amn,ady,(ires(k),k=0,24)

C ========================================
   11	continue

   77 continue                 ! go to the next day
C
	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
   2      CLOSE (unit=11)
	 CLOSE (unit=12)
	 CLOSE (unit=13)
	pause ' '
	STOP
	END
C
      subroutine blet2(ilet,alet2)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	INTEGER*2 ilet
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*2 alet2
CLjuba	a2='00'
	alet2='00'             !
	j10=ilet/10
	j1=ilet-j10*10
    5	do i=0,9
	if (j10.eq.i) then
	alet2(1:1)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet2(2:2)=IN(i)
	endif
	enddo 
	return
	end
C
C
      subroutine blet3(ilet,alet3)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*3 alet3
	a3='000'
C
	j100=ilet/100
	      j10=(ilet-j100*100)/10
	j1=ilet-j100*100-j10*10
    3	do i=0,9
		if (j100.eq.i) then
	alet3(1:1)=IN(i)
	endif
	enddo
    5	do i=0,9
	if (j10.eq.i) then
	alet3(2:2)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet3(3:3)=IN(i)
	endif
	enddo 
	return
	end
C
C ===============================================================
      integer function ndoy(iyr,imn,idy)
C
	       DIMENSION IM(12)
	integer*2 iyr,imn,idy
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	z1=iyr/4.0
      jz1=int(z1)*4
      IF(jz1.EQ.iyr) THEN
               IM(2)=29
        ELSE
                IM(2)=28
	       ENDIF
C Day-of-year LDA1
		mosum=0
      if(imn.gt.1) then
         do 1234 i=1,imn-1
1234    mosum=mosum+im(i)
         endif
      ndoy=mosum+idy	
	END FUNCTION
C ===============================================================
