C ===========================================================
	PROGRAM EXTGECMN
C                                                             ! June 2012   
C
C   EXTRACT Monthly-mean GEC, reduced to F10.7=100 FROM 
C   Input <d:\web\dat0\ehYRMN.txt> FILE  => infile
C
C   Output
C   (1) GEC_1: monthly-mean, (2) GEC_2: Wp<4.0 (quiet), (3) GEC_3: Wp >=4.0 (storm)
c
      DIMENSION IM(12),RX(0:23),RES(12),fs(366),wp(366,0:23),XX(0:23)
	+,fmn(12)
      INTEGER*2 jyr,jmn,jdy
      CHARACTER*128 infile,outfile,infilerz,infilewp,txt
		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*4 AYEAR
 	CHARACTER*2 AMN,AYR,CYR,CMN
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C Start:
C
		CALL DATE_AND_TIME(DD,TT,ZZ)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT 
	write(*,*) ' Enter YEAR' 								 
	read(*,*) AYEAR											 
	AYR=AYEAR(3:4)
	read(ayr,*) ryr
	jyr=int(ryr)
C
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	ndnr=366
	                          ELSE
	IM(2)=28
	ndnr=365
	ENDIF
crem	write(*,*) ' Enter MN:' 				
crem	read(*,*) AMN							
crem	read(amn,*) rmn


	outfile='gecmon.txt'
		OPEN(12,FILE=OUTFILE,access='APPEND')
	write(12,107) AYEAR
	write(*,107) AYEAR
  101	FORMAT(A128)
  102	FORMAT(1X,F6.1)
  107	FORMAT(1X,A4)
  108	FORMAT(1X,A2,I2,3X,F5.1)
  109	FORMAT(6X,24(1X,F4.1))
C
C Input F10.7 for YEAR
C
	infilerz='aprzyr.inp'
	OPEN(11,FILE=INFILERZ)
C
	do j=1,12
	fmn(j)=0.
	enddo
C
	do 91 k=1,ndnr
   92	read(11,108,ERR=3,END=93)  cyr,imn,f108
	if (cyr.ne.ayr) goto 92
	fmn(imn)=fmn(imn)+f108    ! Monthly mean F10.8
	fs(k)=f108/100.
   91	continue
   93	close(unit=11)
C
C  F10.7 monthly mean:
c//	do j=1,12
c//	fav=fmn(j)/im(j)
c//	write(*,102) fav
c//	write(12,102) fav
c//	enddo
c//	goto 2 ! Temporary
C

C Input Wp for YEAR
C
	infilewp='wptecYR.txt'
	infilewp(6:7)=ayr										
	OPEN(11,FILE=INFILEWP)
C
	do 94 n=1,ndnr
   	read(11,109,ERR=3,END=95)  (xx(k),k=0,23)
	do k=0,23
	wp(n,k)=xx(k)
	enddo
   94	continue
   95	close(unit=11)
C
	infile='d:\web\dat0\YR\ehYRMN.txt'
	infile(13:14)=ayr
	infile(18:19)=ayr
C
C Input GEC
C
	DO 1 JMN=1,12
	call blet2(jmn,AMN)
	infile(20:21)=amn
C
		OPEN(10,FILE=INFILE)
	do k=1,4
	read(10,101,ERR=3,END=96) txt ! extra lines
	enddo
   96	continue
C
  134  CONTINUE
c
C
C =======================================================
  117	FORMAT(2A2,I2,24(1X,F4.2))		   
	kk=0
	sum=0.
C   Day-to=day cycle
	hrsmon=im(jmn)*24.
	idyend=im(jmn)
	jcnt=0
  55	DO 77 jdy=1,idyend
	lda=ndoy(jyr,jmn,jdy)
c//	call blet2(jdy,ADY)
C
C input for current mn
C
  130	continue
C
	READ (10,117,ERR=3,END=118)  cyr,cmn,iid,(rx(k),k=0,23)

c//	if ((cyr.eq.ayr).and.(cmn.eq.amn)) then
c//	goto 131
c//	else
c//	goto 130
c//	endif
  131	do k=0,23
C++ GEC reduced to F10.7=100
	rx(k)=rx(k)/fs(lda)
ctemp	if (wp(lda,k).lt.4.0) then  ! select Wp-quiet
	if (wp(lda,k).ge.4.0) then  ! select Wp-disturbed
	sum=sum+rx(k)
	kk=kk+1
	endif
	enddo
c//	fmn(jmn)=fmn(jmn)+sum    ! Monthly mean GEC
  77	CONTINUE			 ! End of current mn
  118	close(unit=10)
	if (kk.gt.0) res(jmn)=sum/kk
C
C
   1	continue
C ===================================
C Output 
   87	format(12(1X,F7.2))
	write(12,87) res
	write(*,87) res
C

C ========================================
   11	continue

C
	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
   2      CLOSE (unit=12)
	pause ' '
	STOP
	END
C
C ===============================================================
