C ===========================================================
	PROGRAM FITGECRP1
C                     
C Count mean Rzp ( proxy)                                         ! June 2013   
C
C   Occurrence of daily-mean Rzp, for 12 months @ 40 grids for Rzp=1,2,...,40 (Rzp>40 joint to Rzp=40) 
C   Input 
C         <fitgecmp.txt> => infilerz
C
C   Output
C   (1) outfile: FITgecmh.txt = infilerz+gecfit(Rzi) 
c
      DIMENSION IM(12),icnt(12,40)
      INTEGER*2 jyr,jmn,jdy
	INTEGER*4 iyyyy
      CHARACTER*128 outfile,infilerz
		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
 	CHARACTER*2 AYR,AMN,ADY
	CHARACTER*4 AYEAR
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C Start:
	outfile='fitgecmp1.txt'
		OPEN(12,FILE=OUTFILE)	 ! 
C
		CALL DATE_AND_TIME(DD,TT,ZZ)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT 
C
   80	format(1X,I4)
C

C  Read Rz, Rzi and GECi lines :
	infilerz='fitgecp1.txt'
	OPEN(11,FILE=INFILERZ)
C
  120	read(11,80,end=73) iyear
C
CREM	if (iyear.lt.1999) then
	if (iyear.lt.2013) then  !Temp for 2013
	goto 120
	else
	backspace(11)
	endif

	do i=1,12
	do k=1,40
	icnt(i,k)=0
	enddo
	enddo
C Cycle on year-to-year 1849-2012:
CTEMP       DO 71 iyyyy=1999,2012
C
	iyyyy=2013				 !Temp for 2013
	ryr=float(iyyyy)
	if(int(ryr/4.)*4.eq.iyyyy) THEN 
 	im(2)=29
	ndnr=366
	                          ELSE
	IM(2)=28
	ndnr=365
	ENDIF

C cycle on month-to-month
CREM	DO kmn=1,12
	DO kmn=1,5			   	 !Temp for 2013
	nmax=im(kmn) 
C day-to-day cycle
   81 format(1X,A4,2A2,1X,I3,1X,I3)
   82 format(1X,A4,2A2,1X,I3,1X,I3)
c-	res1(kmn)=0.
c-	res2(kmn)=0.
	do kdy=1,nmax
C read Rzi
	read(11,82,end=73) ayear,amn,ady,ir,irzp ! read Ri, Rzi
	ayr=ayear(3:4)
	read(ayr,*) xyr
	jyr=int(xyr)
	read(amn,*) xmn
	jmn=int(xmn)
	read(ady,*) xdy
	jdy=int(xdy)
c-	rzi=float(irzi)
	if (irzp.gt.40) irzp=40
	rzi=float(irzp)
C Day-of-year:
	lda=ndoy(jyr,jmn,jdy) 
	days=float(lda)/ndnr*360. ! Day-of-year scaled to 360.
C 12 monthly coefficients refers to 1:360 days:
C days=15,45,75,105,135,165,195,225,255,285,315,345
C month 1  2  3  4   5   6   7   8   9   10  11  12
	ymon=0.5+days/30.
	call subgecrp(ymon,rzi,geci)

c--	icnt(jmn,irzp)=icnt(jmn,irzp)+1
	write(*,83)	ayear,amn,ady,ir,irzp,geci 
	write(12,83) ayear,amn,ady,ir,irzp,geci 
	enddo     ! end daily cycle

	ENDDO			 ! end monthly cycle

   71	CONTINUE ! END year-to-year cycle
   73	close(unit=11)
C
   83 format(1X,A4,2A2,1X,I3,1X,I3,1X,F6.3)
C ========================================
C
	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
   2      CLOSE (unit=12)
	pause ' '
	STOP
	END
C
C ===============================================================
