CC.......................................................Nov. 2015
C Average TEC(glat) over sea/land by number of cells 
C Produce TEC & TEC-monthly-UT from JPL GIM-TEC maps
C Produce TEC-monthly-Glat from JPL GIM_TEC	(for UT=0,1,...,23 h UT)
C in geogr. coordinates glats=-87.5:2.5:87.5, glongs:0:5:360: d:/web/des/etMNDYUT.jYR
C 
C
C JPL hourly results
C
C Input: TEC
C
C T.L.Gulyaeva...........................................
C 
      PROGRAM GLATTEC9Z
C----------------------------------------------------------------
C Select all latitudes: res1=-87.5N,-85N,,,,-5N,00,5,...,87.5 
C                        
C each line in input file for TEC at:[-180, -165,...0,15E,30E,...,165E]
C separate files for UT=0,1,2,3,...23hUT
C Produce GYRMNDY.res files 	 (UT GEC)
C output array: res(72)
C program for EXTRACTING FROM "uhrgdoy0.iYR" ionex_TEC data 
C Output: GYRMNDY.res data for day into annual file gecyr.br
C all results for given year, includint YRMNDY  GEC(t), t=0,1,...,23 UT + daily mean, GEC(t)=GEC/1.E+32, GECU
C outfile='gecyr.br' 
C if input file jplg (2h UT step), linear interpolation is applied for 1h UT results
C
C*********TEST
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*80 INFILE,OUTFILE,OUTFILE2
	+,OUTFILE1,OUTFILE0  ! Sea=>outfile0, land=>outfile1
C=	+,infglat,infglon
	CHARACTER*4 AYEAR
	CHARACTER*131 txt
	character*2 ayr,amn,dy1,ady,aut,dy2
	logical sout  ! true~sea, false ~ land
c-	character*3 aday
	integer*2 idy,iyr,imn,iut,ndays
	dimension itxx(0:72),im(12),itxx0(0:72),rtav(72)
C/	+,gecoef(71)
C/     +,iamp(0:7)
C-     +,vec(0:72),ivec(0:72)
	dimension res(72),rgec(71),igec(71),iroc(71)
c     +,pgec(0:24) ! prec.day
	+,res1(72),res0(72),rgec1(71),rgec0(71)
     +,igec1(71),igec0(71)
C=	+,glat(71,0:72),glon(71,0:72)
	     COMMON  /CONST/UMR
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C	! 87.5,85,...,2.5,0
C
c	comp='          '

	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT

C Read geogr. coords. for magn. grids:
C
C+	infglat='glatgrid1.txt'
C+	infglon='glongrid1.txt'
C+			OPEN(15,FILE=infglat,ACTION='READ')
C+	OPEN(16,FILE=infglon,ACTION='READ')
C+	DO ilat=1,71
C+	read(15,117,end=115) (glat(ilat,k),k=0,72)
C+	read(16,117,end=116) (glon(ilat,k),k=0,72)
C+	ENDDO
C+  115	close(unit=15)
C+  116	close(unit=16)
C
118	format(A4)
C+117	format(73(1X,F5.1))
c	pause  ' '
333	WRITE(*,'(\A\)') ' ENTER YEAR OF INPUT FILE='
      READ(*,'(A)') AYEAR
	ayr=ayear(3:4)
	read(ayr,*) ryr 
      iyr=int(ryr)
	read(ayear,*) year
C
	iiyr=int(year)
 	if(int(year/4.)*4.eq.iiyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF

c outfiles =================================
       outfile2='teglatYR.txt' ! TEC-global, sea, land monthly
	outfile='tgeoYR.txt'
      outfile(5:6)=ayr
	outfile2(7:8)=ayr
	outfile1=outfile	 
	outfile0=outfile
	outfile1(10:10)='1'	   ! Land
	outfile0(10:10)='0'	   ! Sea
      		OPEN(12,FILE=OUTFILE,ACCESS='APPEND')
			OPEN(11,FILE=OUTFILE1,ACCESS='APPEND')
			OPEN(10,FILE=OUTFILE0,ACCESS='APPEND')
	OPEN(13,FILE=OUTFILE2,ACCESS='APPEND')
	imn=1
	if (iyr.eq.98.) imn=9
C=	amn='01'
1	IRUN=0
	call blet2(imn,amn)
c-      WRITE(*,'(\A\)') ' ENTER MN OF INPUT FILE='
c-      READ(*,'(A)') AMN
c-	read(amn,*) xmn
CREM         WRITE(*,'(\A\)') ' ENTER <DY1>,<DY2> OF INPUT FILE='
CREM	      READ(*,'(A)') DY1,DY2
	ndays=im(imn)
	DY1='01'
	call blet2(ndays,DY2)
C
	do n=1,71  !glats
	rgec(n)=0.
	rgec1(n)=0.
	rgec0(n)=0.
	enddo
C
C+    Cycle on day-to-day ++++++++++++
C
	DO 190 idy=1,ndays
	call blet2(idy,ADY)
	xdy=float(idy)
C
C Start input for given UT:++++++++++++++++++++
C
  273 FORMAT(1X,I2)

      infile='d:\web\dts\YR\MN\tcMNDYUT.jYR'
C
      infile(12:13)=ayr
	infile(15:16)=amn
	infile(20:21)=amn
	infile(22:23)=ady 
	infile(28:29)=ayr
C
c   11	continue     ! 
c   27 format(6X,F3.1)

c ***************************************************************
D start cycle on hr-to-hr input:
	DO 775 iut=0,23
 	rut=float(iut)	
	call blet2(iut,AUT)
	infile(24:25)=AUT
C-	outvec=infile
C-	outvec(10:10)='v'
C-	outvec(19:19)='e'
		      OPEN(111,FILE=INFILE)
C-	OPEN(14,FILE=OUTVEC)
   80	GEC=0.
	GEC1=0. !land
	GEC0=0.	!sea
	cntav1=0.
	cntav0=0.
	do k=0,72
 	itxx0(k)=0.		! prec. lati TECeff
	enddo
C
D start cycle on glatitudes:
	glati=-90.0	   ! glati
	DO 777 lat=1,71	   ! Start cycle on glati 
	glati=glati+2.5
	res(lat)=0.			! total gec
	res1(lat)=0.        ! GEC1 for each glat
	res0(lat)=0.        ! GEC0 for each glat
	do k=0,72
 	itxx(k)=0.		! curr. lati TECeff
	enddo
C Select coefficient:
c>>	if (glati.le.0) then
C_	 acoef=gecoef(lat)/1.0E+11  !scale
C//		 acoef=gecoef(lat)
c>>	else
c>>	 acoef=gecoef(73-lat)
c>>	endif
C++++++++++++++++++
C=	if(lat.eq.72) then  ! &! ????????????????
C=	goto 171			   ! for gmlat=90.0
C=	endif
C read  TECeff for current lati
	READ (111,187,END=9,ERR=2) (itxx(k),k=0,72) 
  187	format(73(1X,I4))

C++++++++++++++++++
C
C Select values for Long=-180,-165,...0,15,30,..,165...!!!!!!!!!!!!:
C
171	nlon=-1
C
 	sum=0. 		 ! total GEC
	cnt=0.
C prepare calculation of GEC1 (Land) & GEC0 (Sea):
C 1-Land, 0- Sea
      sum1=0.		 ! GEC1
	cnt1=0.
	sum0=0.		 ! GEC0
	cnt0=0.
	do 776 il=-180,180,5     ! for mlong-cycle
	nlon=nlon+1
	glong=float(il) !glong 
C=	aglat=glat(lat,nlon)
C=	aglon=glon(lat,nlon)
	if (glong.lt.0.) glong=glong+360.        
C
	rtav(nlon)=float(itxx(nlon))
  172    sum=sum+rtav(nlon)
	cnt=cnt+1.
C++			 
C Check position Sea/Land 
	call sealand(glati,glong,sout)
C
	if (sout) then		 !true ~ sea
	cnt0=cnt0+1			  ! Sea
	sum0=sum0+rtav(nlon)
	else
	cnt1=cnt1+1			 !false ~ land
		sum1=sum1+rtav(nlon)
	endif

C
 776	continue ! long cycle
CREM	res(lat)=sum*1.0E+15*acoef
CREM	res1(lat)=sum1*1.0E+15*acoef
CREM	res0(lat)=sum0*1.0E+15*acoef

C Average over number of cells at sea/land/total
	if(cnt.gt.0.) sum=sum/cnt
	if(cnt0.gt.0.) sum0=sum0/cnt0
	if(cnt1.gt.0.) sum1=sum1/cnt1
C
C//	rgec(lat)=rgec(lat)+sum*1.0E+15*acoef
C//	rgec0(lat)=rgec0(lat)+sum0*1.0E+15*acoef
C//	rgec1(lat)=rgec1(lat)+sum1*1.0E+15*acoef
		rgec(lat)=rgec(lat)+sum
	 rgec0(lat)=rgec0(lat)+sum0
	rgec1(lat)=rgec1(lat)+sum1
 182	format(3A2,24(1X,I4))							
	do i=0,72
	itxx0(i)=itxx(i)  ! prec. lati TEC
	itxx(i)=0.
	enddo
	cntav1=cntav1+cnt1
	cntav0=cntav0+cnt0
C
C Output of VEC map for lati:
C
C>      write(*,187) (ivec(k),k=0,72)
C-	write(14,187) (ivec(k),k=0,72)

 777  continue  ! lati cycle

C --------------- 
C OUTPUT OF RESULTS
  9	continue
	 	close(unit=111)
CC
 176  FORMAT(1X,I2,2X,E12.6)
C Continue to the next UT hr :
  32		irun=irun+1 
  775 continue   ! End calculation for given UT
C Output of daily results
C
  190	CONTINUE ! To next day of the month
C
	sum=0.
	sum1=0.
	sum0=0.
	cnthrs=24.*ndays
	cntec=0.
	cntec0=0.
	cntec1=0.
	do i=1,71 
C//	sum=sum+rgec(i) ! aver using glats=1,...,71
C//	sum1=sum1+rgec1(i) ! aver using glats=1,...,71
C//	sum0=sum0+rgec0(i) ! aver using glats=1,...,71
c//	rgec(i)=rgec(i)/(cnthrs*1.0E+32) ! Aver for 24 h UT *all days/month
c//	rgec0(i)=rgec0(i)/(cnthrs*1.0E+32) ! Aver for 24 h UT*all days/month
c//	rgec1(i)=rgec1(i)/(cnthrs*1.0E+32) ! Aver for 24 h UT*all days/month
		rgec(i)=rgec(i)/cnthrs ! Aver for 24 h UT *all days/month
	 rgec0(i)=rgec0(i)/cnthrs ! Aver for 24 h UT*all days/month
	rgec1(i)=rgec1(i)/cnthrs ! Aver for 24 h UT*all days/mont
	igec(i)=nint(rgec(i))
	igec1(i)=nint(rgec1(i))
	igec0(i)=nint(rgec0(i))
	if (rgec(i).gt.0.) then
	sum=sum+rgec(i) ! aver using glats=1,...,71
	cntec=cntec+1.
	endif
	if (rgec1(i).gt.0.) then
	sum1=sum1+rgec1(i) ! aver using glats=1,...,71
	cntec1=cntec1+1.
	endif
	if (rgec0(i).gt.0.) then
	sum0=sum0+rgec0(i) ! aver using glats=1,...,71
	cntec0=cntec0+1.
	endif
	enddo
C//	sum=sum/(cnthrs*1.0E+32) ! aver using glats=1,...,71
c//	sum1=sum1/(cnthrs*1.0E+32) ! aver using glats=1,...,71
c//	sum0=sum0/(cnthrs*1.0E+32) ! aver using glats=1,...,71
		sum=sum/cntec ! aver using glats=1,...,71
 	sum1=sum1/cntec1 ! aver using glats=1,...,71
	sum0=sum0/cntec0 ! aver using glats=1,...,71

c-	iroc(24)=nint(sum*100)
	iaver=nint(sum) 
	iaver1=nint(sum1) 
	iaver0=nint(sum0) 
C
C      Add output of 4 title lines
	imon=1
	if (iyr.eq.98) imon=9
	IF (imn.eq.imon) THEN
	txt(1:3)='GEC'
	write(12,275) txt
	txt(5:9)='Sea'
	write(10,275) txt
	txt(5:9)='Land'
	write(11,275) txt 
	write(*,275) txt
  275 format(A10)
	WRITE(12,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
	WRITE(11,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
	WRITE(10,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
	txt(1:9)='YM|MLAT '
	xmlat=-90.
	do k=1,71
	xmlat=xmlat+2.5
C	iroc(k)=k
	iroc(k)=int(xmlat)
	enddo
  276 format(A8,71(I3,2X))	
      write(*,276) txt,(iroc(k),k=1,71)
	write(12,276) txt,(iroc(k),k=1,71)
	write(11,276) txt,(iroc(k),k=1,71)
	write(10,276) txt,(iroc(k),k=1,71)
	txt(1:50)='--------------------------------------------------'
	txt(51:100)='--------------------------------------------------'
	txt(101:131)='------------------------------'
  274 format(A131)
	write(12,274) txt
	write(11,274) txt
	write(10,274) txt
	write(*,274) txt
	ENDIF
C
	write(*,177) ayr,amn,(igec(i),i=1,71)  ! ZEC (glat)
	write(12,177) ayr,amn,(igec(i),i=1,71)
	write(11,177) ayr,amn,(igec1(i),i=1,71)
	write(10,177) ayr,amn,(igec0(i),i=1,71)
 177  format(1X,2A2,71(1X,I4))

C+++++++++++++++++++++++++++++++++++++++++++++++
	write(*,277) ayr,amn,iaver,iaver1,iaver0	 ! 
	write(13,277) ayr,amn,iaver,iaver1,iaver0
 277  format(1X,2A2,3(2X,I4))
 1277	continue
		irun=0
	iidy=int(xdy)
		goto 33	   ! 
C
c	write (*,888) alat,alon,aday
c  888	format(1X,' alat=',A3,' alon=',A3,' day=',A3)

    2 CONTINUE
      if (irun.eq.0) then
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY ',infile
 	pause ' '
	goto 35
      endif

c 33	if ((iidy.le.idy2).and.(idy1.lt.idy2)) goto 32
   33	imn=imn+1
      call blet2(imn,amn)
	if (iyr.eq.15) then
	 If (imn.lt.11) then
	 goto 1
	else
	goto 35
	endif
	endif
      if (imn.lt.13) GOTO 1
   35      write(*,*) infile,outfile
	write(*,*) irun
	close (unit=10)
	close (unit=11)
 	close (unit=12)
	close (unit=13)
C	if ((imn.lt.12).and.(iyr.ne.18)) GOTO 1
	if (iyr.ne.16) goto 333
      pause ' ' 
      STOP
       END

C***********************************************************
