	program histdgecyr
c .......................................................Sep 2016
C Histogram of dGEC, % occurrence from annual results wfngYR.txt........
C
c input annual files collected for UT: 0, 1, ...,23 hrs
c from jprg TEC maps
c
	DIMENSION ires(13),ind(0:23),ist(13),iper(13),icnt(13)
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*64,infile,outfile
	CHARACTER*2 AYR
	CHARACTER*6 YRMNDY
	CHARACTER*4 AYEAR
	DATA IST/-300,-100,-80,-60,-40,-20,0,20,40,60,80,100,300/ 
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C start
C+      WRITE(*,'(\A\)') ' ENTER YEAR OF INPUT FILE='
C+      READ(*,'(A)') AYEAR
C+	ayr=ayear(3:4)
C+	read(ayear,*) year
crem      WRITE(*,'(\A\)') ' ENTER MN OF INPUT FILE='
crem      READ(*,'(A)') AMN
crem	read(amn,*) rmn
C+	imn=int(rmn)

C          Year-to-Year cycle
C
	jyear=1997
	icntot=0
	do kk=1,13
	ires(kk)=0
	enddo
	AYEAR='9999'
        outfile='histdgec.res'
C
	OPEN(11,FILE=OUTFILE,ACCESS='APPEND')
      WRITE(11,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
	write(*,72) AYEAR,ist
	write(11,72) AYEAR,ist
C
	DO 100 jyear=1998,2016
	year=float(jyear)
	 call blet4(jyear,AYEAR)
	AYR=AYEAR(3:4)
	icntyr=0
	do kk=1,13
	icnt(kk)=0
	enddo
CC CALCULATION OF DAYS OF YEAR	
C-	iiyr=int(year)
C-	if(int(year/4.)*4.eq.jyear) THEN 
c==	ndnr=366
C-	cntyr=24.*366.
C-	im(2)=29
C-	                          ELSE
c==	ndnr=365
C-	cntyr=24.*365.
C-	im(2)=28
C-	ENDIF
c//		 infile='wfngyr.txt'	 ! foF2
		 infile='d:\web\dat0\YR\eoYRdgecj.txt'
  	infile(13:14)=ayr
	infile(18:19)=ayr
c-	imn=0
c-	do i=1,11
c-	icnt(i)=0	  ! annual Hist
c-	enddo
200	 CONTINUE	   ! start cycle month-to-month
C
C Summary array:
c-	do i=1,11
c-	ires(i)=0	   ! monthly Hist
c-	enddo
c-	imn=imn+1
c-	if (imn.gt.12) goto 800 ! end
c-	call blet2(imn,AMN)
c-	infile(20:21)=amn

	OPEN(10,FILE=INFILE,action='READ')
C-	ndnr=im(imn)
c     
 202  CONTINUE       ! day-to-day annual cycle

C ===== Input datafile 
c- 1311	DO 1799 jj=1,ndnr
c	pause ' '
c
    1	READ (10,12,END=55,ERR=2) YRMNDY,(ind(k),k=0,23)
      icntyr=icntyr+24
	icntot=icntot+24        ! count total
  12	FORMAT(A6,24(1X,I4))
C-	YRMN(jj)=YRMNDY
	DO 1234 k=0,23
C-	if (ind(k).lt.ist(1)) then
C-	ires(1)=ires(1)+1
C-	goto 1234
C-	endif
C-	if (ind(k).gt.ist(11)) then
C-	ires(11)=ires(11)+1
C-	goto 1234
C-	endif
	if (ind(k).eq.0) then
	ires(7)=ires(7)+1
	icnt(7)=icnt(7)+1
	goto 1234
	endif
	do j=1,6
	if ((ind(k).ge.ist(j)).and.(ind(k).lt.ist(j+1))) then
	ires(j)=ires(j)+1
	icnt(j)=icnt(j)+1
	goto 1234
 	endif
	enddo
	do j=7,12
	if ((ind(k).gt.ist(j)).and.(ind(k).le.ist(j+1))) then
	ires(j+1)=ires(j+1)+1
	icnt(j+1)=icnt(j+1)+1
	goto 1234
 	endif
	enddo
1234	CONTINUE	 
  	 GOTO 1
C 1799	CONTINUE
  55  CLOSE(unit=10)
	do k=1,13
	per=float(icnt(k))/icntyr*10000.
	iper(k)=nint(per)
	enddo
	write(*,72) AYEAR,(iper(k),k=1,13)
	write(11,72) AYEAR,(iper(k),k=1,13)
	write(*,73) AYEAR,(icnt(k),k=1,13),icntyr
	write(11,73) AYEAR,(icnt(k),k=1,13),icntyr

 100	 CONTINUE             ! year-to-year cycle
c-  3   do k=1,11
c-	icnt(k)=icnt(k)+ires(k)
c-	enddo

c   

C	goto 200 ! next month
  800 CONTINUE             

   72 format(1X,A4,13(3X,I4))
   73 format(1X,A4,13(1X,I6),1X,I8)
   74 format(1X,I8)
   75 continue	 
	write(*,74) icntot
	write(11,74) icntot
	CLOSE(unit=11)
	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

