C                                                        Dec 2011
C
C Add GEC calculation for ut=24h
C Add daily rate-of-change, daily mean GEC -> OUTFILE2
C
C T.L.Gulyaeva...........................................July 2011
C 
      PROGRAM MAPGEC6a
C----------------------------------------------------------------
C Select all latitudes: res1=87.5N,85N,,,,5N,00,5S,...,87.5S 
C                        
C each line in input file for TEC at:[-180, -165,...0,15E,30E,...,165E]
C separate files for UT=0,1,2,3,...23hUT
C Produce GYRMNDY.res files 	 (UT GEC)
C output array: res(72)
C program for EXTRACTING FROM "uhrgdoy0.iYR" ionex_TEC data 
C Output: GYRMNDY.res data for day into annual file gecyr.br
C all results for given year, includint YRMNDY  GEC(t), t=0,1,...,23 UT + daily mean, GEC(t)=GEC/1.E+32, GECU
C outfile='gecyr.br' 
C if input file jplg (2h UT step), linear interpolation is applied for 1h UT results
C
C*********TEST
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*80 INFILE,OUTFILE,OUTFILE2
	CHARACTER*4 AYEAR,RYEAR,NAME

	CHARACTER*131 txt
	CHARACTER*16 txt1,start
	character*2 ayr,amn,rmn,rdy,dy1,ady,aut,dy2,ady0
	character*1 gh
c	character*10 blank,comp
	character*3 aday
	integer*4 ixx(16)
	integer*2 iidy,iyr,imn,iut
	dimension itxx(73),im(12),itxx0(73),rtav(72)
	+,gecoef(36),iamp(0:7)
	dimension res(72),rgec(0:24),igec(0:24),iroc(0:24)
     +,pgec(0:24) ! prec.day
	     COMMON  /CONST/UMR
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C	! 87.5,85,...,2.5,0
	DATA GECOEF/	
     + .2531141E+11,.759077E+11,.1263859E+12,.1766466E+12,.2265569E+12
	+,.2760177E+12,.3249621E+12,.3732819E+12,.4208994E+12,.467718E+12 
     +,.5136394E+12,.5585862E+12,.6024729E+12,.6452101E+12,.6867256E+12 
     +,.7269356E+12,.7657599E+12,.8031333E+12,.8389754E+12,.8732184E+12 
     +,.9058047E+12,.9366653E+12,.965743E+12,.9929863E+12,.1018338E+13 
     +,.1041746E+13,.1063175E+13,.1082581E+13,.1099923E+13,.1115173E+13 
     +,.1128295E+13,.1139272E+13,.1148076E+13,.1154692E+13,.1159113E+13 
     +,.1161326E+13/ 

C
C	UMR=ATAN(1.0)*4./180.
	IRUN=0
	start='START OF TEC MAP'
c	comp='          '

	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
c
ctemp	WRITE(*,*) 'Enter <jplg> or <jprg> or <uhrg> for input: '
ctemp	read(*,118) name
	name='uhrg'
118	format(A4)
	pause  ' '
	WRITE(*,'(\A\)') ' ENTER YEAR OF INPUT FILE='
      READ(*,'(A)') AYEAR
	ayr=ayear(3:4)
	read(ayr,*) ryr 
      iyr=int(ryr)
	read(ayear,*) year

c
      WRITE(*,'(\A\)') ' ENTER MN OF INPUT FILE='
      READ(*,'(A)') AMN
	read(amn,*) xmn
	imn=int(xmn)
         WRITE(*,'(\A\)') ' ENTER <DY1>,<DY2> OF INPUT FILE='
	      READ(*,'(A)') DY1,DY2
CTemp	DY1='01'
	read(dy1,*) xdy
	idy1=int(xdy)
	read(dy2,*) xdy2
	idy2=int(xdy2)
CC??	nrdy2=idy2

c outfiles =================================
       outfile2='gechYR.brc' ! 3h Amplitude of GEC
	outfile='ghYRMN.txt'
	gh='+'        ! 1h day
      outfile(3:4)=ayr
	outfile(5:6)=amn
	outfile2(5:6)=ayr	 
      		OPEN(12,FILE=OUTFILE,ACCESS='APPEND')
	OPEN(13,FILE=OUTFILE2,ACCESS='APPEND')
CC CALCULATION OF DAY OF YEAR	(LDA)
	iiyr=int(year)
	if(int(year/4.)*4.eq.iiyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
c	xdy=1.      ! start day-of-month
C
C Start input for given UT:++++++++++++++++++++
C

C Cycle day-to-day +++++++++++++++++++++++++++++
  700	iidy=int(xdy)
	do n=0,24
	rgec(n)=0.
	enddo
	call blet2(iidy,ADY)
C
c-	outfile(6:7)=ady
c-		OPEN(12,FILE=OUTFILE,ACCESS='APPEND')
C
	lda=ndoy(iyr,imn,iidy)
	daynr=float(lda)
  178	call blet3(lda,ADAY)

c      infile='esrg0010.05i'      !!!!!!!! ESRG-file
c	infile='esag0010.05i'			 !!!!!!!! ESAG-file
c	infile='codg0010.05i'			 !!!!!!!! CODG-file
	infile='jplg0010.05i'			 !!!!!!!! JPLG-file
C
	infile(1:4)=name
 
      infile(10:11)=ayr
		iflag=0
	pdy='00'
C
   11	continue     ! day-to-day cycle
	ih0=-1
		infile(5:7)=aday
C check availability of uhrg file:
   27 format(6X,F3.1)
	OPEN(11,FILE=INFILE,ACTION='READ')
	read (11,27,err=33,end=30) par 
	goto 29
   30	continue
c	blank=txt(1:10)
c	if (blank.eq.comp) then
      if (par.eq.0.) then
	goto 18
	else
	goto 29
	endif
   18	 infile(1:4)='upcg'	! NEW!!!!!!!!!!!!!!!!!!!!!!!
	gh=' '  ! 2h data
C end check
   29	close(unit=11)
C fix hour step:
	gh=infile(2:2)
	if (gh.eq.'h') then
	idelh=1
c+	iruns=24
	iruns=25
	       else
	idelh=2
      if (iiyr.gt.2002) then
	iruns=13              ! start of 2-hr bins	for 2003:2010 
			else
      if ((iiyr.eq.2002).and.(lda.ge.307)) then
		iruns=13              ! start of 2-hr bins	for 2003:2010
	else
		iruns=12              ! start of 2-hr bins	for 1999:2002
	endif
	endif
c//	iruns=12	  ! Before day 316 YEAR=2002!!!!!!!!!!!!!!!!
c//	iruns=13	  ! After day 316 YEAR=2002!!!!!!!!!!!!!!!!

	endif
C end fix
		      OPEN(111,FILE=INFILE)
C  Start of daily selection for given day:
      if (iiyr.gt.2002) then
		ihr=0              ! start of 2-hr bins	for 2003:2010 
			else
      if ((iiyr.eq.2002).and.(lda.ge.307)) then
		ihr=0              ! start of 2-hr bins	for 2003:2010
	else
		ihr=1              ! start of 2-hr bins	for 1999:2002
	endif
	endif
	if (ihr.eq.1) then
	iutf=23
	                   else
	iutf=24
	    endif

c ***************************************************************
D start cycle on hr-to-hr input:
   80	GEC=0.
	do k=1,73
 	itxx0(k)=0.		! prec. lati TEC
	enddo
C
      do i=1,800					             !!
	READ (111,187,END=33,ERR=2) txt,txt1
  187	format(A60,A16)
	if (txt1.eq.start) goto 88
	enddo									 !!
  88	continue
c      write(*,*) txt1
c	pause ' '
C Start of reading VTEC ========================
   	read (111,89,end=9,err=85) ryear,rmn,rdy,iut
   89 format(2X,A4,4X,A2,4X,A2,4X,I2)
       if ((irun.eq.iruns-1).and.(iut.eq.0)) then
 	rmn=amn
	rdy=ady0
	iut=24     !+++
	endif
   85	continue
c      write(*,89) ryear,rmn,rdy,iut 
 	rut=float(iut)	
C Temp for 2002 Nov-Dec
C Temp		iiut=int(rut)				!Temp for 2002 Nov-Dec
C Temp 	if(int(rut/2.)*2.eq.iut) THEN   !Temp for 2002 Nov-Dec
C Temp	iut=iut+1		 !Temp for 2002 Nov-Dec
C Temp	endif			 !Temp for 2002 Nov-Dec
	call blet2(iut,AUT)
C
	if (rmn(1:1).eq.' ') rmn(1:1)='0'
 	if (rdy(1:1).eq.' ') rdy(1:1)='0'

	read (rdy,*) day
	idy=int(day)
c	pause ' '

C +++++++++++ 
	jt=0
C 
  	ilat=0
D start cycle on glatitudes:
	glati=90.0

	DO 777 lat=1,72	   ! Start cycle on glati

	res(lat)=0.        ! GEC for each glat
c??	if (lat.eq.37) then
c??	res(37)=res(36)
c??	goto 121
c??	endif
		ilat=ilat+1
	glati=glati-2.5
	if (glati.ge.0) then
	 acoef=gecoef(lat)
	else
	 acoef=gecoef(73-lat)
	endif
C++++++++++++++++++
	if(lat.eq.72) then
	goto 171
	endif
C++++++++++++++++++
   87	read (111,90,end=9,err=2) glat,txt
   90	format(3X,F5.1,A60)
  91   	j1=0
	do j=1,4        
	j1=(j-1)*16
   1	READ (111,180,END=9,ERR=2) (ixx(i),i=1,16)
  180	format(16(1X,I4))
	do k=1,16
	if (ixx(k).eq.9999) ixx(k)=1	  ! missed TEC
	itxx(j1+k)=ixx(k)
	enddo
	enddo			  ! start selection of 4 longitudes
	READ (111,179,END=9,ERR=2) (ixx(i),i=1,9)
  179	format(9(1X,I4))
	do k=1,9
	if (ixx(k).eq.9999) ixx(k)=1	  ! missed TEC
	itxx(64+k)=ixx(k)
	enddo
cc=	if ((glati.gt.60.).or.(glati.lt.-60.)) goto 777

C Select values for Long=-180,-165,...0,15,30,..,165...!!!!!!!!!!!!:
C
	ii=-1
c=	 jj=71
171	nlon=0
C
C
 	sum=0.
	do 776 il=-180,175,5     ! for long-cycle
	nlon=nlon+1
	ii=ii+1
	glong=float(il) 
cc=	if (glong.lt.0.) glong=glong+360.        
C
cc=	ires(nlati,iidy,ii)=itxx(nlon)
	if (itxx(nlon).le.0) then
	itxx(nlon)=10
	endif
C++++++++
		if(lat.eq.1) then
 	rtav(nlon)=(itxx(nlon)+itxx(nlon+1))/2.
	goto 172
	endif

		if(lat.eq.72) then
 	rtav(nlon)=(itxx0(nlon)+itxx0(nlon+1))/2.
	goto 172
	endif
C
	rtav(nlon)=(itxx0(nlon)+itxx0(nlon+1)+itxx(nlon)+itxx(nlon+1))/4.
c//      isum=isum+itxx(nlon)
  172    sum=sum+rtav(nlon)
C++			 
C
 776	continue ! long cycle
	res(lat)=sum*1.0E+15*acoef
 182	format(3A2,24(1X,I4))							
 121 	GEC=GEC+res(lat)
	do i=1,73
	itxx0(i)=itxx(i)  ! prec. lati TEC
	itxx(i)=0.
	enddo
 777  continue  ! lati cycle

C --------------- 
C OUTPUT OF RESULTS
  9	continue
 176  FORMAT(1X,I2,2X,E12.6)
c	do kk=1,72
c1	write(*,176) iut,GEC
c1	write(12,176) iut,GEC
c	enddo
	 
  775 continue   ! End calculation for given UT
C Continue to the next UT hr :
  32		irun=irun+1 
 	ady0=rdy
	rgec(iut)=GEC/1.0E+32
c-	if (iiyr.gt.2002) then
c//	if (iut.eq.0) then
c==	iutend=iruns+1
c==	                  else
	iutend=iruns
c//	                  endif
	      if (irun.lt.iutend) goto 80 ! continue to the next UT hr =>>>>
C
C Output of daily results
C
	if (idelh.eq.2) then  !>>>>>>>>>>>>>>>>>>>>	 for 1, 3, 5,..., 23 h
C interpolation for 1h UT
	if (iutend.eq.13) then !+++
	do k=1,12				! interp between 13 daily results
	k1=(k-1)*2+1
	rgec(k1)=(rgec(k1-1)+rgec(k1+1))/2.
	enddo
	                else   !+++
	do 207 k=1,12			 ! interp between 12 daily results
	k1=(k-1)*2
	if (k1.eq.0) then
	   if (iidy.eq.1) then
	   rgec(0)=rgec(1)
	   goto 207
	                 else
	   xxg=pgec(23)
	   endif
	else                 
	xxg=rgec(k1-1)
	   endif
	rgec(k1)=(xxg+rgec(k1+1))/2.
  207	continue
                   endif !+++
	endif              !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<,,,
C
	if (rgec(24).eq.0) rgec(24)=rgec(22)+(rgec(23)-rgec(22))*2. ! Lin. extrap.
	sum=0.
	do i=0,24
	sum=sum+rgec(i)
	igec(i)=nint(rgec(i)*100.)
	pgec(i)=rgec(i)    ! keep results for prec.day+++++++++++++++++++++
c-	if (i.lt.24) iroc(i)=nint((rgec(i+1)-rgec(i))*100.) ! rate-of-change
	enddo
	sum=sum/25.
c-	iroc(24)=nint(sum*100)
	iaver=nint(sum*100.) 
C
C      Add output of 4 title lines
	IF (iidy.eq.1) THEN
	txt(1:3)='GEC'
	write(12,275) txt
	write(*,275) txt
  275 format(A3)
	WRITE(12,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
	txt(1:9)='YYMMDD|UT'
	do k=0,24
	iroc(k)=k
	enddo
  276 format(A9,25(I2,3X))	
      write(*,276) txt,(iroc(k),k=0,24)
	write(12,276) txt,(iroc(k),k=0,24)
	txt(1:50)='--------------------------------------------------'
	txt(51:100)='--------------------------------------------------'
	txt(101:131)='-------------------------------'
  274 format(A131)
	write(12,274) txt
	write(*,274) txt
	ENDIF
C
	write(*,177) ayr,amn,ady,gh,(igec(i),i=0,24)  ! GEC
	write(12,177) ayr,amn,ady,gh,(igec(i),i=0,24)
C Keep results for prec.day:
c--	write(*,177) ayr,amn,ady,gh,(iroc(i),i=0,24)  ! rate-of-change
c--	write(13,177) ayr,amn,ady,gh,(iroc(i),i=0,24)
C+++++++++++++++++++++++++++++++++++++++++++++++
Ctemp Produce 3-h UT amplitude of GEC
C
	do i=0,7
	i1=i*3
	xmin=9999.
	xmax=0.
C
	do k=1,3
	if (rgec(i1+k-1).lt.xmin) xmin=rgec(i1+k-1)	  ! 3h Amplitude
	if (rgec(i1+k-1).gt.xmax) xmax=rgec(i1+k-1)
	enddo
	iamp(i)=nint((xmax-xmin)*100.)
	enddo
	write(*,277) ayr,amn,ady,gh,(iamp(i),i=0,7),iaver	 ! 3h Amplitude
	write(13,277) ayr,amn,ady,gh,(iamp(i),i=0,7),iaver
 277  format(3A2,A1,8(I4,1X),2X,I4)
 177  format(3A2,A1,25(I4,1X))
ctemp 177  format(3A2,1X,25(I4,1X))
C	pause ' '
C 
      xdy=xdy+1.
		irun=0
cc=	irun=irun+1
c	pause ' '
	close(unit=111)
	iidy=int(xdy)
	if ((iidy.le.idy2).and.(idy1.lt.idy2)) then
	goto 700                ! continue for the next day of month
	else
		goto 33	   ! end of calculations
	endif
C
c	write (*,888) alat,alon,aday
c  888	format(1X,' alat=',A3,' alon=',A3,' day=',A3)

    2 CONTINUE
      if (irun.eq.0) then
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 35
      endif

   33	if ((iidy.le.idy2).and.(idy1.lt.idy2)) goto 32
   35      write(*,*) infile,outfile
	write(*,*) irun
 	close (unit=12)
	close (unit=13)
      pause ' ' 
      STOP
       END

C***********************************************************
