      program solphasgec
C..................................................................Jan. 2017
C Expected 24-sol-cycle min: 2018 April - according to IG12
C 12-mn set of GEC 1999-2017.01
C
	dimension RMIN(4),RMAX(4)
	character*64 infile,outfile
	integer*2 imn
	character*4 BYEAR
	character*2 AMN,AYR
	DATA RMIN/1996.9,2008.9,2018.3,2024.9/
	DATA RMAX/1989.3,2000.3,2014.2,2020.9/
 
	infile='gec12o.txt'
	outfile='solphasgec.res'
       	OPEN(12,FILE=OUTFILE)
C
	OPEN(11,FILE=INFILE)
  120 FORMAT(A4,1X,I2,1X,F8.3,2X,F5.1)
  121 FORMAT(1X,A2,I2,1X,F4.2)
  122	FORMAT(1X,A2)
  123	FORMAT(12(3X,I4))
C Cycle on years 1914-1963
C  Cycle on years 1999-2017
	do KK=1,22
	nnsum=0
	anssn=0.
C  Cycle on mn
	imnend=12
	if (kk.eq.22) imnend=1  ! 2017.01
	do 77 imn=1,imnend
	READ (11,121,END=3,ERR=2) AYR,KMN,GEC
	call blet2(kmn,AMN)
	rmn=float(kmn)
	read(AYR,*) ryr
	if (ryr.eq.99.) then
	ryear=1999
	else
	ryear=2000+ryr
	endif
	iyear=int(ryear)
	call blet4(iyear,BYEAR)
	ASTR=ryear+rmn/12.
C Select Sol Phase boundaries
	do j=1,4
	if ((ASTR.le.RMIN(j)).and.(ASTR.ge.RMAX(j))) then
	AMIN=RMIN(j)
	AMAX=RMAX(j)
	exit
	endif
	if ((ASTR.ge.RMIN(j)).and.(ASTR.le.RMAX(j+1))) then
	amin=RMIN(j)
	amax=rmax(j+1)
	exit
	endif
	enddo
C end select
       FI=(ASTR-AMIN)/(AMAX-AMIN)
crem	num=keq(imn)
c//      SSNI=0.0112+FI*(-0.0903+FI*(0.7218+FI*(-1.2848+FI*(1.5358
c//	*-0.7769*FI))))
C/      EQN=138.18-0.1832*SSN(imn)                                        
C	nnsum=nnsum+NEQ
C	anssn=anssn+ssn
      if (gec.eq.0.) gec=1.3486*fi+0.8648 ! model gec(fi)
  150 write(*,13) BYEAR,AMN,fi,gec
	write(12,13) BYEAR,AMN,fi,gec
   77	continue   ! end cycle on month
c	anssn=anssn/12.
  13  FORMAT(1X,A4,A2,1X,F7.2,1X,F4.2)
  73  FORMAT(1X,A4,1X,F6.1,1X,I4)
C	write(*,73) AYEAR,anssn,nnsum
C	write(13,73) AYEAR,anssn,nnsum
	ENDDO					   ! end cycle on year
    3	CLOSE(unit=11)
	CLOSE(unit=12)
	goto 180
    2	write(*,*) 'input error'
	
180   continue
	pause ' '
      STOP
	end