C.....................................................................
	program tpxgrd3
C...........................................................Dec/2012
C Read Tpx/Jason, GPS, TECiri
C Monthly mean for North & South Magnetic Hemisphere
C
C...........................................................June 2008(Feb. 2008)
  	dimension im(12)

	integer*2 iyr,imn,idy
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	character*2 ayr,amn,ady
	character*4 ayear
	CHARACTER*64 infile,outfile
	CHARACTER*128 txt
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C =================================================
	WRITE(*,'(\A\)') ' ENTER YEAR OF INPUT FILE='
      READ(*,101) AYEAR
  101 format(A4)
1111	WRITE(*,'(\A\)') 'ENTER AMN OF INPUT FILE or <00> for stop ='
      READ(*,102) AMN
	read(amn,*) rmn
	imn=int(rmn)
  102 format(A2)

  999	continue

c+
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
c Start of annual input:

 	ayr=ayear(3:4)
	read(ayear,*) year
		iiyr=int(year)
	read(ayr,*) ryr
	iyr=int(ryr)

 	if(int(year/4.)*4.eq.iiyr) THEN 
	im(2)=29
	ndyr=366
	                          ELSE
	IM(2)=28
	ndyr=365
	ENDIF
C Continue 
	outfile='tpxgrd4.txt' 
C
990   OPEN(111,FILE=OUTFILE,ACCESS='APPEND')

C prepare calculation of monthly average:
C 1-North, 2- South Magnetic Hemisphere
	sumav1=0.
	cntav1=0.
	errav1=0.
	gimav1=0.
	sumav0=0.
	cntav0=0.
	errav0=0.
	gimav0=0.
C
	infile='jpltpx_YYMMDD.dat'
  	infile(8:9)=ayr
	infile(10:11)=amn
	 mndd=im(imn)
  991	DO 992 idy=1,mndd
	call blet2(idy,ADY)
	infile(12:13)=ady
C read data:
		OPEN(110,FILE=INFILE)	! Availability of TPX data for given day/month
c
	
  175	READ (110,177,END=178,ERR=173) txt
  177	format(A64)
c	write(*,177) txt
	goto 993
  173	write(*,*) 'No <NDY> file for given YEAR,MON. Program terminated'
	pause ' '
	stop
 178	close (unit=110)
	goto 992

C
c++  994 format(41X,F7.2,7X,F7.2) ! rem format for 2008-1:12 & 2009-01
  994 format(18X,F11.6,1X,F11.6,1X,F6.2,7X,F7.2) !format for 2008-1:12 & 2009-01
C-  994 format(51X,F8.3,5X,F8.3) ! rem format for 2009-04, 05 ... 11
  993	READ (110,994,END=178,ERR=173) eflat,eflon,tectpx,tecgps

C Check position North/South of Magnetic equator
	call submageq(eflat,eflon,ns)
C
	if (ns.eq.1) then
	cntav1=cntav1+1
	sumav1=sumav1+tectpx
	gimav1=gimav1+tecgps
	else
	cntav0=cntav0+1
	sumav0=sumav0+tectpx
	gimav0=gimav0+tecgps
	endif
	goto 993
c
  992	continue		  ! END monthly cycle
c??	goto 1
C
988	continue
989	continue          

C
C Total average:
	tpxav1=sumav1/cntav1
	gpsav1=gimav1/cntav1
	tpxav0=sumav0/cntav0
	gpsav0=gimav0/cntav0
C
	write(111,78) ayr,amn,tpxav1,gpsav1,cntav1,tpxav0,gpsav0,cntav0
	write(*,78)  ayr,amn,tpxav1,gpsav1,cntav1,tpxav0,gpsav0,cntav0
   78	format(1X,2A2,2(2(1X,F7.2),1X,F7.0))

		CLOSE(unit=111)
C
C
	goto 900
C
   33	continue
      write(*,*) 'Error reading data; program terminated'
  900	write(*,*) infile
	pause ' '
  	stop
	end
C..............................................................................................
