C............................................................Oct. 2017
C 
C -27-days-tau-accumulated =smoothed GEC index (_27days-tau formula)
C
C 
C
C
      program cngecprotau
C
      DIMENSION IM(12)
	character*45 outfile
	character*4 AYEAR
	character*2 AMN,ADY
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
c
   72	format(1X,I4,1X,F6.2)
   73	format(1X,A2)
   74	format(A45)

	outfile='gectau27.txt'
     	OPEN(20,FILE=outfile,access='APPEND')

C cycle on yr
	nn=0
	DO 50 nyear=1994,2018
C	DO 50 nyear=2015,2017
	call blet4(nyear,AYEAR)
	iyear_cur=nyear
C
C
	     z1=nyear/4.0
        im(2)=28
           if(nyear/4*4.eq.nyear) im(2)=29
C	
C Monthly cycle
C
        imn1=1
	imn2=12
c	if (nyear.eq.1998) imn1=10
	if (nyear.eq.2018) imn2=2
      DO 49 imn=imn1,imn2
	imn_cur=imn
      call blet2(imn,AMN)
C
C Day-to-day cycle
C
       ndmn=im(imn)
	do 48 idy=1,ndmn
	call blet2(idy,ADY)
	idy_cur=idy
C
   40 format(A4,2A2,1X,F5.2)
	call SUBGECTAU27(NYEAR,IMN,IDY,gectau)
	write(*,40) AYEAR,AMN,ADY,gectau
	write(20,40) AYEAR,AMN,ADY,gectau

   48	CONTINUE ! Daily cycle

   49	CONTINUE ! monthly cycle
   50	CONTINUE ! Annual cycle
   51	close (unit=20)

   33	continue
	write(*,*) outfile
   34   pause ' ' 
      STOP
       END

c VERIFICATION OF MEDIAN ================
      subroutine rmedian(ndnr)
C Input file: CC(31,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(31,0:23),ME(0:23),X1(31),X2(31)
		COMMON /BL1/CC,ME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
	IF ((XD1-CD1).LT.0.0001) THEN 
	MD=INT((X2(ND1)+X2(ND2))/2.)
	ELSE
	MD=INT(X2(ND2))
	ENDIF
 1000 IF (MM.eq.0) MD=0
C1010 REM PRINT M;MD;
 1020 ME(M)=MD
 1030 CONTINUE
c 1040 REM PRINT
 1050 RETURN
      END