C............................................................Feb 2014
C GEC asymmetry index: AI=(GECjan-GECjul)/(GECjan-GECjul) for 1999-2013
C  and Ratio=Jan/Jul
C
C
C
      program cntgecai
C
	dimension gec(12)
      character*2 ayr
	character*45 infile,outfile
	integer*2 jyr,jj
c
   71	format(1X,A2,3X,F4.2)
   72	format(1X,A2,2(1X,F7.4))
   73	format(1X,A10)
	outfile='gecai.txt'
crem	infile='gecjmn.txt'
crem	infile='gecjmnN.txt'
	infile='gecjmnS.txt'
	OPEN(110,FILE=outfile,access='APPEND')
	write(110,73) infile
	OPEN(111,FILE=INFILE)
	 gjan=0.
	gjul=0.
	avai=0.
	abrat=0.
C cycle on yr
	DO jj=99,113                 !..................
	if (jj.lt.100) then
	jyr=jj
	else
	jyr=jj-100
	endif
	ryr=float(jyr)

	do k=1,12 ! 12 monthly values
	read(111,71) ayr,gec(k)
	enddo
	ai=(gec(1)-gec(7))/(gec(1)+gec(7))
	rat=gec(1)/gec(7)
	 gjan= gjan+gec(1)
	 gjul= gjul+gec(7)
	avai=avai+ai
	avrat=avrat+rat
	write(*,72) ayr,rat,ai
	write(110,72) ayr,rat,ai
	enddo ! ayr cycle			  !..................
  	ai1=(gjan-gjul)/(gjan+gjul)
 	rat1=gjan/gjul
   	ai=avai/15.
	rat=avrat/15.
c 	rat=gjan/gjul

	ayr='av'
	write(*,72) ayr,rat,ai
	write(110,72) ayr,rat,ai

	close(unit=111)
   80	continue

   81	close(unit=110)
	goto 33
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34

   33	continue
	write(*,*) infile,outfile
   34   pause ' ' 
      STOP
       END

c VERIFICATION OF MEDIAN ================
      subroutine rmedian(ndnr)
C Input file: CC(31,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(31,0:23),ME(0:23),X1(31),X2(31)
		COMMON /BL1/CC,ME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
	IF ((XD1-CD1).LT.0.0001) THEN 
	MD=INT((X2(ND1)+X2(ND2))/2.)
	ELSE
	MD=INT(X2(ND2))
	ENDIF
 1000 IF (MM.eq.0) MD=0
C1010 REM PRINT M;MD;
 1020 ME(M)=MD
 1030 CONTINUE
c 1040 REM PRINT
 1050 RETURN
      END