C............................................................Mar. 2015
C
C............................................................Dec. 2014
C Re-calculation of monthly GEC
C
C............................................................May 2013
C GEC monthly mean
C
C
      program cntgecmn
C
	dimension im(12)
      character*2 ayr,amn
	character*45 infile,outfile
	integer*2 jyr,jmn,jj
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
c
   71	format(48X,F4.2)
   72	format(1X,2A2,1X,F4.2)
C-	infile='gechYR.jvc'
	infile='gechYR.jtc'
	outfile='gecjtmn.txt'
	OPEN(110,FILE=outfile,access='APPEND')
C cycle on yr
C++	DO 70 jj=99,114
	jj=115             ! Year 2015
CREM	jj=98             ! Year 1998
	if (jj.lt.100) then
	jyr=jj
	else
	jyr=jj-100
	endif
	ryr=float(jyr)
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	ndnr=366
	                          ELSE
	IM(2)=28
	ndnr=365
	ENDIF

	call blet2(jyr,AYR)
	infile(5:6)=AYR
	OPEN(111,FILE=INFILE)
C++	do jmn=1,12
CREM      	do jmn=9,12 !1998
	do jmn=11,11	  ! month of 2015
C Constraint for 2015
c-	if ((jj.eq.115).and.(jmn.eq.11)) goto 70
	call blet2(jmn,AMN)
	ndays=im(jmn)
	gecmn=0.
	do kk=1,ndays
	read(111,71) gec
	gecmn=gecmn+gec
	enddo
	gecav=gecmn/ndays
	write(*,72) ayr,amn,gecav
	write(110,72) ayr,amn,gecav
	enddo ! month cycle

	close(unit=111)
   70	continue
   80	continue
   81	close(unit=110)
	goto 33
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34

   33	continue
	write(*,*) infile,outfile
   34   pause ' ' 
      STOP
       END

c VERIFICATION OF MEDIAN ================
      subroutine rmedian(ndnr)
C Input file: CC(31,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(31,0:23),ME(0:23),X1(31),X2(31)
		COMMON /BL1/CC,ME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
	IF ((XD1-CD1).LT.0.0001) THEN 
	MD=INT((X2(ND1)+X2(ND2))/2.)
	ELSE
	MD=INT(X2(ND2))
	ENDIF
 1000 IF (MM.eq.0) MD=0
C1010 REM PRINT M;MD;
 1020 ME(M)=MD
 1030 CONTINUE
c 1040 REM PRINT
 1050 RETURN
      END