C............................................................Mar. 2015
C
C GEC 12=monthly smoothed for ith month for 1999-2015:
C
C GECproxy=(0.0169*R12+0.0102)*58.6408
C
C
      program cntgecrz12
C
	dimension gec12(12),gecrz(12)
      character*4 ayear
	character*45 infile,outfile
	character*1 cc
	character*2 AYR,BYR
	integer*2 jyr
c
c   72	format(1X,A4,1X,12(1X,F5.1))
   72	format(1X,A2,3X,F4.2)
   73	format(1X,A4,2X,12(F5.1,A1))
	cc=','
	outfile='gecrz12n.txt'
C-	infile='r12.dat'
	infile='gec12t.txt'

	OPEN(111,FILE=INFILE)
	OPEN(110,FILE=outfile,access='APPEND')
C cycle on yr
C=   	write(*,*) 'Enter AYEAR:'
C=	read(*,*) ayear
	DO 80 iyyyy=1999,2015
C	read(ayear,*) ryear
C   	iyyyy=int(ryear)
C 31	iyyyy=iyyyy+1
C	if (iyyyy.gt.2018) goto 33
	if(iyyyy.lt.2000) then
	AYEAR(1:2)='19'
	else
	AYEAR(1:2)='20'
	endif
	 jyr=iyyyy-(iyyyy/100)*100
	call blet2(jyr,AYR)
	AYEAR(3:4)=AYR
	nn=0
	jj=0
C	jj=1,180
	DO kmn=1,12
   1	read(111,72,end=81) byr,gecrz(kmn)
C-	enddo
	if (byr.eq.ayr) then
C	do k=1,12
C	gecrz(k)=0.0206*r12(k)+1.0593 ! old regression
C-pre	gecrz(k)=0.0194*r12(k)+1.1157 ! new regression
C
C GEC12= 0.0169*R12+0.8502
C--	gecrz(k)=0.0169*r12(k)+0.8502 ! new regression
C GECproxy= (GEC12-0.84)*58.6408
	gec12(kmn)=(gecrz(kmn)-0.84)*58.6408
	endif
	enddo
C	goto 11
C	else
C      goto 1 ! 
	
	write(*,73) ayear,(gec12(k),cc,k=1,12)
      write(110,73)  ayear,(gec12(k),cc,k=1,12)
Crem11	write(*,74) (gec12(k),cc,k=1,12)
Crem	write(110,74)  (gec12(k),cc,k=1,12)

   80	continue
   81	continue
	goto 33
   74	format(12(F5.1,A1))
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 33

   33	continue
	close(unit=110)
	close(unit=111)
	write(*,*) infile,outfile
   34   pause ' ' 
      STOP
       END

c VERIFICATION OF MEDIAN ================
      subroutine rmedian(ndnr)
C Input file: CC(31,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(31,0:23),ME(0:23),X1(31),X2(31)
		COMMON /BL1/CC,ME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
	IF ((XD1-CD1).LT.0.0001) THEN 
	MD=INT((X2(ND1)+X2(ND2))/2.)
	ELSE
	MD=INT(X2(ND2))
	ENDIF
 1000 IF (MM.eq.0) MD=0
C1010 REM PRINT M;MD;
 1020 ME(M)=MD
 1030 CONTINUE
c 1040 REM PRINT
 1050 RETURN
      END