C............................................................Apr 2013
C GEC (IRI-Plas) annual mean
C
C
      program cntyrsrc
C
      character*2 ayr
	character*45 infile,outfile
	integer*2 jyr,jmn,jj
c
   71	format(48X,F4.2)
   72	format(1X,A2,1X,F4.2)
	infile='gecsYR.src'
	outfile='gecyrs.txt'
	OPEN(110,FILE=outfile)
C cycle on yr
	DO jj=59,113
	if (jj.lt.100) then
	jyr=jj
	else
	jyr=jj-100
	endif
	call blet2(jyr,AYR)
	infile(5:6)=AYR
	OPEN(111,FILE=INFILE)
	decyr=0.
	do jmn=1,12
	read(111,71) gecmn
	decyr=decyr+gecmn
	enddo
	close(unit=111)
	gecyr=decyr/12.
	write(*,72) ayr,gecyr
	write(110,72) ayr,gecyr
	enddo
   80	continue
   81	close(unit=110)
	goto 33
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34

   33	continue
	write(*,*) infile,outfile
   34   pause ' ' 
      STOP
       END

c VERIFICATION OF MEDIAN ================
      subroutine rmedian(ndnr)
C Input file: CC(31,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(31,0:23),ME(0:23),X1(31),X2(31)
		COMMON /BL1/CC,ME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
	IF ((XD1-CD1).LT.0.0001) THEN 
	MD=INT((X2(ND1)+X2(ND2))/2.)
	ELSE
	MD=INT(X2(ND2))
	ENDIF
 1000 IF (MM.eq.0) MD=0
C1010 REM PRINT M;MD;
 1020 ME(M)=MD
 1030 CONTINUE
c 1040 REM PRINT
 1050 RETURN
      END