C ...........................................................Nov 2015
C Annual mean ZEC(glat) at sea/land/global
C 
C
C
C
      program cntgeoyr
C
      character*2 ayr,byr,bmn
	character*4 AYEAR
	character*45 infile,outfile
c
   72	format(1X,2A2,3(2X,F4.0))
   73	format(1X,A4,3(1X,F6.1))
	outfile='zgeolatyr.txt'
	infile='zeglatYR.txt'
	
	OPEN(110,FILE=outfile)
C cycle on yr
	DO 80 jyear=1998,2015
	call blet4(jyear,AYEAR)
	AYR=AYEAR(3:4)
	infile(7:8)=AYR
	OPEN(111,FILE=INFILE)
	sum=0.
	sum0=0.
	sum1=0.
	jmn1=1
	if (jyear.eq.1998) jmn1=9
	jmn2=12
	if (jyear.eq.2015) jmn2=10
	cntmns=jmn2-jmn1+1.0
	do jmn=jmn1,jmn2
   1	read(111,72,end=81) byr,bmn,ztot,zlan,zsea
      sum=sum+ztot
	sum0=sum0+zsea
	sum1=sum1+zlan
	enddo
	res=sum/cntmns
	res0=sum0/cntmns
	res1=sum1/cntmns
c
	write(*,73) ayear,res,res1,res0
	write(110,73) ayear,res,res1,res0
   81	close(unit=111)
   80	continue
   	close(unit=110)
	goto 33
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34

   33	continue
	write(*,*) infile,outfile
   34   pause ' ' 
      STOP
       END

c VERIFICATION OF MEDIAN ================
      subroutine rmedian(ndnr)
C Input file: CC(31,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(31,0:23),ME(0:23),X1(31),X2(31)
		COMMON /BL1/CC,ME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
	IF ((XD1-CD1).LT.0.0001) THEN 
	MD=INT((X2(ND1)+X2(ND2))/2.)
	ELSE
	MD=INT(X2(ND2))
	ENDIF
 1000 IF (MM.eq.0) MD=0
C1010 REM PRINT M;MD;
 1020 ME(M)=MD
 1030 CONTINUE
c 1040 REM PRINT
 1050 RETURN
      END