Cc ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++==
	program extmageq
C .........................................Mar 2012
C
C Extract distance between MAG-Equator and Georg. Equator
C
 	CHARACTER*40 infile,outfile
	CHARACTER*128 txt
	CHARACTER*4	ctime
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ


C
  176 format(A128)

     	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
	      TT(5:)='      '
	ctime=TT

C
   24 format(A30)
   25 format(A30,2(1X,F8.1))
	INFILE='mageq.txt'	! 

	outfile='mageqkm.txt'

	OPEN(10,FILE=OUTFILE)	
	OPEN(11,file=INFILE)

C Input .inp file
	read(11,24) txt
	alt=0.
	alt1=20200.0
	write(*,25) txt,alt,alt1
	write(10,25) txt,alt,alt1
C	 Cycle on lats:

	 do 151 ist=1,72
C
   20	format(5(1X,F5.1))
   21	format(5(1X,F5.1),2(1X,F8.1))
C
C Read .inp file
  100	read(11,20,end=111,err=2) glat,glon,xmlat,xmlon,xmodip
c	write(*,20) glat,glon,xmlat,xmlon,xmodip
	call subdist1(glat,glon,0.0,glon,alt,dist0)
	call subdist1(glat,glon,0.0,glon,alt1,dist1)
	write(*,21) glat,glon,xmlat,xmlon,xmodip,dist0,dist1
	write(10,21) glat,glon,xmlat,xmlon,xmodip,dist0,dist1
C
  151	continue
  111	close (unit=11)
C
	close (unit=10)	  ! outfile
	goto 3
   2	write(*,*) 'Input error'
   3	write(*,*) outfile 
      pause ' '
	STOP
	END
C ==================================================================
      integer function ndoy(iyr,imn,idy)
C To define day-of-year
C
	       DIMENSION IM(0:12)
	integer*2 iyr,imn,idy,nyr,nmn,ndy
	DATA IM/31,31,28,31,30,31,30,31,31,30,31,30,31/
	nyr=iyr
	nmn=imn
	ndy=idy
	z1=nyr/4.0
      jz1=int(z1)*4
      IF(jz1.EQ.nyr) THEN
               IM(2)=29
        ELSE
                IM(2)=28
	       ENDIF
C Day-of-year LDA1
		mosum=0
C NEW++++++++++++++++++++
	if (nmn.eq.0) then
	nmn=12
	nyr=nyr-1
	if (nyr.lt.0) nyr=100+nyr
	endif
      if(nmn.gt.1) then
         do 1234 i=1,nmn-1
1234    mosum=mosum+im(i)
         endif
      ndoy=mosum+ndy	
	END FUNCTION
C ===============================================================
	subroutine ditec(num,res,tect)
      DIMENSION res(0:300,3)
	x1=res(1,1)
	y1=res(1,3)
	SUM=0.0
	do 1 k=2,num
	x2=res(k,1)
	y2=res(k,3)
	st=res(k,1)-res(k-1,1)
	 SUM=SUM+(y2+y1)*st
	x1=x2
	y1=y2
    1 continue
	tect=sum*500.
	return
	end
c===================================================================
      subroutine blet3(ilet,alet3)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
c	INTEGER*2 ilet
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*3 alet3
	alet3='000'             
	j100=ilet/100
	j10=(ilet-j100*100)/10
	j1=ilet-j100*100-j10*10
    	do i=0,9
	if (j100.eq.i) then
	alet3(1:1)=IN(i)
	endif
	enddo
    5	do i=0,9
	if (j10.eq.i) then
	alet3(2:2)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet3(3:3)=IN(i)
	endif
	enddo 
	return
	end
c ============================================