C.......................................................June 2014
C Derive GEC monthly qmedian excluding hours of North and South substorms
C Read from Catalogs: yr1,mn1,dy1,ut1,yr2,mn2,dy2,ut2,hrs (1,2,...,9) 
C
C input file for given YR,MN,DY
	program extrmedq
	DIMENSION CC(31,0:23),HME(0:23),imed(0:23),im(12),idat(0:23) 
	+,icatwun(9,120),icatwln(9,120),icatwus(9,120),icatwls(9,120)
	+,iss(9),xcc(0:23)
	character*80 infile,outfile,infilwun,infilwln,infilwus,infilwls
	+,txt
	character*2 AYR,AMN,ADY
	integer*2 jyr,jmn,jdy,jdq1,jdq2
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
	infilwun='catwun.txt'
	infilwln='catwln.txt'
	infilwus='catwus.txt'
	infilwls='catwls.txt'
	OPEN(11,file=infilwun,action='READ')
	OPEN(12,file=infilwln,action='READ')
	OPEN(13,file=infilwus,action='READ')
	OPEN(14,file=infilwls,action='READ')

         write(*,*) 'Enter YR of infile:'
	 read(*,*) AYR
         write(*,*) 'Enter MN of infile:'
	 read(*,*) AMN
	read(ayr,*) ryr
	jyr=int(ryr)
	if(int(ryr/4.)*4.eq.jyr) THEN 
  	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
	read(amn,*) rmn
	jmn=int(rmn)
	ndy=im(jmn)

C read storm and substorm data
C 990105  1  990105   9  34.0  990105 17   17   21.4    1
   70 format(1X,3I2,1X,I2,20X,3I2,1X,I2,1X,I4)
   71 format(A80)
   72 format(3I2,24(2X,F3.0))
   73 format(3A2,24(2X,I3))
      i1=0
	do i=1,1000
	read(11,70,end=81) (iss(k),k=1,9)
	if (iss(1).eq.jyr) then
	i1=i1+1
	do k=1,9
	icatwun(k,i1)=iss(k)
	enddo
	endif
	enddo
   81	close(unit=11)
      i2=0
	do i=1,1000
	read(12,70,end=82) (iss(k),k=1,9)
	if (iss(1).eq.jyr) then
	i2=i2+1
	do k=1,9
	icatwln(k,i2)=iss(k)
	enddo
	endif
	enddo
   82	close(unit=12)
      i3=0
	do i=1,1000
	read(13,70,end=83) (iss(k),k=1,9)
	if (iss(1).eq.jyr) then
	i3=i3+1
	do k=1,9
	icatwus(k,i3)=iss(k)
	enddo
	endif
	enddo
   83	close(unit=13)
      i4=0
	do i=1,1000
	read(14,70,end=84) (iss(k),k=1,9)
	if (iss(1).eq.jyr) then
	i4=i4+1
	do k=1,9
	icatwls(k,i4)=iss(k)
	enddo
	endif
	enddo
   84	close(unit=14)
C
	infile='d:\web\dat0\YR\ejYRMN.txt'
	infile(13:14)=AYR
	infile(18:19)=AYR
	infile(20:21)=AMN
C	
	outfile=infile
	outfile(22:)='q.med'
	OPEN(10,file=infile)
	OPEN(20,file=outfile,access='APPEND')
CC
	do i=1,4
	read(10,71,end=85) txt ! extra lines
	enddo
C Cycle day-to-day ====================================
	do 90 jdy=1,ndy
	call blet2(jdy,ADY)
	read(10,72,end=85) kyr,kmn,kdy,(xcc(k),k=0,23)
C
	do i=1,i1  ! ++++++++++++++++
	if ((kyr.eq.icatwun(1,i)).and.(kmn.eq.icatwun(2,i))
	*.and.(kdy.ge.icatwun(3,i)).and.(kmn.le.icatwun(6,i))
     *.and.(kdy.le.icatwun(7,i))) then  !<<<<<<<<<<<<<<<<<<<
	it1=icatwun(4,i)
	it2=icatwun(8,i)
      if (kdy.eq.icatwun(3,i)) then ! 1st day of sstorm
	  if (kdy.eq.icatwun(7,i)) then
	  do k=it1,it2
	  xcc(k)=0.
	  enddo
	                           else
	  do k=it1,23
	  xcc(k)=0.
	  enddo
	  endif
                                           else ! next day of sstorm
	  if (kdy.eq.icatwun(7,i)) then
	  do k=0,it2
	  xcc(k)=0.
	  enddo
	                           else
	  do k=0,23
	  xcc(k)=0.
	  enddo
	  endif
	endif
	                  endif  !<<<<<<<<<<<
	enddo	  !+++++++++++

	do i=1,i2  ! ++++++++++++++++
	if ((kyr.eq.icatwln(1,i)).and.(kmn.eq.icatwln(2,i))
	*.and.(kdy.ge.icatwln(3,i)).and.(kmn.le.icatwln(6,i))
     *.and.(kdy.le.icatwln(7,i))) then  !<<<<<<<<<<<<<<<<<<<
	it1=icatwln(4,i)
	it2=icatwln(8,i)
      if (kdy.eq.icatwln(3,i)) then ! 1st day of sstorm
	  if (kdy.eq.icatwln(7,i)) then
	do k=it1,it2
	xcc(k)=0.
	enddo
	                           else
	do k=it1,23
	xcc(k)=0.
	enddo
	endif
                                           else ! next day of sstorm
	  if (kdy.eq.icatwln(7,i)) then
	do k=0,it2
	xcc(k)=0.
	enddo
	                           else
	do k=0,23
	xcc(k)=0.
	enddo
	endif
	endif
	                  endif  !<<<<<<<<<<<
	enddo	  !+++++++++++
c
	do i=1,i3  ! ++++++++++++++++
	if ((kyr.eq.icatwus(1,i)).and.(kmn.eq.icatwus(2,i))
	*.and.(kdy.ge.icatwus(3,i)).and.(kmn.le.icatwus(6,i))
     *.and.(kdy.le.icatwus(7,i))) then  !<<<<<<<<<<<<<<<<<<<
	it1=icatwus(4,i)
	it2=icatwus(8,i)
        if (kdy.eq.icatwus(3,i)) then ! 1st day of sstorm
	  if (kdy.eq.icatwus(7,i)) then
	do k=it1,it2
	xcc(k)=0.
	enddo
	                           else
	do k=it1,23
	xcc(k)=0.
	enddo
	endif
                                           else ! next day of sstorm
	  if (kdy.eq.icatwus(7,i)) then
	do k=0,it2
	xcc(k)=0.
	enddo
	                           else
	do k=0,23
	xcc(k)=0.
	enddo
	endif
	endif
	                  endif  !<<<<<<<<<<<
	enddo	  !+++++++++++

	do i=1,i4  ! ++++++++++++++++
	if ((kyr.eq.icatwls(1,i)).and.(kmn.eq.icatwls(2,i))
	*.and.(kdy.ge.icatwls(3,i)).and.(kmn.le.icatwls(6,i))
     *.and.(kdy.le.icatwls(7,i))) then  !<<<<<<<<<<<<<<<<<<<
	it1=icatwls(4,i)
	it2=icatwls(8,i)
	if (kdy.eq.icatwls(3,i)) then ! 1st day of sstorm
	  if (kdy.eq.icatwls(7,i)) then
	do k=it1,it2
	xcc(k)=0.
	enddo
	                           else
	do k=it1,23
	xcc(k)=0.
	enddo
	endif
                                           else ! next day of sstorm
	  if (kdy.eq.icatwls(7,i)) then
	do k=0,it2
	xcc(k)=0.
	enddo
	                           else
	do k=0,23
	xcc(k)=0.
	enddo
	endif
	endif
	                  endif  !<<<<<<<<<<<
	enddo	  !+++++++++++
	do n=0,23
	cc(jdy,n)=xcc(n)
	enddo
   90	CONTINUE !=======================
   85	close(unit=10)
C
         write(*,*) 'Enter QDY1,QDY2 for median:'
	 read(*,*) jdq1,jdq2
C Select data for quiet interval:
	jjq=jdq2-jdq1+1
	do n=1,jjq
	do k=0,23
	cc(n,k)=cc(jdq1+n-1,k) ! move data up
	enddo
	enddo
C
	call submedmn(jjq,cc,hme)
	write(*,79) jdq1,jdq2
	write(20,79) jdq1,jdq2
  79  format(6X,2(1X,I4))
	do n=0,23
	imed(n)=nint(hme(n))
	enddo

	do jdy=1,ndy
	do n=0,23
	idat(n)=nint(cc(jdy,n))
	enddo
	call blet2(jdy,ADY)
crem	write(*,73) AYR,AMN,ADY,(idat(k),k=0,23)
crem	write(20,73) AYR,AMN,ADY,(idat(k),k=0,23)
	enddo
	ady='00'
  	write(*,73) AYR,AMN,ADY,(imed(k),k=0,23)
	write(20,73) AYR,AMN,ADY,(imed(k),k=0,23)

   21	close(unit=20)
C
	goto 3
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY ',infile
 
   3	pause ' '
	stop
	END
C----------------------------------------------------------------
