      program gafraim1
C .................................................Feb.2012
C TECij = mean TEC for a cell
C dlat=2.5, lati={-88.75,88.75] step=2.5,
C dlon=5.0. long=[-177.5,177.5] step=5
C
	CHARACTER*12 FILNAM
C
C calculate coefficient for TECi due to Afraimovich et al., 
C weighted by Cv=7.52
c
C teta=glati, fi=glong, dteta=2.5deg, dfi=5deg.
	FILNAM='geccoef1.txt'
	h=0.
	RE=6370.
	PI=ATAN(1.0)*4.
        UMR=PI/180.
	dtetar=2.5*umr
	dfir=5.*umr
	call subdist1(0.,0.,2.5,0.,h,dkm0) ! distance for dteta=2.5
C 
      OPEN(12,FILE=FILNAM,ACCESS='APPEND')
	glat1=-90.0
	DO i=1,72			 ! cycle along Latitudes
	glat2=glat1+2.5
	if (i.eq.1) then
	dkm1=0.
	goto 25
	endif
	call subdist1(glat1,0.,glat1,5.0,0.,dkm1)
	if (i.eq.72) then
	dkm2=0.
	goto 26
	endif
   25	call subdist1(glat2,0.,glat2,5.0,0.,dkm2)
   26	del=(dkm1+dkm2)/2.
	scell=del*dkm0
	gcoef=scell*7.52
	write(*,*) glat2,scell,gcoef
	write(12,*) glat2,scell,gcoef
	glat1=glat1+2.5
 	enddo
	close(unit=12)
	pause ' '
	stop

C	

	hstar=150.
	do i=1,10
      e1=(1.+exp(-hstar/300.))
	e2=(1.+exp(-(hstar/100.-30.)/3.))
	ro1=1./e1+1./e2
	ro=5-4*ro1
	write (*,*) hstar,ro
c	hstar=hstar+300.
	hstar=hstar+50.
	enddo
	stop
	end
