	program gec2pi
c .......................................................Mar 2013
C Harmonic analysis of daily GEC .......
C
c Input:gechYR.jrc 
C output
c from (uhrg) jprg TEC maps
c
	DIMENSION im(12),xx(0:359),yy(0:359),zz(5,0:359)
	+,g2pi(3,0:359),ginp(3,366)	 !1=global,2-North,3=South
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZZ
	CHARACTER*64,infile,outfile,outfile1,outfile0
	CHARACTER*2 AYR
	CHARACTER*4 AYEAR
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
	integer*2 jyr
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C start
	write(*,*) ' Enter YEAR' 								 
 	read(*,*) AYEAR											 
 	AYR=AYEAR(3:4)
 	read(ayr,*) ryr
	jyr=int(ryr)
		if(int(ryr/4.)*4.eq.jyr) THEN 
  	im(2)=29
	ndyr=366
	                          ELSE
	IM(2)=28
	ndyr=365
	ENDIF
C
      infile='gechYR.jrc'		 !
	infile(5:6)=AYR

	irun=0
	outfile='gec2pi.txt'
      OPEN(11,FILE=outfile)
	outfile1='gec2pi.tx1'
	OPEN(12,FILE=outfile1)
	outfile0='gec2pi.tx0'
	OPEN(13,FILE=outfile0)
C

C Add calculations in North and South Mag. hemisphere
c?   99	irun=irun+1
c?	if (irun.gt.3) GOTO 900

C
      OPEN(10,FILE=infile,ACTION='READ')
  196	format(46X,3(F6.2))
C Read GEC, GEC-N, GEC-S daily
	do ii=1,ndyr
      READ(10, 196, END=44) (ginp(k,ii),k=1,3)
	enddo
   44	close(unit=10)
C Interpolate data for k=0,359
	days=float(ndyr)
	dx=360./days
	xk=0
C
	DO k=0,359
c	xk=xk+dx*k
	xk=float(k+1)
        do j=1,ndyr
	x1=float(j)/float(ndyr)*360.
	x2=float(j+1)/float(ndyr)*360.
	if((xk.ge.x1).and.(xk.lt.x2)) then
	g2pi(1,k)=ginp(1,j)+(ginp(1,j+1)-ginp(1,j))/(x2-x1)*(xk-x1)
	g2pi(2,k)=ginp(2,j)+(ginp(2,j+1)-ginp(2,j))/(x2-x1)*(xk-x1)
	g2pi(3,k)=ginp(3,j)+(ginp(3,j+1)-ginp(3,j))/(x2-x1)*(xk-x1)
	exit
	endif
	  enddo
	enddo 
C
	do k=0,359
	xx(k)=g2pi(1,k)
	enddo
C Determine Harmonic coefficients

	call subfur360(1,xx,yy)  ! 1 = annual harmonic
	do k=0,359
	zz(1,k)=yy(k) !1st harmonic
	enddo
C
	call subfur360(2,xx,yy)  ! 1 = annual harmonic
	do k=0,359
	zz(2,k)=yy(k) !1st harmonic
	enddo
C
	call subfur360(3,xx,yy)  ! 1 = annual harmonic
	do k=0,359
	zz(3,k)=yy(k) !1st harmonic
	enddo
C
	call subfur360(4,xx,yy)  ! 1 = annual harmonic
	do k=0,359
	zz(4,k)=yy(k) !1st harmonic
	enddo
C
	call subfur360(5,xx,yy)  ! 1 = annual harmonic
	do k=0,359
	zz(5,k)=yy(k) !1st harmonic
	enddo

   74	format(1X,A4,' GEC360')
   75	format(1X,A4,' GEC360 North')
   76	format(1X,A4,' GEC360 South')
  171	format(A64)
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
       write(*,74) AYEAR
	write(11,74) AYEAR
	do k=0,359
	write(*,84) k,g2pi(1,k),(zz(i,k),i=1,5)
	write(11,84) k,g2pi(1,k),(zz(i,k),i=1,5)
	enddo
	goto 85
C
	write(*,75) AYEAR
	write(12,75) AYEAR
	do k=0,359
	write(*,83) k,g2pi(2,k)
	write(12,83) k,g2pi(2,k)
	enddo
C
	write(*,76) AYEAR
	write(13,76) AYEAR
	do k=0,359
	write(*,83) k,g2pi(3,k)
	write(13,83) k,g2pi(3,k)
	enddo
   83	format(1X,I4,F6.2)
   84	format(1X,I4,6(F6.2,1X))
   85	close (unit=11)
		CLOSE(unit=12)
	CLOSE(unit=13)
      goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 continue

      pause ' '
      STOP
      END

