C ===========================================================
	PROGRAM RMSGECMP
C                                                             ! June 2013   
C RMSE and eps and delta
C
C Change proxy to Rzp=1+int(Rzm/3),
C      	  Rzm=(Rz(3)av + Rz(-7)av +Rz(-81)av)/3
C RMS error between GECob and GEC mod. 1999-2012 (12 months results)
C
C   EXTRACT daily-mean GEC, for 12 months @ 40 grids od Rzi=1,2,...,40 (Rzi>40 joint to Rzi=40) 
C   Input <gechYR.jrc  => infile	   =GECobs
C         <fitgecmp.txt> => infilerz =GEC model
C
C   Output
C   (1) outfile: GRZI(40,12) (2) outfile0: GRZI0(40,12) (3) outfile1: GRZI1(40,12)
c
      DIMENSION IM(12),RES(12),RES1(12),RES2(12)
	+,grzi(12),cnt(12),grz1(12),grz2(12)
      INTEGER*2 jyr,jmn,jdy
      CHARACTER*128 infile,outfile,infilerz
		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
 	CHARACTER*2 AYR
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C Start:
	outfile='rmsgecmh.txt'
CREM	outfile='rmsgecmp.txt'
CREM	infilerz='fitgecmp.txt'
	infilerz='fitgecmh.txt'
		CALL DATE_AND_TIME(DD,TT,ZZ)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT 
	do i=1,12
	grzi(i)=0.
	grz1(i)=0.
	grz1(i)=0.
	cnt(i)=0.
	enddo
C
   80	format(1X,A4,2A2,1X,I3)
   78	format(1X,A4,2A2,5(1X,I3)) ! output rz3,...,rzp
C
	infile='gechYR.jrc'
	iflag=0           ! before 1999
C
C =========================================================
   77	format(1X,I4)
  172	OPEN(11,FILE=infilerz,ACTION='READ')
  171	read(11,77) iyrz
C
	if (iyrz.le.1998) then
	goto 171
	else
	backspace(11)
	endif
C
	icntot=0
C
C Cycle on year-to-year 1999-2012:
CTEMP      DO 71 iyyyy=1999,2012
C
	iyyyy=2013       !TEMP  for 2013
	jyr=iyyyy-(iyyyy/100)*100
	call blet2(jyr,AYR)
	infile(5:6)=AYR
	OPEN(12,FILE=INFILE,ACTION='READ')
C
	ryr=float(jyr)
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	ndnr=366
	                          ELSE
	IM(2)=28
	ndnr=365
	ENDIF

C cycle on month-to-month
CTEMP	DO jmn=1,12
	DO jmn=1,5   !TEMP for 2013
	nmax=im(jmn) 
C day-to-day cycle
   81 format(3X,3I2,6X,I2)
  181 format(3X,3I2,9X,F6.3)   ! Change to Rzp !!!!!!!!!!!!!
   82 format(3I2,40X,3(3X,F3.2))
	do jdy=1,nmax
C read Rzi
	read(11,181,end=73) iyrz,imnz,idyz,gecm ! read Rzi
C read daily GEC, GEC0, GEC1
	read(12,82,err=3,end=79) iyrg,imng,idyg,gec,gec0,gec1 ! read GEC
	if ((iyrz.eq.iyrg).and.(imnz.eq.imng).and.(idyz.eq.idyg)) then
	icntot=icntot+1
	cnt(jmn)=cnt(jmn)+1.
	delta=gecm-gec
	grzi(jmn)=grzi(jmn)+delta**2.
	grz1(jmn)=grz1(jmn)+delta
	grz2(jmn)=grz2(jmn)+abs(delta/gec)
	endif
	enddo     ! end daily cycle
	ENDDO			 ! end monthly cycle
   79	close(unit=12)

   71	CONTINUE ! END year-to-year cycle
   73	close(unit=11)
C
		OPEN(13,FILE=OUTFILE,access='APPEND')
C
	restot=0.
	restot1=0.
	restot2=0.
	do i=1,12
	restot=restot+grzi(i)
	restot1=restot1+grz1(i)
	restot2=restot2+grz2(i)
	cnttot=cnttot+cnt(i)
	if (cnt(i).gt.0.) then
	res(i)=sqrt(grzi(i)/cnt(i))							! RMSE, GECU
c-	res1(i)=sqrt((grzi(i)-(grz1(i)**2./cnt(i))/(cnt(i)-1.))) ! eps
	res1(i)=grz2(i)/cnt(i)
	res2(i)=grz2(i)/cnt(i)*100. ! delta %
	endif
	write(*,87) i,res(i),res1(i),res2(i),cnt(i)
	write(13,87) i,res(i),res1(i),res2(i),cnt(i)
	enddo
	restot=sqrt(restot/cnttot)
c-	restot1=sqrt((restot-(restot1**2./cnttot)/(cnttot-1.))) ! eps
      restot1=restot2/cnttot ! delta 
	restot2=restot2/cnttot*100. ! delta %
	write(*,87) jyr,restot,restot1,restot2,cnttot
	write(13,87) jyr,restot,restot1,restot2,cnttot

C
C
C ===================================
   87	format(1X,I2,3(1X,F9.6),1X,F5.0)
   88	format(12(1X,F6.0))

C
C ========================================
C

	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY ',infile
   2      CLOSE (unit=13)
	pause ' '
	STOP
	END
C
C ===============================================================
