C ===========================================================
	PROGRAM RMSGECRZ
C                                                             ! June 2013   
C RMSE for 12-months smothed GEC12c ~ R12; IG12 ~ R12 for 1958-2015
C
C
C   Input <r12-5815.txt  => infilerz   =R12
C         <gec12c-5815.txt> => infile =GEC12c
C or		          <ig12-5815.txt> => infile =IG12
C
C   Output
C   (1) outfile: rmsgecrz.txt
c
      DIMENSION	gec12(700),rz12(700)
      CHARACTER*35 infile,outfile,infilerz,txt
		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
C
C Start:
	outfile='rmsgecrx.txt'
	infilerz='r12-5815.txt'
CREM	infile='gec12c-5815.txt'
	infile='ig12-5815.txt'

	OPEN(13,FILE=OUTFILE,access='APPEND')

		CALL DATE_AND_TIME(DD,TT,ZZ)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT 
C
   80	format(1X,A4,2A2,1X,I3)
   78	format(1X,A4,2A2,5(1X,I3)) ! output rz3,...,rzp
C
C
C =========================================================
   77	format(1X,I4)
  172	OPEN(11,FILE=infilerz,ACTION='READ')
	OPEN(12,FILE=INFILE,ACTION='READ')
	read(11,*) txt
	read(11,*) txt
	read(12,*) txt
	read(12,*) txt
C
C Cycle on year-to-year 1999-2012:
C
C
	icnttot=0.

   81 format(3X,3I2,6X,I2)
  181 format(F5.1)   ! 
   82 format(3I2,40X,3(3X,F3.2))
C read Rzi
      DO iy=1,696
	icnttot=icnttot+1
	read(11,181,end=73) rz12(iy) ! read Rz12
	enddo
  73	close(unit=11)
      DO iy=1,icnttot
	read(12,181,end=74) gec12(iy) ! read GEC12
	enddo
  74	close(unit=12)
C read daily GEC, GEC0, GEC1
	rms=0.
	do jj=1,icnttot
	delta=gec12(jj)-rz12(jj)
c//	reldev=delta/gec
	rms=rms+delta**2. ! rmse
c//	grz2(jmn)=grz2(jmn)+gec     ! mean gec for the month
	enddo     ! end daily cycle
	rmse=sqrt(rms/icnttot)							! RMSE, GECU
	write(*,87) infile,infilerz,rmse
	write(13,87) infile,infilerz,rmse


   71	CONTINUE ! 
   	close(unit=13)
C
C
C
C
C ===================================
   87	format(1X,2A35,1X,F9.6)

C
C ========================================
C

	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY ',infile
   2     pause ' '
	STOP
	END
C
C ===============================================================
