      subroutine subfur4(fdat,fres)
C.......................................................Nov. 2011
C Furie expansion of diurnal foF2 using 96 prec. values 
      dimension fdat(0:96),fres(0:23)
	+,AI(5),BI(5),FUA(5,24),FUB(5,24)
	COMMON /BLFUR/FUA,FUB        ! Coeff. Furie for Ai, Bi
	PARAMETER (n=96,p=24.,pip=.2617994)
C
C Parameters:
c	PI=ATAN(1.0)*4.
c	P=24.
c	N=96
c	 pip=2*pi/p 
C
crem
C mean of 96 values:
	xav=0.
	do i=0,N-1
	xav=xav+fdat(i)
	enddo
	xav=xav/N
C
	do ii=1,5
	ai(ii)=0.
	bi(ii)=0.
	DO nn=1,4  ! 4 times repeat coefs. for Ai and Bi
	do j=1,24  ! set of coefficiens
	nj=j-1+(nn-1)*24
	xval=fdat(nj)
c
		ai(ii)=ai(ii)+xval*fua(ii,j)
	bi(ii)=bi(ii)+xval*fub(ii,j)
	enddo
	ENDDO
	ai(ii)=ai(ii)*2./N
	bi(ii)=bi(ii)*2./N
	enddo
C synthesis
		sum=xav
	do iut=0,23
	fres(iut)=xav
crem	do ii=1,5 ! sum of 5 terms
      do ii=1,4 ! sum of 4 terms
	fres(iut)=fres(iut)+ai(ii)*fua(ii,iut+1)
	&+bi(ii)*fub(ii,iut+1)
	 enddo
	enddo
  101	CONTINUE
crem	close (unit=15)
	RETURN
	end
