C*************************************************************   
CC 
      SUBROUTINE SUBGECTAU27(IYYYY,IMN,IDY,gtau)
CC-------------------------------------------------------------------
CC......................................................Oct. 2017
CC Ytau27=(1-tau)/(1-tau**n)*(F0+tau*F_1+tau**2*F_2...+tau**29*F_26) =smoothed GEC(tau) index
CC
CC       gecoYR.jtc  (preceding year: IYYYY-1)                              
CC       gecoYR.jtc  (given year: IYYYY)                              
c--------------------------------------------------------------------
c 
      DIMENSION lm(12)
     &,gecd(28)
      CHARACTER*4 YEAR,YEAR_pre
	CHARACTER*2 AYR,AYR_pre
      CHARACTER*80 infilegec
      COMMON /FIKP1/iyear_cur,imn_cur,idy_cur
      DATA LM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C START: 
      ipcnt=0 ! keep cnt -28,...,-1
C	tau=0.9623
      tau=exp(-1./26.)
         do k=1,28
       gecd(k)=0.
         enddo

C   Input file gecoYR.jtc starts from 1998.09:
C
        iy=iyyyy-1900

 770       z1=iy/4.0
        lm(2)=28
           if(iyyyy/4*4.eq.iyyyy) lm(2)=29
      if (iy.ge.100) then
      iyr=iy-100
      else
      iyr=iy
      endif
      call blet4(iyyyy,YEAR)
      iYYYY_pre=iYYYY-1
      call blet4(iYYYY_pre,YEAR_pre)
	AYR=YEAR(3:4)
	AYR_pre=YEAR_pre(3:4)
C
      idend=idy
C
C Day-of-year:
      ldaend=ndoy(iyyyy,imn,idend)       ! current day-of-year
C
      ipre=0
       if (ldaend.lt.27) then
        ipre=1    ! Include data for preceding year
       endif
C
      infilegec='gecoYR.jtc'  
C
10    FORMAT(3I2,42X,F4.2)

C
C-------------------------------------------------------------------------------
C Go to read current year file kpYEAR (avoid preceding year input) if current day IDY>81 day-of-year:
C
      if (ipre.eq.0) GOTO 203 !avoid input of preceding year file kpYEAR>>>>>
C
C-------------------------------------------------------------------------------
C Include Input file 'kpYEAR' for preceding year 
C
      infilegec(5:6)=AYR_pre  !!! Tamara

      OPEN(13,FILE=infilegec,STATUS='OLD',ERR=21)  
  201 continue

      READ(13,10,END=202) JYR,JMN,JDY,gec1 ! daily GEC
C
      gecd(28)=gec1
C Move data 1 line up:
      do k=1,27
      gecd(k)=gecd(k+1)
      enddo
      GOTO 201
  202 close(unit=13)
      ipcnt=27-ldaend   ! 
C
C For current year:
  203 infilegec(5:6)=AYR   !
C
      OPEN(13,FILE=infilegec,ERR=21)
C
C Read file kpyear for current year:
C
  204 continue  
C
      READ(13,10,err=29,END=30) JYR,JMN,JDY,gec1
      gecd(28)=gec1
C Move data 1 line up:
  140 do  k=1,27
      gecd(k)=gecd(k+1)
      enddo
C
      ipcnt=ipcnt+1

      if (ipcnt.lt.27) goto 204

      IF ((JYR.eq.IYR).and.(JMN.eq.IMN).and.(JDY.eq.idend)) then 
      goto 207
      ELSE
      ipcnt=ipcnt-1
      goto 204
      ENDIF

C data for 27 preceding days are collected                       
  207 gtau=0.0
      	gsum=0.
	STAU=1.
      icnv=0
C-      do k=1,26
      do k=27,1,-1
	gsum=gsum+stau*gecd(k)
	stau=stau*0.9623
	enddo
	coef=(1.-tau)/(1.-stau)
	gtau=coef*gsum
C
C
      goto 30
21      write(*,100)
100     format(1X,'Date is outside range of GEC indices file.')
      goto 30
  29  write(*,*) 'Error in input GEC-index file',infilegec 
C      pause ' '
      stop
  30  CLOSE(unit=13)
      RETURN
      END

C __________________________________________________________________________
C
