C ===========================================================
	PROGRAM EXTGECM5
C                                                             ! Dec. 2011   
C    GECm is defined as median for 5 days centered on 3rd day:
C    (1) GEC for i-2 day
C    (2) GEC for i-1 day
C    (3) GEC for i day (current day)
C    (4) GEC for i+1 day 
C    (5) GEC for i+2 day C
C   EXTRACT GEC FROM DAILY-HOURLY FILE  => infile2
c   EXTRACT 72 HOURLY "GEC" from d:\web\dat0\YR\ghyrmn.txt for 72 hours => infile1
C   Current day+2 prec.days
C   Send output results to d:\dat0\yr\gyrmn24.txt-q-model.= > outfile1
C   Send dlogGEC= log10(gec/GECm)*1000 => outfile2
c
      DIMENSION XRES(0:24),IM(12)
	+,IYMD(5,3),rx(0:24),IRES(0:24)
	+,XMED(0:24)
	+,DA(5,0:24) ! 4 prec_days+curr_day=5
      INTEGER*2 jyr,jmn,jdy,jyr_pre,jmn_pre,jdy_pre,kdy0,kdy1,kdy2
	+,idy1,idy2,jyr_nex,jmn_nex
      CHARACTER*128 infile0,infile1,infile2,outfile1,outfile2,txt
		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*4 YEAR,TTT
c-	CHARACTER*3 DOY
 	CHARACTER*2 ST,AMN,DD1,DD2,AYR,ADY,ADY0,ADY2,AUT
	+,PYR_pre,PMN_pre,PYR_nex,PMN_nex
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C Start:
C    
	st='gh'		! 
Ctemp	st='gp'		! temp

C
C read preceding 72 values: iyr,imn,idy,iut,fof2
C
C
		CALL DATE_AND_TIME(DD,TT,ZZ)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT 
	write(*,*) ' Enter YEAR' 								 
	read(*,*) YEAR											 
            TTT(1:4)=YEAR  
	AYR=YEAR(3:4)
	read(ayr,*) ryr
	jyr=int(ryr)
C
	write(*,*) ' Enter MN, DY1,DY2:' 				
	read(*,*) AMN,DD1,DD2							
	read(amn,*) rmn
	jmn=int(rmn)
C
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
C
	jyr_pre=JYR ! prec_year
 	jyr_nex=JYR ! year for next month
	jmn_pre=JMN-1 ! prec_month
 	jmn_nex=JMN+1 ! next month

C preceding month:
	if (jmn.eq.1) then
	jmn_pre=12				 ! prec_mn
	jyr_pre=jyr-1			 ! prec_yr
	if (jyr_pre.lt.0) jyr_pre=100+jyr_pre ! 1998 or 1999
	endif
C next month
	if (jmn.eq.12) then
	jmn_nex=1				 ! next_mn
	jyr_nex=jyr+1			 ! next_yr
	if (jyr_nex.gt.100) jyr_nex=jyr_nex-100 ! 2000 ...
	endif

	call blet2(jyr_pre,PYR_pre)  ! prec_yr
	call blet2(jmn_pre,PMN_pre)   ! prec_mn
	call blet2(jyr_nex,PYR_nex)  ! next_yr
	call blet2(jmn_nex,PMN_nex)   ! next_mn
C
C
	read(dd1,*) rdy1
	 idy1=int(rdy1)      
	read(dd2,*) rdy2
	 idy2=int(rdy2)      
C
  134  CONTINUE
c
C
	infile0='d:\web\dat0\YY\ghYRMN.txt'   ! preceding mn     
	infile0(13:14)=pyr_pre									
 	infile0(18:19)=pyr_pre									
	infile0(20:21)=pmn_pre
C										
	infile2=infile0               ! next mn
	infile2(13:14)=pyr_nex									
 	infile2(18:19)=pyr_nex									
	infile2(20:21)=pmn_nex									
C
    		write(*,*) pmn_pre,infile0
    		write(*,*) pmn_nex,infile2
C
      infile1=infile0  ! current mn
	infile1(17:17)='h'
	infile1(13:14)=ayr										
 	infile1(18:19)=ayr										
	infile1(20:21)=amn		
C
	write(*,*) amn,infile1
	outfile1=infile1
	outfile1(22:)='m.txt'	 ! 5 days centered median
	outfile2=outfile1
	outfile2(22:)='d.txt'	! deviations, %			
		OPEN(12,FILE=OUTFILE1,access='APPEND')
	OPEN(13,FILE=OUTFILE2,access='APPEND')
C =======================================================
C   Day-to=day cycle
  55	DO 77 kdy1=idy1,idy2
	call blet2(kdy1,ADY)
	iflag=0	 ! include current mn
c---	kdy1      ! current day 
	kdy0=kdy1-2
	if (kdy0.lt.0) then
	iflag=-1			  ! include prec.mn
	 kdy0=im(jmn_pre)+kdy0
	endif
C		
	kdy2=kdy1+2
	if (kdy2.gt.im(jmn)) then
	 kdy2=kdy2-im(jmn)
	iflag=1	   ! include next mn
	endif
c
	call blet2(kdy0,ADY0)
	call blet2(kdy2,ADY2)
C
	aut='00'
      	read(aut,*) ut
 	jut=int(ut)
C
C Avoid input of prec. month 
cc	if (iflag.ge.0) GOTO 130						 !!!
	 if(kdy1.gt.2) goto 130
C =======================================================
C
  117	FORMAT(3I2,1X,25(F4.0,1X))		   
C
C  day-to-day input for prec mon
C
	nndy=im(jmn_pre)	  ! prec. mn
C
C
		OPEN(10,FILE=INFILE0)
	do ir=1,4
	read(10,89,err=3,end=116) txt ! 4 extra lines
	enddo
	DO 9 jdy_pre=1,nndy  ! 
cc-	if (jdy_pre.lt.kdy0) goto 9 ! read only 2 last days

C	     DA(5,0:23) ! 4 prec_days+curr_day=5
	READ (10,117,ERR=3,END=116) iiy,iim,iid,(rx(k),k=0,24)
	 iymd(5,1)=iiy
	iymd(5,2)=iim
	iymd(5,3)=iid
	do k=0,24
	da(5,k)=rx(k)
	enddo
C move data up by 1 line
	do jj=1,4
	do j=1,3
	iymd(jj,j)=iymd(jj+1,j)
	enddo
	do k=0,24
	da(jj,k)=da(jj+1,k)
	enddo
	enddo
    9 CONTINUE
  116	close(unit=10)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C input for current mn
  130	continue
C
C
C
		OPEN(10,FILE=INFILE1)
	do ir=1,4
	read(10,89,err=3,end=116) txt ! 4 extra lines
	if (kdy1.eq.1) then 
	if (ir.eq.2) then
      WRITE(12,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT 
      WRITE(13,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT 
	else      
	write(12,89) txt
	write(13,89) txt
	endif
	endif
	enddo
	nn1=kdy0
	if (nn1.gt.kdy1) nn1=kdy1-2
	nndy=kdy1+2
	if (nndy.gt.im(jmn)) nndy=im(jmn)
	DO 99 jdy=1,nndy  !
C	     DA(5,0:23) ! 4 prec_days+curr_day=5
	READ (10,117,ERR=3,END=118)  iiy,iim,iid,(rx(k),k=0,24)
		if (jdy.lt.nn1) goto 99 ! only 1 mn
	 iymd(5,1)=iiy
	iymd(5,2)=iim
	iymd(5,3)=iid
	do k=0,24
	da(5,k)=rx(k)
	enddo

	if (jdy.lt.nndy) then

C move data up by 1 line
	
	do jj=1,4
	do j=1,3
	iymd(jj,j)=iymd(jj+1,j)
	enddo
	do k=0,24
	da(jj,k)=da(jj+1,k)
	enddo
	enddo
	endif
  99	continue
C
  118	close(unit=10)
C
C Avoid input of next month 
	if (iflag.le.0) GOTO 330						 !!!
C =======================================================
C  day-to-day input for next mon
C
	nndy=im(jmn_nex)	  ! next mn
C
C
		OPEN(10,FILE=INFILE2)
	do ir=1,4
	read(10,89,err=3,end=111) txt ! 4 extra lines
	enddo

	DO 189 jdy_nex=1,kdy2  ! 
C
	READ (10,117,ERR=3,END=111) iiy,iim,iid,(rx(k),k=0,24)
	if (jdy_nex.le.kdy2) then
C move data up by 1 line
	do jj=1,4
	do j=1,3
	iymd(jj,j)=iymd(jj+1,j)
	enddo
	do k=0,24
	da(jj,k)=da(jj+1,k)
	enddo
	enddo
	endif
	 iymd(5,1)=iiy
	iymd(5,2)=iim
	iymd(5,3)=iid
	do k=0,24
	da(5,k)=rx(k)
	enddo
  189 CONTINUE
  111	close(unit=10)
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  330	continue

C Median for 5 days:
      call smedian5(da,xmed)
C
 124	continue
C
C  median :
      do k=0,24
	ires(k)=nint(xmed(k))
	enddo
C
  135	kdy=kdy2	 ! current day 				   !???????????
C
C
C ==========================================================
c
   17	FORMAT(1X,'DOY='A3)
   19	format(A6)
   20	format(A13,A2,A1)
   21	format(A4)
   22	format(A2)
   23	format(15(F8.3))
   89	format(A128)
C
C
   1	continue
C ===================================
C Output of 'quiet' subfur results for current day++++++++++++++++++++++
   87	format(3A2,25(1X,I4))					!NEW
	write(12,87) ayr,amn,ady,(ires(k),k=0,24)  ! 5-days median
	write(*,87) ayr,amn,ady,(ires(k),k=0,24)
C
C  Output  deltaGEC,%
	do k=0,24
crem	xres(k)=alog10(da(5,k)/xres(k)*1000.) !dlogGEC
      xres(k)=(da(3,k)-xmed(k))/xmed(k)*100. !deltaGEC,%
	ires(k)=nint(xres(k))
	enddo
	write(13,87) ayr,amn,ady,(ires(k),k=0,24)	! deviation results
	write(*,87) ayr,amn,ady,(ires(k),k=0,24)

C ========================================
   11	continue

   77 continue                 ! go to the next day
C
	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
   2      CLOSE (unit=11)
	 CLOSE (unit=12)
	 CLOSE (unit=13)
	pause ' '
	STOP
	END
C
      subroutine blet2(ilet,alet2)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	INTEGER*2 ilet
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*2 alet2
CLjuba	a2='00'
	alet2='00'             !
	j10=ilet/10
	j1=ilet-j10*10
    5	do i=0,9
	if (j10.eq.i) then
	alet2(1:1)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet2(2:2)=IN(i)
	endif
	enddo 
	return
	end
C
C
      subroutine blet3(ilet,alet3)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*3 alet3
	a3='000'
C
	j100=ilet/100
	      j10=(ilet-j100*100)/10
	j1=ilet-j100*100-j10*10
    3	do i=0,9
		if (j100.eq.i) then
	alet3(1:1)=IN(i)
	endif
	enddo
    5	do i=0,9
	if (j10.eq.i) then
	alet3(2:2)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet3(3:3)=IN(i)
	endif
	enddo 
	return
	end
C
C ===============================================================
      integer function ndoy(iyr,imn,idy)
C
	       DIMENSION IM(12)
	integer*2 iyr,imn,idy
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	z1=iyr/4.0
      jz1=int(z1)*4
      IF(jz1.EQ.iyr) THEN
               IM(2)=29
        ELSE
                IM(2)=28
	       ENDIF
C Day-of-year LDA1
		mosum=0
      if(imn.gt.1) then
         do 1234 i=1,imn-1
1234    mosum=mosum+im(i)
         endif
      ndoy=mosum+idy	
	END FUNCTION
C ===============================================================
