C ===========================================================
	PROGRAM EXTGECM6a
C ............................................................Apr. 2012
C input :ehyymm.txt
C.............................................................Jan. 2012
C arrange calculation for storms YR,MN1,DY1 : MN2,DY2
C results: med and dlog for days  MN1,DY1+2...MN2,DY2-2
C                                                             ! Dec. 2011   
C    GECm is defined as median for 5 days centered on 3rd day:
C    (1) GEC for i-2 day
C    (2) GEC for i-1 day
C    (3) GEC for i day (current day)
C    (4) GEC for i+1 day 
C    (5) GEC for i+2 day C
C   EXTRACT GEC FROM DAILY-HOURLY FILE  => infile2
c   EXTRACT 72 HOURLY "GEC" from d:\web\dat0\YR\ghyrmn.txt for 72 hours => infile1
C   Current day+2 prec.days
C   Send output results to d:\dat0\yr\gyrmn24.txt-q-model.= > outfile1
C   Send dlogGEC= log10(gec/GECm)*1000 => outfile2
c
      DIMENSION XRES(0:23),IM(12)
	+,IYMD(5,3),rx(0:23),IRES(0:23)
	+,XMED(0:23)
	+,DA(5,0:23) ! 4 prec_days+curr_day=5
      INTEGER*2 jyr,jmn,jdy,jyr_pre,jmn_pre
	+,idy1,idy2,jyr_nex,jmn_nex,jmn1,jmn2,jdy_nex
      CHARACTER*128 infile1,outfile1,outfile2,txt
		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*4 YEAR,TTT
c-	CHARACTER*3 DOY
 	CHARACTER*2 ST,AMN,DD1,DD2,AYR,ADY,AUT
	+,PYR_pre,PMN_pre,PYR_nex,PMN_nex,AMN1,AMN2
	+,AMN_nex,ADY_nex
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C Start:
C    
	st='gh'		! 
Ctemp	st='gp'		! temp

C
C read preceding 72 values: iyr,imn,idy,iut,fof2
C
C
		CALL DATE_AND_TIME(DD,TT,ZZ)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT 
	write(*,*) ' Enter YEAR' 								 
	read(*,*) YEAR											 
            TTT(1:4)=YEAR  
	AYR=YEAR(3:4)
	read(ayr,*) ryr
	jyr=int(ryr)
C
	write(*,*) ' Enter AMN1,DY1,AMN2,DY2:' 				
	read(*,*) AMN1,DD1,AMN2,DD2							
      amn=amn1
	read(amn1,*) rmn1
	jmn1=int(rmn1)
	jmn=jmn1
	read(amn2,*) rmn2
	jmn2=int(rmn2)
C
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
C
	read(dd1,*) rdy1
	 idy1=int(rdy1)      
	read(dd2,*) rdy2
	 idy2=int(rdy2)      
C
	lda1=ndoy(jyr,jmn1,idy1)
	lda2=ndoy(jyr,jmn2,idy2)

C
	jyr_pre=JYR ! prec_year
 	jyr_nex=JYR ! year for next month
	jmn_pre=JMN1 ! prec_month
 	jmn_nex=JMN2 ! next month
	goto 134 ! ===========================>

  134  CONTINUE

	call blet2(jyr_pre,PYR_pre)  ! prec_yr
	call blet2(jmn_pre,PMN_pre)   ! prec_mn
	call blet2(jyr_nex,PYR_nex)  ! next_yr
	call blet2(jmn_nex,PMN_nex)   ! next_mn
C
C
C
c
C
	infile1='d:\web\dat0\YY\ehYRMN.txt'   ! preceding mn     
	infile1(13:14)=pyr_pre									
 	infile1(18:19)=pyr_pre									
	infile1(20:21)=pmn_pre
C										
C
C
	infile1(17:17)='h'
C
	write(*,*) amn,infile1
	outfile1=infile1
	outfile1(22:)='m.txt'	 ! 5 days centered median
	outfile2=outfile1
	outfile2(22:)='d.txt'	! deviations, %			
		OPEN(12,FILE=OUTFILE1,access='APPEND')
	OPEN(13,FILE=OUTFILE2,access='APPEND')
C =======================================================
  117	FORMAT(3I2,1X,24(F4.0,1X))		   
  161	FORMAT(A128)		   
C   Day-to=day cycle
crem  55	DO 77 kdy1=idy1,idy2
  55	DO 77 kdy=lda1,lda2-2
	nn=0
      call submmdd(kdy,jyr,jmn,jdy)
	call blet2(jdy,ADY)
	kdy2=kdy+2
	call submmdd(kdy2,jyr,jmn_nex,jdy_nex)
	if (jmn.eq.jmn1) then
	infile1(20:21)=amn1
	else
	infile1(20:21)=amn2
	endif

 57		OPEN(10,FILE=INFILE1)
C Read 4 extra lines
	do jj=1,4
	read(10,161) txt
	enddo
C
  56	READ (10,117,ERR=3,END=118)  iiy,iim,iid,(rx(k),k=0,23)
		if ((iid.lt.jdy).and.(nn.eq.0)) goto 56 ! 
	nn=nn+1
	 iymd(5,1)=iiy
	iymd(5,2)=iim
	iymd(5,3)=iid
	do k=0,23
	da(5,k)=rx(k)
	enddo
	if (nn.eq.5) goto 118          ! med. dev. calculation
C move data up by 1 line
	
	do jj=1,4
	do j=1,3
	iymd(jj,j)=iymd(jj+1,j)
	enddo
	do k=0,23
	da(jj,k)=da(jj+1,k)
	enddo
	enddo
	if ((nn.lt.5).and.(iid.lt.im(iim))) then
	goto 56
	else
	close(unit=10)
	infile1(20:21)=amn2
	jdy=1
	goto 57
	endif

c	call blet2(kdy0,ADY0)
c	call blet2(kdy2,ADY2)
C
	aut='00'
      	read(aut,*) ut
 	jut=int(ut)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  130	continue
C
C
  99	continue
C
  118	close(unit=10)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  330	continue
	call blet2(jdy_nex,ADY_nex)
	call blet2(jmn_nex,AMN_nex)
C Median for 5 days:
      call smedian5(da,xmed)
C
 124	continue
C
C  median :
      do k=0,23
	ires(k)=nint(xmed(k))
	enddo
C
c?????  135	kdy=kdy2	 ! current day 				   !???????????
C
C
C ==========================================================
c
   17	FORMAT(1X,'DOY='A3)
   19	format(A6)
   20	format(A13,A2,A1)
   21	format(A4)
   22	format(A2)
   23	format(15(F8.3))
   89	format(A128)
C
C
   1	continue
C ===================================
C Output of 'quiet' subfur results for current day++++++++++++++++++++++
   87	format(3A2,24(1X,I4))					!NEW
	if (kdy.lt.lda2-3) then
	write(12,87) ayr,amn_nex,ady_nex,(ires(k),k=0,23)  ! 5-days median
	write(*,87) ayr,amn_nex,ady_nex,(ires(k),k=0,23)
C
C  Output  deltaGEC,%
	do k=0,23
crem	xres(k)=alog10(da(5,k)/xres(k)*1000.) !dlogGEC
      xres(k)=(da(3,k)-xmed(k))/xmed(k)*100. !deltaGEC,%
	ires(k)=nint(xres(k))
	enddo
	write(13,87) ayr,amn_nex,ady_nex,(ires(k),k=0,23)	! deviation results
	write(*,87) ayr,amn_nex,ady_nex,(ires(k),k=0,23)
	endif
C ========================================
   11	continue

   77 continue                 ! go to the next day
C
	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
   2      CLOSE (unit=11)
	 CLOSE (unit=12)
	 CLOSE (unit=13)
	pause ' '
	STOP
	END
C
