C ===========================================================
	PROGRAM EXTGECM7
C.............................................................Jan. 2012
C arrange calculation for storms YR,MN1,DY1 : MN2,DY2
C results: med and dlog for days  MN1,DY1+2...MN2,DY2-2
C                                                             ! Dec. 2011   
C    GECm is defined as median for 5 days centered on 3rd day:
C    (1) GEC for i-2 day
C    (2) GEC for i-1 day
C    (3) GEC for i day (current day)
C    (4) GEC for i+1 day 
C    (5) GEC for i+2 day C
C   EXTRACT GEC FROM DAILY-HOURLY FILE  => infile2
c   EXTRACT 72 HOURLY "GEC" from d:\web\dat0\YR\ghyrmn.txt for 72 hours => infile1
C   Current day+2 prec.days
C   Send output results to d:\dat0\yr\gyrmn24.txt-q-model.= > outfile1
C   Send dlogGEC= log10(gec/GECm)*1000 => outfile2
c
      DIMENSION XRES(0:24),IM(12)
	+,IYMD(5,3),rx(0:24),IRES(0:24)
	+,XMED(0:24)
	+,DA(5,0:24) ! 4 prec_days+curr_day=5
      INTEGER*2 jyr,jmn,jdy,jyr_pre,jmn_pre
	+,idy1,idy2,jyr_nex,jmn_nex,jmn1,jmn2,jdy_nex
      CHARACTER*128 infile1,outfile1,outfile2,txt
		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*4 YEAR,TTT
c-	CHARACTER*3 DOY
 	CHARACTER*2 ST,AMN,DD1,DD2,AYR,ADY,AUT
	+,PYR_pre,PMN_pre,PYR_nex,PMN_nex,AMN1,AMN2
	+,AMN_nex,ADY_nex
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C Start:
C    
	st='gh'		! 
Ctemp	st='gp'		! temp

C
C read preceding 72 values: iyr,imn,idy,iut,fof2
C
C
		CALL DATE_AND_TIME(DD,TT,ZZ)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT 
	write(*,*) ' Enter YEAR' 								 
	read(*,*) YEAR											 
            TTT(1:4)=YEAR  
	AYR=YEAR(3:4)
	read(ayr,*) ryr
	jyr=int(ryr)
C
	write(*,*) ' Enter AMN1,DY1,DY2:' 				
	read(*,*) AMN1,DD1,DD2							
      amn=amn1
	amn2=amn1
	read(amn1,*) rmn1
	jmn1=int(rmn1)
	jmn=jmn1
	read(amn2,*) rmn2
	jmn2=int(rmn2)
C++
 	if (jmn1.gt.1) then
 	jmnp=jmn1-1			 ! prec_mn
	jyrp=jyr
	else
	jmnp=12				 ! prec_mn
	jyrp=jyr-1			 ! prec_yr
	if (jyrp.lt.0) jyrp=100+jyrp ! 1998 or 1999
	endif
c//	call blet2(jyrp,PYR)  ! prec_yr
c//      call blet2(jmnp,PMN)  ! prec_mn
C
 	if (jmn2.lt.12) then
 	jmnn=jmn2+1			 ! next_mn
	jyrn=jyr
	else
	jmnn=1				 ! next_mn
	jyrn=jyr+1			 ! next_yr
	if (jyrn.ge.100) jyrn=jyrn-100 ! 2000...
	endif
c//	call blet2(jyrn,BYR)  ! next_yr
c//      call blet2(jmnn,BMN)  ! next_mn
C
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
C
	read(dd1,*) rdy1
	 idy1=int(rdy1)      
	read(dd2,*) rdy2
	 idy2=int(rdy2)      
C
	lda1=ndoy(jyr,jmn1,idy1)
	lda2=ndoy(jyr,jmn2,idy2)

C
	jyr_pre=JYRP ! prec_year
 	jyr_nex=JYRN ! year for next month
	jmn_pre=JMNP ! prec_month
 	jmn_nex=JMNN ! next month
c//	goto 134 ! ===========================>

  134  CONTINUE

	call blet2(jyr_pre,PYR_pre)  ! prec_yr
	call blet2(jmn_pre,PMN_pre)   ! prec_mn
	call blet2(jyr_nex,PYR_nex)  ! next_yr
	call blet2(jmn_nex,PMN_nex)   ! next_mn
C
C
C
c
C
	infile1='d:\web\dat0\YY\ghYRMN.txt'   ! preceding mn     
	infile1(13:14)=pyr_pre									
 	infile1(18:19)=pyr_pre									
	infile1(20:21)=pmn_pre
C										
C
C
	infile1(17:17)='h'
C
C	  Read data for 2 last days of prec.month
116	FORMAT(A128)
	write(*,*) amn,infile1
		OPEN(10,FILE=INFILE1)
C
	do m=1,4      ! extra lines
	READ (10,116,ERR=3,END=115)	txt
	enddo
	 mend=im(jmn_pre)
		nn=0
	do 114 m=1,mend
  113	READ (10,117,ERR=3,END=115)  iiy,iim,iid,(rx(k),k=0,24)
	if (m.le.mend-2) goto 114 ! read only 2 last days of month
	nn=nn+1
	 iymd(5,1)=iiy
	iymd(5,2)=iim
	iymd(5,3)=iid
	do k=0,24
	da(5,k)=rx(k)
	enddo
c//	if (nn.eq.5) goto 118          ! med. dev. calculation
C move data up by 1 line
	do jj=1,4
	do j=1,3
	iymd(jj,j)=iymd(jj+1,j)
	enddo
	do k=0,24
	da(jj,k)=da(jj+1,k)
	enddo
	enddo
  114	continue           ! end reading of prec. month
  115	close(unit=10)
C
C current month
	infile1(13:14)=AYR									
 	infile1(18:19)=AYR									
	infile1(20:21)=AMN

	outfile1=infile1
	outfile1(22:)='m.txt'	 ! 5 days centered median
	outfile2=outfile1
	outfile2(22:)='d.txt'	! deviations, %			
		OPEN(12,FILE=OUTFILE1,access='APPEND')
	OPEN(13,FILE=OUTFILE2,access='APPEND')
C =======================================================
  117	FORMAT(3I2,1X,25(F4.0,1X))		   
C   Day-to=day cycle for current month:
c//  55	DO 77 kdy1=idy1,idy2
c//  55	DO 77 kdy=lda1,lda2-2
	nndy=im(jmn)
  55	DO 77 kdy=lda1,lda2
c//	nn=0
      call submmdd(kdy,jyr,jmn,jdy)
	call blet2(jdy,ADY)
	kdy2=kdy+2
	call submmdd(kdy2,jyr,jmn_nex,jdy_nex)
	if (kdy.eq.lda1) then
	ndy=jdy
	else
	ndy=jdy_nex
	endif
	if (kdy.lt.lda2-1) then
c//	if (jdy.le.nndy) then
	infile1(20:21)=amn1
	iflag=0
	else
	call blet2(jmn_nex,AMN_NEX)
	infile1(20:21)=amn_nex
	iflag=0
	if (jmn_nex.eq.1) then
		infile1(13:14)=PYR_NEX
  	infile1(18:19)=PYR_NEX
	endif
	endif
 57		OPEN(10,FILE=INFILE1)
      if (iflag.eq.0) then
	do m=1,4      ! extra lines
	READ (10,116,ERR=3,END=115)	txt
	enddo
	iflag=1
	endif
C
  56	READ (10,117,ERR=3,END=118)  iiy,iim,iid,(rx(k),k=0,24)
c//		if ((iid.lt.jdy).and.(nn.eq.0)) goto 56 ! 
		if (iid.lt.ndy) goto 56 ! 
      if (iid.ge.ndy) then
	nn=nn+1
	endif
	 iymd(5,1)=iiy
	iymd(5,2)=iim
	iymd(5,3)=iid
	do k=0,24
	da(5,k)=rx(k)
	enddo
	if (nn.eq.5) goto 118          ! med. dev. calculation
C move data up by 1 line
	
	do jj=1,4
	do j=1,3
	iymd(jj,j)=iymd(jj+1,j)
	enddo
	do k=0,24
	da(jj,k)=da(jj+1,k)
	enddo
	enddo
	if ((nn.lt.5).and.(iid.lt.im(iim))) then
	goto 56
	else
	close(unit=10)
c//	infile1(20:21)=amn2
	if (jmn_nex.eq.1) then
		infile1(13:14)=PYR_NEX
  	infile1(18:19)=PYR_NEX
	endif
  	infile1(20:21)=PMN_NEX
	jdy=1
	ndy=jdy_nex
	iflag=0
	goto 57
	endif

c	call blet2(kdy0,ADY0)
c	call blet2(kdy2,ADY2)
C
	aut='00'
      	read(aut,*) ut
 	jut=int(ut)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  130	continue
C
C
  99	continue
C
  118	close(unit=10)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  330	continue
	call blet2(jdy_nex,ADY_nex)
	call blet2(jmn_nex,AMN_nex)
C Median for 5 days:
      call smedian5(da,xmed)
C
 124	continue
C
C  median :
      do k=0,24
	ires(k)=nint(xmed(k))
	enddo
C
c?????  135	kdy=kdy2	 ! current day 				   !???????????
C
C
C ==========================================================
c
   17	FORMAT(1X,'DOY='A3)
   19	format(A6)
   20	format(A13,A2,A1)
   21	format(A4)
   22	format(A2)
   23	format(15(F8.3))
   89	format(A128)
C
C
   1	continue
C ===================================
C Output of 'quiet' subfur results for current day++++++++++++++++++++++
   87	format(3A2,25(1X,I4))					!NEW
c//	if (kdy.lt.lda2-3) then
	write(12,87) ayr,amn,ady,(ires(k),k=0,24)  ! 5-days median
	write(*,87) ayr,amn,ady,(ires(k),k=0,24)
C
C  Output  deltaGEC,%
	do k=0,24
crem	xres(k)=alog10(da(5,k)/xres(k)*1000.) !dlogGEC
      xres(k)=(da(3,k)-xmed(k))/xmed(k)*100. !deltaGEC,%
	ires(k)=nint(xres(k))
	enddo
	write(13,87) ayr,amn,ady,(ires(k),k=0,24)	! deviation results
	write(*,87) ayr,amn,ady,(ires(k),k=0,24)
c//	endif
C ========================================
   11	continue
	nn=4
C put data for 2 prec. days in jj=3 & jj=4
	do jj=1,4
	do j=1,3
	iymd(jj,j)=iymd(jj+1,j)
	enddo
	do k=0,24
	da(jj,k)=da(jj+1,k)
	enddo
	enddo
   77 continue                 ! go to the next day
C
	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
   2      CLOSE (unit=11)
	 CLOSE (unit=12)
	 CLOSE (unit=13)
	pause ' '
	STOP
	END
C
      subroutine blet2(ilet,alet2)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	INTEGER*2 ilet
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*2 alet2
CLjuba	a2='00'
	alet2='00'             !
	j10=ilet/10
	j1=ilet-j10*10
    5	do i=0,9
	if (j10.eq.i) then
	alet2(1:1)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet2(2:2)=IN(i)
	endif
	enddo 
	return
	end
C
C
      subroutine blet3(ilet,alet3)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*3 alet3
	a3='000'
C
	j100=ilet/100
	      j10=(ilet-j100*100)/10
	j1=ilet-j100*100-j10*10
    3	do i=0,9
		if (j100.eq.i) then
	alet3(1:1)=IN(i)
	endif
	enddo
    5	do i=0,9
	if (j10.eq.i) then
	alet3(2:2)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet3(3:3)=IN(i)
	endif
	enddo 
	return
	end
C
C ===============================================================
      integer function ndoy(iyr,imn,idy)
C
	       DIMENSION IM(12)
	integer*2 iyr,imn,idy
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	z1=iyr/4.0
      jz1=int(z1)*4
      IF(jz1.EQ.iyr) THEN
               IM(2)=29
        ELSE
                IM(2)=28
	       ENDIF
C Day-of-year LDA1
		mosum=0
      if(imn.gt.1) then
         do 1234 i=1,imn-1
1234    mosum=mosum+im(i)
         endif
      ndoy=mosum+idy	
	END FUNCTION
C ===============================================================
