C ===========================================================
	PROGRAM EXTGECM9
C.............................................................Mar.2012
C Add output of Median for 7 days (6 prec.+1 curr. days) 
C     dev. from Median for 7 days :p.txt
C.............................................................Jan. 2012
C arrange calculation for storms YR,MN1,DY1 : MN2,DY2
C results: med and dlog for days  MN1,DY1+2...MN2,DY2-2
C                                                             ! Dec. 2011   
C    GECm is defined as median for 5 days centered on 3rd day:
C    (0) reserved for move up 
C    (1) GEC for i-6 day
C    (2) GEC for i-5 day
C    (3) GEC for i-4 day
C    (4) GEC for i-3 day
C    (5) GEC for i-2 day
C    (6) GEC for i-1 day
C    (7) GEC for i day (current day)
C   EXTRACT GEC FROM DAILY-HOURLY FILE  => infile2
c   EXTRACT 72 HOURLY "GEC" from d:\web\dat0\YR\ghyrmn.txt for 72 hours => infile1
C   Current day+2 prec.days
C   Send output results to d:\dat0\yr\gyrmn24.txt-q-model.= > outfile1
C   Send dlogGEC= log10(gec/GECm)*1000 => outfile2
c
      DIMENSION XRES(0:23),IM(12)
	+,IYMD(0:7,3),rx(0:23),IRES(0:23)
	+,XMED(0:23)
	+,DA(0:7,0:24) ! 6 prec_days+curr_day=7
      INTEGER*2 jyr,jmn,jdy,jyr_pre,jmn_pre
	+,idy1,idy2,jmn1
      CHARACTER*128 infile1,outfile1,outfile2,txt
		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*4 YEAR,TTT
c-	CHARACTER*3 DOY
 	CHARACTER*2 ST,AMN,DD1,DD2,AYR,ADY
	+,PYR_pre,PMN_pre,AMN1,AMN2
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C Start:
C    
	st='gh'		! 
Ctemp	st='gp'		! temp

C
C read preceding 72 values: iyr,imn,idy,iut,fof2
C
C
		CALL DATE_AND_TIME(DD,TT,ZZ)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT 
	write(*,*) ' Enter YEAR' 								 
	read(*,*) YEAR											 
            TTT(1:4)=YEAR  
	AYR=YEAR(3:4)
	read(ayr,*) ryr
	jyr=int(ryr)
C
	write(*,*) ' Enter AMN1,DY1,DY2:' 				
	read(*,*) AMN1,DD1,DD2							
      amn=amn1
	amn2=amn1
	read(amn1,*) rmn1
	jmn1=int(rmn1)
	jmn=jmn1
C++
 	if (jmn1.gt.1) then
 	jmnp=jmn1-1			 ! prec_mn
	jyrp=jyr
	else
	jmnp=12				 ! prec_mn
	jyrp=jyr-1			 ! prec_yr
	if (jyrp.lt.0) jyrp=100+jyrp ! 1998 or 1999
	endif
C
C
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
C
	read(dd1,*) rdy1
	 idy1=int(rdy1)      
	read(dd2,*) rdy2
	 idy2=int(rdy2)      
C
	lda1=ndoy(jyr,jmn1,idy1)
	lda2=ndoy(jyr,jmn1,idy2)

C
	jyr_pre=JYRP ! prec_year
	jmn_pre=JMNP ! prec_month
c//	goto 134 ! ===========================>

  134  CONTINUE

	call blet2(jyr_pre,PYR_pre)  ! prec_yr
	call blet2(jmn_pre,PMN_pre)   ! prec_mn
C
C
C
c
C
	infile1='d:\web\dat0\YY\ghYRMN.txt'   ! preceding mn     
	infile1(13:14)=pyr_pre									
 	infile1(18:19)=pyr_pre									
	infile1(20:21)=pmn_pre
C										
C
C
	infile1(17:17)='h'
C
C	  Read data for 6 last days of prec.month
116	FORMAT(A128)
	write(*,*) amn,infile1
		OPEN(10,FILE=INFILE1)
C
      do m=1,4      ! extra lines
	READ (10,116,ERR=3,END=115)	txt
	enddo
	 mend=im(jmn_pre)
		nn=0
	do 114 m=1,mend
  113	READ (10,117,ERR=3,END=115)  iiy,iim,iid,(rx(k),k=0,23)
	if (m.le.mend-6) goto 114 ! read only 6 last days of month
	nn=nn+1
	 iymd(7,1)=iiy
	iymd(7,2)=iim
	iymd(7,3)=iid
	do k=0,23
	da(7,k)=rx(k)
	enddo
c//	if (nn.eq.5) goto 118          ! med. dev. calculation
C move data up by 1 line
	do jj=0,6
	do j=1,3
	iymd(jj,j)=iymd(jj+1,j)
	enddo
	do k=0,23
	da(jj,k)=da(jj+1,k)
	enddo
	enddo
  114	continue           ! end reading of prec. month
  115	close(unit=10)
C
C current month
	infile1(13:14)=AYR									
 	infile1(18:19)=AYR									
	infile1(20:21)=AMN

	outfile1=infile1
	outfile1(22:)='q.txt'	 ! 7 (6 prec.+curr.) days median
	outfile2=outfile1
	outfile2(22:)='p.txt'	! deviations, % from median-7. days
		OPEN(12,FILE=OUTFILE1,access='APPEND')
	OPEN(13,FILE=OUTFILE2,access='APPEND')
C =======================================================
  117	FORMAT(3I2,1X,24(F4.0,1X))		   
C   Day-to=day cycle for current month:
c//  55	DO 77 kdy=lda1,lda2-2
	nndy=im(jmn)
	infile1(20:21)=amn1
	iflag=0
		OPEN(10,FILE=INFILE1)
  55	DO 77 kdy=lda1,lda2
      call submmdd(kdy,jyr,jmn,jdy)
	call blet2(jdy,ADY)
	if (kdy.eq.lda1) then
	ndy=jdy
	endif
C
C Start reading current month
C
 57	continue
      if (iflag.eq.0) then
	do m=1,4      ! extra lines
	READ (10,116,ERR=3,END=115)	txt
	enddo
	iflag=1
	endif
C
  56	READ (10,117,ERR=3,END=118)  iiy,iim,iid,(rx(k),k=0,23)
c//		if ((iid.lt.jdy).and.(nn.eq.0)) goto 56 ! 
		if (iid.lt.ndy) goto 56 ! 
      if (iid.ge.ndy) then
	nn=nn+1
	endif
	 iymd(7,1)=iiy
	iymd(7,2)=iim
	iymd(7,3)=iid
	do k=0,23
	da(7,k)=rx(k)
	enddo
	if (nn.eq.7) goto 330          ! med. dev. calculation
C move data up by 1 line
	
	do jj=0,6
	do j=1,3
	iymd(jj,j)=iymd(jj+1,j)
	enddo
	do k=0,23
	da(jj,k)=da(jj+1,k)
	enddo
	enddo
	if ((nn.lt.7).and.(iid.lt.im(iim))) then
	goto 56
	else
	goto 330
	endif

C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C
  99	continue
C
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  330	continue
C Median for 7 days:
      call smedian7(da,xmed)
C
 124	continue
C
C  median :
      do k=0,24
	ires(k)=nint(xmed(k))
	enddo
C
c?????  135	kdy=kdy2	 ! current day 				   !???????????
C
C
C ==========================================================
c
   17	FORMAT(1X,'DOY='A3)
   19	format(A6)
   20	format(A13,A2,A1)
   21	format(A4)
   22	format(A2)
   23	format(15(F8.3))
   89	format(A128)
C
C
   1	continue
C ===================================
C Output of 'quiet' subfur results for current day++++++++++++++++++++++
   87	format(3A2,24(1X,I4))					!NEW
	write(12,87) ayr,amn,ady,(ires(k),k=0,23)  ! 7-days median
	write(*,87) ayr,amn,ady,(ires(k),k=0,23)
C  Output  deltaGEC,%
	do k=0,23
      xres(k)=(da(7,k)-xmed(k))/xmed(k)*100. !deltaGEC,%
	ires(k)=nint(xres(k))
	enddo
	write(13,87) ayr,amn,ady,(ires(k),k=0,23)	! deviation results
	write(*,87) ayr,amn,ady,(ires(k),k=0,23)
C ========================================
   11	continue
	nn=6
C put data for 6 prec. days in jj=1 & jj=6
	do jj=0,6
	do j=1,3
	iymd(jj,j)=iymd(jj+1,j)
	enddo
	do k=0,23
	da(jj,k)=da(jj+1,k)
	enddo
	enddo
   77 continue                 ! go to the next day
  118	close(unit=10)  !?????????????????????

C
	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
   2      CLOSE (unit=11)
	 CLOSE (unit=12)
	pause ' '
	STOP
	END
C
      subroutine blet2(ilet,alet2)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	INTEGER*2 ilet
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*2 alet2
CLjuba	a2='00'
	alet2='00'             !
	j10=ilet/10
	j1=ilet-j10*10
    5	do i=0,9
	if (j10.eq.i) then
	alet2(1:1)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet2(2:2)=IN(i)
	endif
	enddo 
	return
	end
C
C
      subroutine blet3(ilet,alet3)
c     nn=1,2,3,4 

	CHARACTER*1 IN(0:9)
	DATA IN/'0','1','2','3','4','5','6','7','8','9'/
	CHARACTER*3 alet3
	a3='000'
C
	j100=ilet/100
	      j10=(ilet-j100*100)/10
	j1=ilet-j100*100-j10*10
    3	do i=0,9
		if (j100.eq.i) then
	alet3(1:1)=IN(i)
	endif
	enddo
    5	do i=0,9
	if (j10.eq.i) then
	alet3(2:2)=IN(i)
	endif
	enddo
   7	do i=0,9 
     	if (j1.eq.i) then
 	alet3(3:3)=IN(i)
	endif
	enddo 
	return
	end
C
C ===============================================================
      integer function ndoy(iyr,imn,idy)
C
	       DIMENSION IM(12)
	integer*2 iyr,imn,idy
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	z1=iyr/4.0
      jz1=int(z1)*4
      IF(jz1.EQ.iyr) THEN
               IM(2)=29
        ELSE
                IM(2)=28
	       ENDIF
C Day-of-year LDA1
		mosum=0
      if(imn.gt.1) then
         do 1234 i=1,imn-1
1234    mosum=mosum+im(i)
         endif
      ndoy=mosum+idy	
	END FUNCTION
C ===============================================================
