C ===========================================================
	PROGRAM FITGECM2
C                     
C Monthly mean Rz (data & proxy) and GECp                                ! June 2013   
C 
C
C   Fitting daily-mean GEC, for 12 months @ 40 grids for Rzi=1,2,...,40 (Rzi>40 joint to Rzi=40) 
C   Input 
C         <fitgecmp.txt> => infilerz
C
C   Output
C   (1) outfile: FITgecm2.txt = infilerz+gecfit(Rzp) 
c
      DIMENSION IM(12),res1(12),res2(12)
      INTEGER*2 jyr,jmn,jdy
	INTEGER*4 iyyyy
      CHARACTER*128 outfile,infilerz
		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
 	CHARACTER*2 AYR,AMN,ADY
	CHARACTER*4 AYEAR
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C Start:
	outfile='fitgecm2.txt'
		OPEN(12,FILE=OUTFILE)	 ! 
C
		CALL DATE_AND_TIME(DD,TT,ZZ)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT 
C
   80	format(1X,I4)
C

C  Read Rz, Rzi and GECi lines :
	infilerz='fitgecmp.txt'
	OPEN(11,FILE=INFILERZ)
C
C Cycle on year-to-year 1850-2012:
       DO 71 iyyyy=1850,2012
C
C
	ryr=float(iyyyy)
	if(int(ryr/4.)*4.eq.iyyyy) THEN 
 	im(2)=29
	ndnr=366
	                          ELSE
	IM(2)=28
	ndnr=365
	ENDIF

C cycle on month-to-month
	DO kmn=1,12
	nmax=im(kmn) 
C day-to-day cycle
   81 format(1X,A4,2A2,1X,I3,1X,I3)
   82 format(1X,A4,2A2,1X,F3.0,1X,F3.0,1X,F6.3)
	res1(kmn)=0.
	res2(kmn)=0.
	do kdy=1,nmax
C read Rzi
	read(11,82,end=73) ayear,amn,ady,rz,rzi,geci ! read Rz, Rzi, GECi 
	ayr=ayear(3:4)
	read(ayr,*) xyr
	jyr=int(xyr)
	read(amn,*) xmn
	jmn=int(xmn)
	read(ady,*) xdy
	jdy=int(xdy)
c-	rzi=float(irzi)
c-	if (rzi.gt.40.) rzi=40.
C Day-of-year:
	lda=ndoy(jyr,jmn,jdy) 
c-	days=float(lda)/ndnr*360. ! Day-of-year scaled to 360.
C 12 monthly coefficients refers to 1:360 days:
C days=15,45,75,105,135,165,195,225,255,285,315,345
C month 1  2  3  4   5   6   7   8   9   10  11  12
c-	ymon=0.5+days/30.
c-	call subgecrz(ymon,rzi,geci)
	res1(kmn)=res1(kmn)+geci
	res2(kmn)=res2(kmn)+rz
	enddo     ! end daily cycle

	res1(kmn)=res1(kmn)/nmax
	res2(kmn)=res2(kmn)/nmax
	write(*,83)	ayear,amn,res2(kmn),res1(kmn)
	write(12,83) ayear,amn,res2(kmn),res1(kmn)
	ENDDO			 ! end monthly cycle
   71	CONTINUE ! END year-to-year cycle
   73	close(unit=11)
C
   83 format(1X,A4,A2,1X,F4.0,1X,F6.3)
C ========================================
C
	goto 2
3	 write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
   2      CLOSE (unit=12)
	pause ' '
	STOP
	END
C
C ===============================================================
