C........................................................July 2023
C 15-min GEC
C........................................................May 2023
C xy='u' (uqrg),'r' (uadg)-real time. Produce GEC.
C
C T.L.Gulyaeva...........................................July 2011
C 
      PROGRAM MAPGEC6upc15
C----------------------------------------------------------------
C Select all latitudes: res1=87.5N,85N,,,,5N,00,5S,...,87.5S 
C                        
C each line in input file for TEC at:[-180, -165,...0,15E,30E,...,165E]
C separate files for UT=0,1,2,3,...23hUT
C Produce GYRMNDY.res files 	 (UT GEC)
C output array: res(72)
C program for EXTRACTING FROM "uhrgdoy0.iYR" ionex_TEC data 
C Output: GYRMNDY.res data for day into annual file gecyr.br
C all results for given year, includint YRMNDY  GEC(t), t=0,1,...,23 UT + daily mean, GEC(t)=GEC/1.E+32, GECU
C outfile='gecyr.br' 
C if input file jplg (2h UT step), linear interpolation is applied for 1h UT results
C
C*********TEST
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*80 INFILE,OUTFILE,infcoef,outyear
	CHARACTER*4 AYEAR
	CHARACTER*131 txt
	CHARACTER*1 xy
C++	+,ninp
	character*2 ayr,amn,ady,aut,amm
	integer iyr,imn,iut
	dimension itxx(73),im(12)
	+,gecoef(71)
	dimension res(72),rgec(0:96),igec(0:96),iroc(0:95)
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C-      xy='u'    ! uqrg
      xy='r'    ! uadg
C++	ninp='8'
       infcoef='geccoef2h.txt'	! Manuel coefs
	OPEN(10,file=infcoef,action='READ')
	DO kk=1,71
	read(10,*,end=19) fi,coefi
	GECOEF(kk)=coefi*1.0E+06
	ENDDO
   19	close(10)
C
	IRUN=0
c
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
c
118	format(A4)
C	pause  ' '
C+	WRITE(*,'(\A\)') ' ENTER YEAR OF INPUT FILE='
C+      READ(*,'(A)') AYEAR
C+	read(ayear,*) year
        iyear=2023   !TEMPPPPPPPPPPPPPPPPPP
	call blet4(iyear,ayear)
	ayr=ayear(3:4)
	read(ayr,*) ryr 
      iyr=int(ryr)
	year=float(iyear)
		iiyr=int(year)
 	if(int(year/4.)*4.eq.iiyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
c
C+++++++++++++
	WRITE(*,'(\A\)') ' ENTER MN OF INPUT FILE='
      READ(*,*) IMN
	WRITE(*,'(\A\)') ' ENTER dy1, d2 OF INPUT FILE='
      READ(*,*) idy1,idy2
c outfiles =================================
C--	outfile='guYRMN_.txt'
	outfile='guYRMN_15.txt'
	outfile(2:2)=xy
c
      outfile(3:4)=ayr
C	outyear='gecYEARu_.txt'  !TEMPPPPPPPPP
	outyear='gecYRMNu15.txt'  !TEMPPPPPPPPP col-out
	outyear(8:8)=xy
      outyear(4:5)=ayr
CC CALCULATION OF DAY OF YEAR	(LDA)
C
        infile='d:\web\graf\dtu\YR\MN\ut\tcMNDDUTMM.uYR' ! UT=0, 1,...,23 
	infile(15:15)=xy
C--      infile(37:37)=ninp
	if (xy.eq.'r') infile(15:15)='a' 
	infile(17:18)=AYR
	infile(38:39)=AYR
C
	txt(1:9)='YYMMDD|UT'
c	do k=0,95
c	irok(k)=0
c	enddo
	ihrs=0
	do k=0,95,4
	iroc(k)=ihrs
	ihrs=ihrs+1
	enddo
  276 format(A9,95(I2,3X),I2,2X,'Day')	

C Cycle on month:
C
c        imn1=1
c	imn2=12
c	if (iyear.eq.2022) then 
c	imn1=7  !TEMPPPPPPPPPPPPP
c	imn2=7  !TEMPPPPPPPPPPPPP
c	endif
c	if (iyear.eq.2023) then 
c	imn1=1  !TEMPPPPPPPPPPPPP
c	imn2=2  !TEMPPPPPPPPPPPPP
c	endif
C       DO 100 imn=imn1,imn2 ++++++IMN entered
	call blet2(imn,AMN)
C
      infile(20:21)=AMN
	infile(28:29)=AMN
	outfile(5:6)=amn
	outyear(6:7)=amn
C      		OPEN(12,FILE=OUTFILE,ACCESS='APPEND')
      		OPEN(12,FILE=OUTFILE)
ccc      write(*,276) txt,(iroc(k),k=0,95)
ccc	write(12,276) txt,(iroc(k),k=0,95)
C
      OPEN(14,FILE=OUTYEAR)
C Cycle day-to-day +++++++++++++++++++++++++++++
          DO 101 idy=idy1,idy2
	call blet2(idy,ADY)
	infile(30:31)=ADY
C
C
	do n=0,96
	rgec(n)=0.
	enddo
C
	lda=ndoy(iyr,imn,idy)
	daynr=float(lda)
C
C--------------------------------
C Start input for given UT:++++++++++++++++++++
C UT cycle
       ntt=0
       DO 775 iut=0,23
	 call blet2(iut,AUT)
	 infile(32:33)=AUT 
   27 format(6X,F3.1)
C
C 15-min cycle        
	DO 771 imm=0,45,15
	call blet2(imm, AMM)
	infile(34:35)=AMM 
	OPEN(11,FILE=INFILE,ACTION='READ')

c ***************************************************************
D start cycle on hr-to-hr input:
   80	GEC=0.
C
  	ilat=0
C start cycle on glatitudes:
	glati=-90.0
C
	DO 777 lat=1,71	   ! Start cycle on glati

	res(lat)=0.        ! GEC for each glat
	glati=glati+2.5
	 acoef=gecoef(lat)
C++++++++++++++++++
   1	READ (11,180,END=9,ERR=2) (itxx(i),i=1,73)
  180	format(73(1X,I4))
C Select values for Long=-179.5,-178.5,...0.5,,..,179.5...!!!!!!!!!!!!:
C
171	nlon=0
C
 	sum=0.
	glong=-185.0
C
	do 776 nlon=1,72     ! for long-cycle
	glong=glong+5.0 
C++++++++
C-	rtav(nlon)=(itxx0(nlon)+itxx0(nlon+1)+itxx(nlon)+itxx(nlon+1))/4.
C-  172    sum=sum+rtav(nlon)
  172    sum=sum+itxx(nlon)
C++			 
C
 776	continue ! long cycle
	res(lat)=sum*1.0E+15*acoef
 182	format(3A2,24(1X,I4))							
 121 	GEC=GEC+res(lat)
C
 777  continue  ! lati cycle
   9   close(11)
C --------------- 
C OUTPUT OF RESULTS
 176  FORMAT(1X,I2,2X,E12.6)
	rgec(ntt)=GEC/1.0E+32
	write(*,31) AYEAR,AMN,ADY,AUT,AMM,rgec(ntt)
      write(14,31) AYEAR,AMN,ADY,AUT,AMM,rgec(ntt)
       ntt=ntt+1
C	 
  771 continue   ! End calculation for given 15-min
  775 continue   ! End calculation for given UT   Continue to the next UT hr :
C
C Output of daily results
C
  207	continue
C
	sum=0.
	do i=0,95
	sum=sum+rgec(i)
	igec(i)=nint(rgec(i)*100.)
	enddo
	sum=sum/96.
	iaver=nint(sum*100.) 
	igec(96)=iaver
C
C      Add output of 4 title lines
	IF (idy.eq.1) THEN
	txt(1:3)='GEC'
	write(12,275) txt
	write(*,275) txt
  275 format(A3)
	WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,' Time = ',TT
	WRITE(12,*) 'PC Date: Year,Month,Day = ',DD,' Time = ',TT
      write(*,276) txt,(iroc(k),k=0,95)
	write(12,276) txt,(iroc(k),k=0,95)
	txt(1:50)='--------------------------------------------------'
	txt(51:100)='--------------------------------------------------'
	txt(101:131)='-------------------------------'
  274 format(A131)
	write(12,274) txt
	write(*,274) txt
	ENDIF
C
	write(*,177) ayr,amn,ady,(igec(i),i=0,96)  ! GEC
	write(12,177) ayr,amn,ady,(igec(i),i=0,96)
CCC	write(14,177) ayr,amn,ady,(igec(i),i=0,96)
C+++++++++++++++++++++++++++++++++++++++++++++++
 177  format(3A2,97(1X,I4))
  101  CONTINUE
 	close (unit=12)
  100  CONTINUE
C       
	close (unit=14)
  105  CONTINUE
C 
   31 FORMAT(1X,A4,4(1X,A2),1X,F6.2)
		goto 35	   ! end of calculations
C
    2 CONTINUE
      if (irun.eq.0) then
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 35
      endif

C_   33	if ((iidy.le.idy2).and.(idy1.lt.idy2)) goto 32
   35      write(*,*) infile,outfile
	write(*,*) irun
      pause ' ' 
      STOP
       END

C***********************************************************
