C............................................................Nov. 2015
C Include IRI-Plas GEC predictions
C 
C............................................................Jan 2014
C GEC 12=monthly smoothed for ith month:
C
C GEC12(i)=(SUM(i-6,i-5...i-1)+SUM(i+1,i+2,...i+6))/12
C
C
      program cntgec12cm
C
	dimension datc(0:13)
C	+,dat(0:13)
      character*2 ayr(0:13),amn(0:13)
	character*45 infile,outfile
	integer*2 jj
c 5801 4.33
   72	format(1X,2A2,1X,F4.2)
	outfile='gec12tcm.txt'
	infile='gecjtmnc2.txt'
	OPEN(111,FILE=INFILE)
	OPEN(110,FILE=outfile,access='APPEND')
C cycle on yr
	nn=0
	jj=0
C	jj=1,180
   1	read(111,72,end=81) ayr(13),amn(13),datc(13)
	nn=nn+1
	jj=jj+1
C	if (jj.gt.199) goto 81 ! end of data = Feb 2015
	if (jj.gt.732) goto 81 ! start: Jan 1958, end of data = Dec 2018
C Shift data one line up
	do k=0,12
	ayr(k)=ayr(k+1)
	amn(k)=amn(k+1)
c	dat(k)=dat(k+1)
	datc(k)=datc(k+1)
	enddo
c
	if (nn.lt.13) then 
	goto 1
	               else
	nn=nn-1
c	gec12=0.
	gec12c=0.
	do k=0,5
c	gec12=gec12+dat(k)
	gec12c=gec12c+datc(k)
	enddo
	do k=7,12
c	gec12=gec12+dat(k)
	gec12c=gec12c+datc(k)
	enddo
c	gecav=gec12/12.
	gecavc=gec12c/12.
	write(*,72) ayr(6),amn(6),gecavc
	write(110,72) ayr(6),amn(6),gecavc
	goto 1
	                endif
   80	continue
   81	close(unit=110)
	close(unit=111)
	goto 33
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34

   33	continue
	write(*,*) infile,outfile
   34   pause ' ' 
      STOP
       END

c VERIFICATION OF MEDIAN ================
      subroutine rmedian(ndnr)
C Input file: CC(31,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(31,0:23),ME(0:23),X1(31),X2(31)
		COMMON /BL1/CC,ME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
	IF ((XD1-CD1).LT.0.0001) THEN 
	MD=INT((X2(ND1)+X2(ND2))/2.)
	ELSE
	MD=INT(X2(ND2))
	ENDIF
 1000 IF (MM.eq.0) MD=0
C1010 REM PRINT M;MD;
 1020 ME(M)=MD
 1030 CONTINUE
c 1040 REM PRINT
 1050 RETURN
      END