C............................................................Feb 2017
C new set of GEC12o coefficients to gec_rz.dat file
C............................................................Mar. 2015
C
C GECo 12=monthly smoothed for ith month for 1999.03-2017.01:
C
C GECproxy=0.97236*R12+0.18837 (for 1957.12:1999.02; 2016-2020.01)
C GECproxy=1.7+57.5362*(GEC12-0.83) for 1999.03-2015.12
C
C
      program cntgecrz12b
C
	dimension gec12(12),r12(12)
      character*4 ayear,byear
	character*72 infile1,infile2,outfile1,outfile2
	character*1 cc
	character*2 AYR,BYR,BMN
      CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
c	integer*2 jyr
      CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
c
   71	format(1X,A4,1X,12(1X,F5.1))
   72	format(1X,2A2,1X,F4.2)
   73	format(1X,A4,2X,12(F5.1,A1))
	cc=','
	outfile1='gec_rz12.txt'
	outfile2='gec12_rz.txt'
C-	infile='r12.dat'
	infile1='gec12os.txt'
	infile2='R12.dat'

	OPEN(11,FILE=INFILE1)	! gec12
	OPEN(12,FILE=INFILE2)  ! for R12
   19	read(12,71) BYEAR,r12 ! extra lines
      if (BYEAR.ne.'1953') goto 19

	OPEN(10,FILE=outfile1,access='APPEND')
	OPEN(13,FILE=outfile2,access='APPEND')
      WRITE(10,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
      WRITE(13,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C cycle on yr
	ig=0
	DO 80 iyyyy=1954,2019
	if(iyyyy.lt.2000) then
	AYEAR(1:2)='19'
	else
	AYEAR(1:2)='20'
	endif
	 jyr=iyyyy-(iyyyy/100)*100
	call blet2(jyr,AYR)
	AYEAR(3:4)=AYR
	nn=0
	jj=0
C
   1	read(12,71,end=81) byear,r12
C
	if (byear.eq.ayear) then  !<<<<<<<<<<<<<<<<<<
C
      imnend=12
Crem	if (iyyyy.eq.2017) imnend=1
 	do imn=1,imnend
	if ((iyyyy.ge.1999).and.(iyyyy.lt.2018)) then  !+++++++include 2017 mn=1
	read(11,72,end=70) byr,bmn,gec
C	    if ((kyr.eq.jyr).and.(kmn.eq.imn)) then
	         if (gec.eq.0.) then
Cold	gec12(imn)=0.97236*r12(imn)+0.18837
      gec12(imn)=0.9703*r12(imn)+1.4447
	         else
Cold	gec12(imn)=1.7+57.5362*(gec-0.83)
	gec12(imn)=57.5362*gec-46.0550
	         endif
C	    endif
	                      else !++++++++++++
Cold	gec12(imn)=0.97236*r12(imn)+0.18837
      gec12(imn)=0.9703*r12(imn)+1.4447
	                     endif !+++++++++++
	enddo

  70	continue
C GECproxy= (GEC12-0.83)*57.5362+1.7
C//       do imn=1,12
C//	call blet2(imn,BMN)
C//	write(*,74) ayr,bmn,gec12(imn)
C//	write(13,74) ayr,bmn,gec12(imn)
C//	write(*,74) ayr,bmn,r12(imn)
C//	write(10,74) ayr,bmn,r12(imn)
C//	enddo
Crem	write(*,73) ayear,(gec12(k),cc,k=1,12)
Crem      write(13,73)  ayear,(gec12(k),cc,k=1,12)
Crem	write(*,73) ayear,(r12(k),cc,k=1,12)
Crem      write(10,73)  ayear,(r12(k),cc,k=1,12)
	write(*,173) (gec12(k),cc,k=1,12)
      write(13,173) (gec12(k),cc,k=1,12)
 	write(*,173) (r12(k),cc,k=1,12)
      write(10,173) (r12(k),cc,k=1,12)

	endif                        ! <<<<<<<<<<<<<<<<<<<<<<<<<
   80	continue
   81	continue
	goto 33
  173	format(12(F5.1,A1))
   74	format(1X,2A2,1X,F6.1)
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 33

   33	continue
	close(unit=10)
	close(unit=11)
	close(unit=12)
	close(unit=13)
	write(*,*) infile1,infile2,outfile1,outfile2
   34   pause ' ' 
      STOP
       END

c VERIFICATION OF MEDIAN ================
      subroutine rmedian(ndnr)
C Input file: CC(31,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(31,0:23),ME(0:23),X1(31),X2(31)
		COMMON /BL1/CC,ME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
	IF ((XD1-CD1).LT.0.0001) THEN 
	MD=INT((X2(ND1)+X2(ND2))/2.)
	ELSE
	MD=INT(X2(ND2))
	ENDIF
 1000 IF (MM.eq.0) MD=0
C1010 REM PRINT M;MD;
 1020 ME(M)=MD
 1030 CONTINUE
c 1040 REM PRINT
 1050 RETURN
      END