C............................................................Nov. 2015
C
C............................................................Dec. 2014
C
C............................................................July 2014
C GEC 12=monthly smoothed for ith month vs R12-new:
C GEC12new=    0.01131 * R12new  +    0.8303
C GEC12cnew=(GEC12new-0.83)*90.
C
C
      program cntgecrz12c
C
	dimension r12(12),gec12(12),gecrz(12),gec12t(17,12)
      character*4 ayear,byear
	character*45 infile,outfile,infilegec
	character*1 cc
	character*2 AYR
	integer*2 jyr
c
   70	format(1X,I4,1X,F4.1)
   72	format(1X,A4,1X,12(1X,F5.1))
   73	format(1X,A4,2X,12(F5.1,A1))
	cc=','
	outfile='gecrz12c.txt'
	infile='r12.dat'
	infilegec='gec12t.txt'
	OPEN(111,FILE=INFILEGEC)
	OPEN(110,FILE=outfile,access='APPEND')
	OPEN(112,FILE=INFILE)
	do jj=1,17
	do kk=1,12
	read(111,70,end=23) iyrmn,gec12t(jj,kk)
	enddo
	enddo
   23	close(unit=111)
C cycle on yr
crem   	write(*,*) 'Enter AYEAR:'
crem	read(*,*) ayear
crem	read(ayear,*) ryear
crem   	iyyyy=int(ryear)
	iyyyy0=1999
	iyyyy1=2015
	 jyr=0
	iyyyy=1956
31	iyyyy=iyyyy+1
	call blet4(iyyyy,AYEAR)
	if (iyyyy.gt.2019) goto 33  !stop
	AYR=AYEAR(3:4)
	nn=0
	jj=0
C	jj=1,180
   1	read(112,72,end=81) byear,(r12(k),k=1,12)
	if (byear.eq.ayear) then
	if ((iyyyy.ge.iyyyy0).and.(iyyyy.le.iyyyy1)) then
	jyr=jyr+1
	endif
	do k=1,12
C	! old regression
	gecrz(k)=0.01131*r12(k)+0.8303 ! new regression
	if ((iyyyy.ge.iyyyy0).and.(iyyyy.le.iyyyy1)) then
	gecinp=gec12t(jyr,k)
	if (gecinp.gt.0.) gecrz(k)=gecinp
	endif 
Cold	gec12(k)=(gecrz(k)-1.0)*50.0
	gec12(k)=(gecrz(k)-0.83)*90.0
	enddo
	goto 11
	else
      goto 1 ! 
	endif

11	write(*,73) ayear,(gec12(k),cc,k=1,12)
	write(110,73)  ayear,(gec12(k),cc,k=1,12)
   80	continue
   81	continue
	goto 31
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 33

   33	continue
	close(unit=110)
	close(unit=111)
	write(*,*) infile,outfile
   34   pause ' ' 
      STOP
       END

c VERIFICATION OF MEDIAN ================
      subroutine rmedian(ndnr)
C Input file: CC(31,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(31,0:23),ME(0:23),X1(31),X2(31)
		COMMON /BL1/CC,ME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
	IF ((XD1-CD1).LT.0.0001) THEN 
	MD=INT((X2(ND1)+X2(ND2))/2.)
	ELSE
	MD=INT(X2(ND2))
	ENDIF
 1000 IF (MM.eq.0) MD=0
C1010 REM PRINT M;MD;
 1020 ME(M)=MD
 1030 CONTINUE
c 1040 REM PRINT
 1050 RETURN
      END