C............................................................July 2016
C new set of Rz12 coefficients from cov12.data file
C............................................................Mar. 2015
C Rzf12=33.52*sqrt(85.12+F12) - 408.99
C
C
      program cntrz12cov12
C
      character*4 byear
	character*72 infile,outfile
	character*1 cc
	character*2 BYR,BMN
c	integer*2 jyr
c
   71	format(1X,A4,A2,1X,F7.2)
   72	format(1X,2A2,1X,F4.2)
   73	format(1X,A4,2X,12(F5.1,A1))
	cc=','
	infile='cov12n.txt'
	outfile='rz12f12.txt'
C
	OPEN(11,FILE=INFILE)	! cov12

	OPEN(10,FILE=outfile,access='APPEND')
C cycle on yr
	ig=0
C?	DO 80 iyyyy=1947,2019
C	if(iyyyy.lt.2000) then
C	AYEAR(1:2)='19'
C	else
C	AYEAR(1:2)='20'
C	endif
C	 jyr=iyyyy-(iyyyy/100)*100
C	call blet2(jyr,AYR)
C	AYEAR(3:4)=AYR
C	nn=0
C	jj=0
C
   1	read(11,71,end=81) byear,bmn,cov12
C
      byr=byear(3:4)
C
	rzf12=33.52*sqrt(85.12+cov12)-408.99

	write(*,74) byr,bmn,rzf12
	write(10,74) byr,bmn,rzf12
C+	write(*,73) ayear,(gec12(k),cc,k=1,12)
C+      write(13,73)  ayear,(gec12(k),cc,k=1,12)
C+	write(*,73) ayear,(r12(k),cc,k=1,12)
C+      write(10,73)  ayear,(r12(k),cc,k=1,12)
	goto 1
   80	continue
   81	continue
	goto 33
   74	format(1X,2A2,1X,F6.1)
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 33

   33	continue
	close(unit=10)
	close(unit=11)
	write(*,*) infile,outfile
   34   pause ' ' 
      STOP
       END

c VERIFICATION OF MEDIAN ================
      subroutine rmedian(ndnr)
C Input file: CC(31,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(31,0:23),ME(0:23),X1(31),X2(31)
		COMMON /BL1/CC,ME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
	IF ((XD1-CD1).LT.0.0001) THEN 
	MD=INT((X2(ND1)+X2(ND2))/2.)
	ELSE
	MD=INT(X2(ND2))
	ENDIF
 1000 IF (MM.eq.0) MD=0
C1010 REM PRINT M;MD;
 1020 ME(M)=MD
 1030 CONTINUE
c 1040 REM PRINT
 1050 RETURN
      END