      program geccoef2i
C.............................................................Feb. 2023
C GEC coef for 1x1 map
C.............................................................Apr.2012
C Coef. for TECeff = mean TECeff for a sell
C
C ............................................................Feb.2012
C TECij = mean TEC for a cell
C dlat=2.5, lati={-88.75,88.75] step=2.5,
C dlon=5.0. long=[-177.5,177.5] step=5
C
	CHARACTER*15 FILNAM
C
C calculate coefficient for TECi due to Afraimovich et al., 
C weighted by Cv=7.52
c
C teta=glati, fi=glong, dteta=1.0deg, dfi=1.0deg.
	FILNAM='geccoef2i.txt'
	h=0.
	RE=6370.
	PI=ATAN(1.0)*4.
        UMR=PI/180.
C	dtetar=2.5*umr
	dtetar=1.0*umr
C	dfir=5.*umr
	dfir=1.0*umr
C	call subdist1(0.,0.,2.5,0.,h,dkm0) ! distance for dteta=2.5
	call subdist1(0.,0.,1.0,0.,h,dkm0) ! distance for dteta=1.0
C 
      OPEN(12,FILE=FILNAM,ACCESS='APPEND')
	glat1=-90.5
	DO i=1,180			 ! cycle along Latitudes
	glat2=glat1+1.0
	if (i.eq.1) then
	dkm1=0.
	goto 25
	endif
	call subdist1(glat1,0.,glat1,1.0,0.,dkm1)  ! distance for glat1
	if (i.eq.180) then
	dkm2=0.
	goto 26
	endif
   25	call subdist1(glat2,0.,glat2,1.0,0.,dkm2)	! distance for glat2
   26	del=(dkm1+dkm2)/2.
	scell=del*dkm0
cNOT	gcoef=scell*7.52
      gcoef=scell
	write(*,*) glat2,gcoef
	write(12,*) glat2,gcoef
	glat1=glat1+1.0
 	enddo
	close(unit=12)
	pause ' '
	stop

C	

	hstar=150.
	do i=1,10
      e1=(1.+exp(-hstar/300.))
	e2=(1.+exp(-(hstar/100.-30.)/3.))
	ro1=1./e1+1./e2
	ro=5-4*ro1
	write (*,*) hstar,ro
c	hstar=hstar+300.
	hstar=hstar+50.
	enddo
	stop
	end
