C...........................................................Jul. 2016
C R12 [1931-2019] SSN2, SSN1
C 
C IG12=   -0.0031*R12*R12 +  1.5332*R12  -11.5634
C............................................................Aug.2013
C IG12-fitted to Rzp (1850-2013) 12-monthly mean	
C............................................................Dec. 2012
C
      program ig12fitr12
C
	character*45 infile1,infile2,outfile,txt
	character*2 AMN
	dimension xig(12)
c
c-	infile='fitgec5713.txt'
	infile1='ssn12cor.txt'
	OPEN(110,FILE=infile1)
	read(110,78) txt ! extra line
C
	infile2='ig_rz.dat'
	OPEN(10,FILE=infile2)
	do i=1,5
	read(10,78) txt ! extra line
	enddo
C
	outfile='ig12fitr12.txt'
	OPEN(111,FILE=outfile)
   78	format(A45)
   79	format(I4,I2,2(1X,F6.1))
	jinp=0
   77	read(110,79,end=89) kyear,kmn,ssn2,ssn1
C	if ((kyear.ge.1958).and.(kyear.lt.2015)) then
	if (kyear.ge.1958) then
	 if (kmn.eq.1) then
	read(10,*) xig
	else
	  goto 177
	endif
      else
	r12=ssn1
	xig(kmn)=-0.0031*R12*R12+1.5332*R12-11.5634
	endif
 177	call blet2(kmn,AMN)
      write(*,99) kyear,amn,xig(kmn)
	write(111,99) kyear,amn,xig(kmn)
	goto 77
   89	close(unit=110)
      close(unit=10)
      close(unit=111)
C++  Cycle on mn-to-mn =========================
    1 continue
   99	format(I4,A2,1X,F6.1)
c	pause ' '
c  450 continue 

       GOTO 33
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34

   33	continue
      write(*,*) infile1,infile2,outfile
c//	goto 1
   34   pause ' ' 
      STOP
       END

c VERIFICATION OF MEDIAN ================
      subroutine rmedian(ndnr)
C Input file: CC(31,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(31,0:23),ME(0:23),X1(31),X2(31)
		COMMON /BL1/CC,ME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
	IF ((XD1-CD1).LT.0.0001) THEN 
	MD=INT((X2(ND1)+X2(ND2))/2.)
	ELSE
	MD=INT(X2(ND2))
	ENDIF
 1000 IF (MM.eq.0) MD=0
C1010 REM PRINT M;MD;
 1020 ME(M)=MD
 1030 CONTINUE
c 1040 REM PRINT
 1050 RETURN
      END