C............................................................Dec. 2012
C GEC simulation by IRI-Plas (CCIR) 1959-2012
C Add monthly mean
C
C
      program med2mngs
C
      DIMENSION XX(0:11)
	+,res(4)  ! 0+1, 3+4, 6+7, 9+10
	character*45 infile,outfile
	character*10 txt
	iyear=1959
C++  Cycle on yr-to-yr =========================
       infile='esavmon1.txt'
	outfile='esavmon2.txt'
	OPEN(110,FILE=outfile,access='APPEND')
      OPEN(111,FILE=INFILE)
   99	format(A10)
	read(111,99) txt ! title
	read(111,99) txt ! title
	read(111,99) txt ! title
	write(110,99) txt
  110 continue
   1	iyear=iyear+1
	if (iyear.gt.2012) goto 33 !???????????????????//
C   		
  100	READ (111,107,END=81,ERR=2) iyear,(xx(k),k=0,11)
  107	FORMAT(1X,I4,12(1X,F5.2))
	sum=0.
	do i=0,11
	sum=sum+xx(i)
	enddo
	sum=sum/12.
 	res(1)=(xx(0)+xx(1))/(2.*sum)
	res(2)=(xx(3)+xx(4))/(2.*sum)
	res(3)=(xx(6)+xx(7))/(2.*sum)
	res(4)=(xx(9)+xx(10))/(2.*sum)
	del1=res(1)-res(3)
	del2=res(2)-res(4)
   80	continue
	write(*,98) iyear,(res(k),k=1,4),sum,del1,del2 
      write(110,98) iyear,(res(k),k=1,4),sum,del1,del2  ! Output median+++++++++++++++++++++
	GOTO 110
   81	close(unit=111)
  98  format(1X,I4,7(1X,F7.2))
       GOTO 33
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34

   33	continue
	close(unit=110)
      write(*,*) infile,outfile
	goto 1
   34   pause ' ' 
      STOP
       END

c VERIFICATION OF MEDIAN ================
      subroutine rmedian(ndnr)
C Input file: CC(31,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(31,0:23),ME(0:23),X1(31),X2(31)
		COMMON /BL1/CC,ME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
	IF ((XD1-CD1).LT.0.0001) THEN 
	MD=INT((X2(ND1)+X2(ND2))/2.)
	ELSE
	MD=INT(X2(ND2))
	ENDIF
 1000 IF (MM.eq.0) MD=0
C1010 REM PRINT M;MD;
 1020 ME(M)=MD
 1030 CONTINUE
c 1040 REM PRINT
 1050 RETURN
      END