C............................................................Nov 2011
C
C       "MEDIAN" 
      program medmong
C
      DIMENSION YY(0:23),XX(31,0:23)
	+,im(12),med(0:23)
      character*2 ayr,amn,ady,byr,bmn,bdy
	character*45 infile,outfile
	COMMON /BL1/XX,MED
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
c
c-      write(*,*) 'ENTER STATION CODE ST$:'
c-	 read(*,*) ST
       write(*,*) 'ENTER YR:'
	 read(*,*) AYR
       write(*,*) 'ENTER MN:'
	 read(*,*) AMN
		read(ayr,*) yr
		read(amn,*) rmn
	mn=int(rmn)
C CALCULATION OF DAY OF YEAR	(LDA)
 	iyr=int(yr)
	if(int(yr/4.)*4.eq.iyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
	ndnr=im(mn)
C
       infile='gechyr.br'
	infile(5:6)=ayr
	outfile=infile
	outfile(10:10)='m'
	OPEN(110,FILE=outfile,access='APPEND')
  110 continue
      NDY=0 
	L=0 
	LC=0 
	FL=0
      DO K=0,23
      MED(K)=0
	enddo

      OPEN(111,FILE=INFILE)
		nn=0
    	do 80 ii=1,ndnr					             !!
  100	READ (111,107,END=81,ERR=2) byr,bmn,bdy,(yy(k),k=0,23)
  107	FORMAT(3A2,24(1X,F4.0))
		if (bmn.eq.amn) then  !<<<<<<<
 	nn=nn+1
	do i=0,23
	xx(nn,i)=yy(i)
	enddo
	goto 80
	          else
	goto 100
	endif
   80	continue
   81	close(unit=111)
	call rmedian(ndnr)
	ady='15'
c  450  write(110,98) ayr,amn,ady,(med(k),k=0,23)
      write(110,96) ayr,amn,ady
	do k=0,23
      write(110,97) med(k)
	enddo
	write(*,98) ayr,amn,ady,(med(k),k=0,23)
  98  format(3A2,24(1X,I4))
  97  format(1X,I4)
  96  format(3A2)
       GOTO 33
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34

   33	continue
	close(unit=110)
      write(*,*) infile,outfile
      pause ' ' 
   34   STOP
       END

c VERIFICATION OF MEDIAN ================
      subroutine rmedian(ndnr)
C Input file: CC(31,0:23) for 31 days, hours 00, 01, 23 h UY
C Number days for median : ndnr
C Outout file: ME(0:23) for hours 00, 01, 23 h UY
	DIMENSION CC(31,0:23),ME(0:23),X1(31),X2(31)
		COMMON /BL1/CC,ME
C "MEDIAN:"
       DO 1030 M=0,23
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 ND1=INT(MM/2.) 
      ND2=ND1+1 
	IF (ND1.eq.MM/2) THEN 
	MD=INT((X2(ND1)+X2(ND2))/2.)
	ENDIF
  990 IF (ND1.lt.MM/2) THEN 
      MD=X2(ND2)
	ENDIF
 1000 IF (MM.eq.0) MD=0
C1010 REM PRINT M;MD;
 1020 ME(M)=MD
 1030 CONTINUE
c 1040 REM PRINT
 1050 RETURN
      END