      program mosfhour1
C..............................................................Apr.2018++
C
C..............................................................Mar. 2017
C correct production of Moscow f-plot,w-index plot
C
	dimension ixx(0:23),fmos(0:5,0:23),fmed(0:5,0:23),ipar(5,48)
     +,ff2(3,48),IM(12),iwdat(48),fdat(5,0:23),f96(0:96) !fdat for 96 prec hours + forecast for 24 hrs
     +,iff(0:23)  ! ++
	character*128 infilef,infilmed,parres,infdate,txt,inftime,infilad      !  Liuba ++
      character*41 put    !!! Liuba
	character*19 med    !!! Liuba
	character*19 fadd    !!! Liuba++

	character*4 AYEAR,BYEAR,TTT
	character*2 AYR,BYR,AMN,BMN,ADY,BDY,CYR,CMN,CDY,UT_TIME      !Tamara
	character*3 ALDA,BLDA
 		CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/    !

	CALL DATE_AND_TIME(DD,TT,ZZ)
      TTT(1:4)=TT(1:4)
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TTT
C
      CALL HARMONIC										  !
C
	do k=1,48
      do i=1,5
	ipar(i,k)=0
	enddo
	do i=1,3
	ff2(i,k)=0.
	enddo
	iwdat(k)=0
	enddo

      put='/var/www/izmiran/ionosphere/weather/graf/' ! 41  
C	
C	infilef='d:\web\graf\2017\moYRf.br'
	infilef='/var/www/izmiran/ionosphere/weather/graf/2017/moYRf.br'  !!! Liuba
C	infilmed='d:\web\graf\dat2\17\moYRMNm.txt'
      med='dat2/17/moYRMNm.txt'                          !!! Liuba
	infilmed=put//med	                               !!! Liuba
C++	
    	 fadd='dat1/19/moYRMN.txt'                         !!! Liuba ++
	infilad=put//fadd	                               !!! Liuba ++
C	infdate='d:\web\graf\date'
      infdate='/var/www/izmiran/ionosphere/weather/graf/date'     !!! Liuba 
      inftime='/var/www/izmiran/ionosphere/weather/graf/time'     !!! Liuba 

C	parres='d:\web\graf\f\Par_gr'
      parres='/var/www/izmiran/ionosphere/weather/graf/f/mo_gr'   !!! Liuba !!!! 
C
	OPEN(10,file=infdate,action='READ')
   21	format(A4,2(1X,A2),1X,A4,2(1X,A2),2(1X,A3))
   22	format(A128)
	read(10,21) AYEAR,AMN,ADY,BYEAR,BMN,BDY,ALDA,BLDA
	close(unit=10)
C
	BYR=BYEAR(3:4)               !Tamara
	read(BYR,*) ryr0			 !Tamara
	iyr_pre=int(ryr0)			 !Tamara
	read(BMN,*) rmn0			 !Tamara
	imn_pre=int(rmn0)			 !Tamara
	read(BDY,*) rdy0			 !Tamara
	idy_pre=int(rdy0)			 !Tamara

	AYR=AYEAR(3:4)
	read(AYR,*) ryr
	kyr=int(ryr)
C	infilef(13:16)=AYEAR		 !Tamara
C	infilef(20:21)=AYR			 !Tamara

	infilef(42:45)=AYEAR      !!! Liuba
	infilef(49:50)=AYR        !!! Liuba

C	infilmed(18:19)=AYR			 !Tamara
C	infilmed(23:24)=AYR			 !Tamara

	infilmed(47:48)=AYR       !!! Liuba   
	infilmed(52:53)=AYR       !!! Liuba 54:55 MN   

	infilad(47:48)=AYR        !!! Liuba   ++
	infilad(52:53)=AYR        !!! Liuba	 ++ 54:55 MN  

C
	read(AMN,*) rmn
	kmn=int(rmn)
	read(ADY,*) rdy
	kdy=int(rdy)
C
		z1=kyr/4.0						  !
      jz1=int(z1)*4                     ! 
      IF(jz1.EQ.kyr) THEN				  !
               IM(2)=29				  !
      yds=366.
	  ELSE							  !
                IM(2)=28				  !
	yds=365.
	       ENDIF					  !
C
	kdy_pre=kdy-1
	kmn_pre=kmn
	kyr_pre=kyr
	if (kdy_pre.eq.0) then
	kmn_pre=kmn-1
	if (kmn_pre.eq.0) then
	kyr_pre=kyr-1
	kmn_pre=12
	endif
	kdy_pre=im(kmn_pre)
	endif
C=======================================
C check preceding last UT month and day:
	OPEN(10,file=parres,action='READ')
	do k=1,24
	read(10,*) nn,nyr,nmn,ndy,nut
	enddo
	close(unit=10)
C	if ((nyr.eq.kyr_pre).and.(nmn.eq.kmn_pre).and.(ndy.eq.kdy_pre)
C     +.and.(nut.lt.23)) then
	call submos(BYEAR,BMN,BDY,BLDA)  ! read data for prec. day
C	endif
C========================================
        call submos(AYEAR,AMN,ADY,ALDA)
C
C     write(*,*) 'Enter UT-start:'
C	read(*,*) kuthr

	OPEN(19,file=inftime,action='READ')
   99	format(I2,1X,A2)
	read(19,99) kuthr,UT_TIME
	close(unit=19)

	   write(*,*) 'kuthr:',kuthr
	   write(*,*) 'UT_TIME:',UT_TIME

	iut=kuthr
	idy=kdy_pre
	imn=kmn_pre
	iyr=kyr_pre               !Tamara
C
C
   56	DO 55 nn=1,48  !+++++++
	ipar(1,nn)=nn
	ipar(2,nn)=iyr
	ipar(3,nn)=imn
	ipar(4,nn)=idy
	if((idy.eq.1).and.(nn.le.24)) then	  !Tamara
	ipar(2,nn)=iyr_pre					  !Tamara
	ipar(3,nn)=imn_pre					  !Tamara
	ipar(4,nn)=idy_pre					  !Tamara
	endif								  !Tamara
	ipar(5,nn)=iut
	iut=iut+1
	     if (iut.le.23) then
			goto 55
	           else
	iut=0
	idy=idy+1
	if (idy.gt.im(imn)) then
	idy=1
	imn=imn+1
	endif
	endif
   55	CONTINUE
C/	ipar(5,48)=ipar(5,47)+1
C
	idy_4=kdy_pre-3
	imn_4=kmn_pre
	if (idy_4.le.0) then
	imn_4=imn_4-1
	idy_4=im(imn_4)+idy_4
	endif

	kutend=kuthr-1
	kdyend=kdy
	jdy=idy_4
	jmn=imn_4
C
   23	format(3A2,1X,24(1X,I3,1X))									
      OPEN(12,file=infilef,action='READ')
C
C
C read foF2
C
   61	read(12,23,end=62) CYR,CMN,CDY,(ixx(k),k=0,23)
      do k=0,23
      fmos(5,k)=float(ixx(k))/10.
	enddo
C Move data 1 line up
	do k1=1,5
	do k2=0,23
	fmos(k1-1,k2)= fmos(k1,k2)
	enddo
	enddo
	if ((cyr.eq.ayr).and.(cmn.eq.amn).and.(cdy.eq.ady)) then 
	goto 62
	             else
	goto 61
	endif
   62	close(unit=12)
C
C      infilmed(25:26)=AMN     !!!!!!!!!!!!!!!!TAMARA
       infilmed(54:55)=AMN     	                                  !!! Liuba   
	infilad(54:55)=AMN     	                                      !!! Liuba ++   

	if (imn.ne.imn_pre) then               !Tamara
C     infilmed(25:26)=BMN					   !Tamara
      infilmed(54:55)=BMN					                          !!! Liuba/      infilad ?
      infilad(54:55)=BMN
	endif								   !Tamara
C++
      OPEN(14,file=infilad,action='READ') !++
	do i=1,4							!++
	read(14,22) txt !extra line			!++
	enddo								!++
   
      write(*,*) 'mosfhour1.for 2) infilmed = ', infilmed 

      OPEN(13,file=infilmed,action='READ')
	do i=1,4
	read(13,22) txt !extra line  
	enddo
C
C Read Median +foF2 <infilad>
C 
   63 read(13,23,end=64) CYR,CMN,CDY,(ixx(k),k=0,23)
      read(14,23,end=64) CYR,CMN,CDY,(iff(k),k=0,23) !++
      do k=0,23
      fmed(5,k)=float(ixx(k))/10.
	if (fmos(5,k).eq.0.) fmos(5,k)=float(iff(k))/10. !++
	enddo

C Move data 1 line up
	do k1=1,5
	do k2=0,23
	fmed(k1-1,k2)= fmed(k1,k2)
	fmos(k1-1,k2)= fmos(k1,k2) !++
	enddo
	enddo
	if ((cyr.eq.ayr).and.(cmn.eq.amn).and.(cdy.eq.ady)) then 
	goto 64
	             else
	goto 63
	endif
C
   64	close(unit=13)
	 ncnt=0
      DO jj=1,5	   !>>>>>>>>>>>>>>>>>
C
	if (jj.eq.1) then
	DO jut=kuthr,23
	f96(ncnt)=fmos(0,jut)
	if (f96(ncnt).eq.0.0) f96(ncnt)=fmed(4,jut)        !Tamara
	ff2(3,ncnt+1)=fmed(4,jut)
	ncnt=ncnt+1
	ENDDO
	endif
	if (jj.eq.2) then
	DO jut=0,23
	f96(ncnt)=fmos(1,jut)
C	if (ncnt.lt.49) ff2(3,ncnt)=fmed(4,jut)
      if (f96(ncnt).eq.0.0) f96(ncnt)=fmed(4,jut)        !Tamara
	if (jut.lt.kuthr) ff2(3,ncnt+1)=fmed(4,jut)
	ncnt=ncnt+1
	ENDDO
	endif
	if (jj.eq.3) then
	DO jut=0,23
	f96(ncnt)=fmos(2,jut)
	if (f96(ncnt).eq.0.0) f96(ncnt)=fmed(4,jut)        !Tamara
	ncnt=ncnt+1
	ENDDO
	endif
		if (jj.eq.4) then
 	DO jut=0,23
	f96(ncnt)=fmos(3,jut)
	if (f96(ncnt).eq.0.0) f96(ncnt)=fmed(4,jut)        !Tamara
	ncnt=ncnt+1
	ENDDO
	endif
		if (jj.eq.5) then
 	DO jut=0,kuthr
	f96(ncnt)=fmos(4,jut)
	if (f96(ncnt).eq.0.0) f96(ncnt)=fmed(4,jut)        !Tamara
	ncnt=ncnt+1
	ENDDO
	endif
	ENDDO			!>>>>>>>>>>>>>>>>>>>>>
      do jj=1,24
	ff2(3,jj+24)=ff2(3,jj) ! med for next 24 hrs
	enddo
C
	nn=0
	DO jj=1,4
		do kk=0,23
	fdat(jj,kk)=f96(nn)
	nn=nn+1
	enddo
	ENDDO
	DO kk=0,23
	fdat(5,kk)=0.
	enddo
	CALL subfur4a(fdat)
C
	 DO mm=1,24
	ff2(3,mm+24)=ff2(3,mm) ! median
C	ff2(1,mm)=fdat(4,mm-1)  ! current foF2       !Tamara
	ndy=ipar(4,mm)								 !Tamara
	nut=ipar(5,mm)								 !Tamara
	if (ndy.eq.kdy_pre) then					 !Tamara
	ff2(1,mm)=fmos(3,nut)						 !Tamara
	else										 !Tamara
	ff2(1,mm)=fmos(4,nut)						 !Tamara
	endif										 !Tamara
	ff2(2,mm)=-2.  			 ! no forecast
	ff2(2,mm+24)=fdat(5,mm-1)	 ! forecast foF2
	ff2(1,mm+24)=-2.		  ! no data
	if (fdat(4,mm-1).eq.ff2(3,mm)) then       !Tamara
	iw=0						              !Tamara
	goto 27				            		 !Tamara
	endif						             !Tamara
	 xpar=fdat(4,mm-1)**2
	xmed=ff2(3,mm)**2
	if (xpar.eq.0.) then
	iw=0
	goto 27
	endif
	call windex1(xpar,xmed,iw)
   27   iwdat(mm)=iw
	 xpar1=fdat(5,mm-1)**2
	call windex1(xpar1,xmed,iw)
	iwdat(mm+24)=iw
	ENDDO
C
C   Output results
C
  24	format(1X,I2,4(1X,I3),3(1X,F5.1),3X,I2)
	ipar(5,48)=ipar(5,47)+1
		OPEN(11,file=parres)  ! outfile

	DO ii=1,48
	if (ff2(1,ii).eq.0.0) ff2(1,ii)=-1.0  ! Tamara
	write(*,24) (ipar(k,ii),k=1,5),(ff2(k,ii),k=1,3),iwdat(ii)
	write(11,24) (ipar(k,ii),k=1,5),(ff2(k,ii),k=1,3),iwdat(ii)
	ENDDO
	close(unit=11)
C
C      pause ' '  !! Liuba
	STOP
	END
C -----------------------------------------------------------
 